<?php
namespace Geral\Entities;

/**
 * @method \Geral\Repositories\Itemproduto getRepository static
 * @method array findByCdfilialAndNrlanctonfAndNrorg($cdfilial, $nrlanctonf, $nrorg) static
 * @method \Geral\Entities\Itemproduto getObjectByWhere static
 */
class Itemproduto extends Base\Itemproduto
{

    /**
     * IDATUVRESTOQ: Atualiza valor de estoque.
     */
    const ATUALIZA_VALOR_ESTOQUE = "S";
    /**
     * IDATUVRESTOQ: Nao atualiza valor de estoque.
     */
    const NAO_ATUALIZA_VALOR_ESTOQUE = "N";

    /**
     * IDCONFORITEM: Identificador de item com conformidade.
     */
    const ITEM_COM_CONFORMIDADE  = "S";
    /**
     * IDCONFORITEM: Identificador de item sem conformidade.
     */
    const ITEM_SEM_CONFORMIDADE = "N";

    /** @var \Geral\Entities\Prodfili */
    protected  $prodfili;

    /**
     * @return \Geral\Entities\Prodfili
     */
    public function getProdfili() {
        if ($this->prodfili === null) {
            $id = array(
                "cdfilial" => $this->cdfilial,
                "cdproduto" => $this->cdproduto,
                "nrorg" => $this->nrorg,
            );
            $this->prodfili = \Geral\Entities\Prodfili::getObject($id);
        }

        return $this->prodfili;
    }

}