#!/bin/sh

VERSION=$1
REVISION=$2
BUILD=$3

echo 'Backend Step -------------------------------------------------------------'
rm vendor -Rf
[ -f composer.lock ] && rm -f composer.lock
composer clearcache

{ # try !
    composer install --no-dev --optimize-autoloader
} || { # catch!
    echo 'Composer Error -------------------------------------------------------'
    exit 1
}

echo 'Fix composer dependencies version ---------------------------------------------------------------------'
cd vendor/teknisa/entities
if [ $VERSION = "CURRENT" ]; then
    echo 'VERSION = CURRENT'
    git pull origin master
else
    echo 'VERSION =' $VERSION.$REVISION.$BUILD
    git fetch --tags
    git checkout PROD_1198_$VERSION.$REVISION.$BUILD
fi
