const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const motivoCancPage = require('../../../page-objects/parametrizacao/financeiro/motivoCancelamento.po.js');

const motivoCancGridId = '96151419535215748553710';

describe('Tela Motivo de Cancelamento', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		motivoCancPage.abrir();
		geral.clickAplicarFiltro();
		protractorHelper.waitForElementVisibility(
			element(by.id(`grid-${motivoCancGridId}`)), 5000);
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar tela Motivo de Cancelamento', () => {
		expect(z.component.header.getTitle()).toBe('Motivo de Cancelamento');
	});

	it('Adicionar uma motivo de cancelamento', () => {
		geral.clickAdicionar();
		motivoCancPage.adicionar(j.getValor('codigoMotivoCanc'), j.getValor('descricaoMotivoCanc'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('codigoMotivoCanc'));

		expect(geral.gridHasText(motivoCancGridId, j.getValor('descricaoMotivoCanc'), 1))
			.toBe(j.getValor('descricaoMotivoCanc'));
		expect(geral.gridHasText(motivoCancGridId, j.getValor('codigoMotivoCanc')))
			.toBe(j.getValor('codigoMotivoCanc'));
	});

	it('Editar registro', () => {
		geral.filterIt(j.getValor('codigoMotivoCanc'));
		geral.clickGrid('DSMOTICANC', j.getValor('descricaoMotivoCanc'), motivoCancGridId);
		geral.clickEditar();
		motivoCancPage.editar(j.getValor('descricaoMotivoCanc1'));
		geral.clickSalvar();
		geral.clickVoltar();
		geral.filterIt(j.getValor('codigoMotivoCanc'));

		expect(geral.gridHasText(motivoCancGridId, j.getValor('descricaoMotivoCanc1'), 1))
			.toBe(j.getValor('descricaoMotivoCanc1'));
		expect(geral.gridHasText(motivoCancGridId, j.getValor('codigoMotivoCanc')))
			.toBe(j.getValor('codigoMotivoCanc'));
	});

	it('Excluir registro', () => {
		geral.filterIt(j.getValor('codigoMotivoCanc'));
		geral.clickGrid('DSMOTICANC', j.getValor('descricaoMotivoCanc1'), motivoCancGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(motivoCancGridId, j.getValor('descricaoMotivoCanc1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(motivoCancGridId, j.getValor('codigoMotivoCanc')))
			.toBeUndefined();
	});
});
