<?php
namespace Folha\Logic\ControlePonto;

use Folha\Entities\FpaEventoh;
use Folha\Entities\GpeEscalatrabh;
use Folha\Entities\GpeAltesitufunc;
use Folha\Entities\GpeEscalatrabm;
use Folha\Entities\GpeHordiam;
use Folha\Entities\GpeIntervaloshorario;
use Folha\Entities\GpeMarcacaoponto;
use Folha\Entities\GpeParamorg;
use Folha\Entities\GpeSitufunch;
use Folha\Entities\GpeTurno;
use Folha\Entities\GpeVinculoh;
use Folha\Entities\GpeHorarioturno;
use Folha\Entities\PtoAltebancohoras;
use Folha\Entities\PtoAssocsitufreq;
use Folha\Entities\PtoBancohorasperiodo;
use Folha\Entities\PtoBancohorasprog;
use Folha\Entities\PtoCalculositufreq;
use Folha\Entities\PtoIntervalosmarcacao;
use Folha\Entities\PtoProgocorrencia;
use Folha\Entities\PtoResumositufreq;
use Folha\Entities\PtoSitufreqparam;
use Folha\Entities\PtoSitufrequencia;
use Folha\Entities\PtoTipoprogocorrencia;
use Folha\Logic\ControlePonto;
use Geral\Entities\Ocorcalendario;
use Geral\Entities\Tpcalendario;
use Setforms2\Shared\ORM\DateTime;
use Folha\Logic\ControlePonto\Dateutil;
use Folha\Logic\ControlePonto\FPA;

/**
 * Description of Dia
 *
 * @author ingridmoreira
 */
class Dia
{
    private $nrorg;
    private $nrvinculom;
    private $data;
    private $nrPeriodoApuracao;
    private $idDiaCalend;
    private $existeAtraso;
    private $situFuncional;
    private $idAfastamento;
    private $idFerias;
    private $situFreq;
    private $escala;
    private $escalaHistorico;
    private $turno;
    private $dentroPeriodo;
    private $horario;
    private $periodosIntervalos = array();
    private $programacoesOcorrencia = array();
    private $registros = array();
    private $registrosNDesprez = array();
    private $indexRegistros;
    private $intervalosControle = array();
    private $indexIntervalosControle;
    private $endOfIntervalosControle;
    private $intervalosRegistros = array();
    private $indexIntervalosRegistros;
    private $endOfIntervalosRegistros;
    private $primeiraMarcacao;
    private $ultimaMarcacao;
    private $calcSituFreq;
    private $resumosSituFreqs;
    private $extrasNoDia;
    private $idHorasTrabTot;
    private $idFolgaAutorizadas = array();
    private $idHorasCompensarTot;
    private $idHorasFaltasTot;
    private $idHorasAtrSaiTot;
    private $idHorasAtrasosTot;
    private $idHorasSaidasTot;
    private $idHorasNotAdic;
    private $idHorasExtAdic;
    private $idHorasPextAdic;
    private $idTrabDia;
    private $idTrabNot;
    private $idTrabNComp;
    private $iniPerApur;

    // Contém a quantidade de separação entre as Horas Extras I e II referente a Alteescala ou Escalatrabh
    private $qtLimiteSeparacaoHoraExtra;

    private $idAdicHexDia;
    private $idAdicHexDia2;
    private $idAdicHexNot;
    private $idAdicHexNot2;
    private $idAdicHexNComp;

    /* situacoes usadas para o dia corrente */
    private $idExtraDia;
    private $idExtraDia2;
    private $idExtraNot;
    private $idExtraNot2;
    private $idExtraNComp;
    private $idTipoExtra;  /* indexa vars de extra e comensacao */
    private $idJornComplementar;

    /* situacoes usadas para o dia seguinte no caso de virada de noite */
    private $idPextraDia;
    private $idPextraDia2;
    private $idPextraNot;
    private $idPextraNot2;
    private $idPextraNComp;
    private $idTipoPextra; /* indexa vars de extra e comensacao */
    private $idPjornComplementar;

    //Id Intervalos de Marcações
    const ATRASO       = 'A';
    const EXTRA        = 'E';
    const IGNORADO     = 'I';
    const SAIDA_INT    = 'S';
    const TRABALHO     = 'T';
    const IDENTIFICADO = 'D';

    //Id's Ocorrências
    const HORAS_FOLGAR            = 'HORAS_FOLGAR';
    const SAIDA_ATRASO_AUT        = 'SAIDA_ATRASO_AUT';
    const SAIDA_ATRASO_INTRA_AUT  = 'SAIDA_ATRASO_INTRA_AUT';
    const AUSENCIA_EXTRAJORNADA   = 'AUSENCIA_EXTRAJORNADA';
    const FALTA_ABONADA           = 'FALTA_ABONADA';
    const SITUACAO_PROGRAMADA     = 'SITUACAO_PROGRAMADA';
    const QUITA_SALDO_OU_DEB      = 'QUITA_SALDO_OU_DEB';
    const QUITA_CRED_ACUMULADO    = 'QUITA_CRED_ACUMULADO';
    const QUITA_DEBITO            = 'QUITA_DEBITO';
    const AUSENC_COMP_SE_CRED     = 'AUSENC_COMP_SE_CRED';
    const QUEBRA_HRFOLGA_HRAUT    = 'QUEBRA_HRFOLGA_HRAUT';
    const HORAS_FOLGAR_ACRESC     = 'HORAS_FOLGAR_ACRESC';
    const DSR_ABONADO             = 'DSR_ABONADO';
    const SOBREPOE_CALENDARIO     = 'SOBREPOE_CALENDARIO';
    const SIMPLES_REGISTRO        = 'SIMPLES_REGISTRO';
    const ATRASO_AUTORIZADO       = 'ATRASO_AUTORIZADO';
    const SAIDA_AUTORIZADA        = 'SAIDA_AUTORIZADA';
    const ATRASO_INTRA_AUTORIZADO = 'ATRASO_INTRA_AUTORIZADO';
    const SAIDA_INTRA_AUTORIZADA  = 'SAIDA_INTRA_AUTORIZADA';
    const ATRASO_COMP_SE_CRED     = 'ATRASO_COMP_SE_CRED';
    const SAIDA_COMP_SE_CRED      = 'SAIDA_COMP_SE_CRED';
    const HR_EXTRA_AUTORIZADA     = 'HR_EXTRA_AUTORIZADA';
    const AUSENCIA_COMPENSAR      = 'AUSENCIA_COMPENSAR';
    const IDENTIFICA_INTERVALO    = 'IDENTIFICA_INTERVALO';
    const IDENTIFICA_INTERVALO_NP = 'IDENTIFICA_INTERVALO_NP';
    const COMPLEMENTA_TRABALHO    = 'COMPLEMENTA_TRABALHO';

    //Cálculos Situações Frequência
    //Adicionais
    // --Feriado
    const AD_EX_DIA_FERIAD_1AS = 'AD_EX_DIA_FERIAD_1AS';
    const AD_EX_DIA_FERIAD_SEG = 'AD_EX_DIA_FERIAD_SEG';
    const AD_EX_NOT_FERIAD_1AS = 'AD_EX_NOT_FERIAD_1AS';
    const AD_EX_NOT_FERIAD_SEG = 'AD_EX_NOT_FERIAD_SEG';
    const AD_EX_NOT_FERIAD_CP  = 'AD_EX_NOT_FERIAD_CP';

    // --Folga
    const AD_EX_DIA_FOLGA_1AS  = 'AD_EX_DIA_FOLGA_1AS';
    const AD_EX_DIA_FOLGA_SEG  = 'AD_EX_DIA_FOLGA_SEG';
    const AD_EX_NOT_FOLGA_1AS  = 'AD_EX_NOT_FOLGA_1AS';
    const AD_EX_NOT_FOLGA_SEG  = 'AD_EX_NOT_FOLGA_SEG';
    const AD_EX_NOT_FOLGA_CP   = 'AD_EX_NOT_FOLGA_CP';

    // --Sábado
    const AD_EX_DIA_SABADO_1AS = 'AD_EX_DIA_SABADO_1AS';
    const AD_EX_DIA_SABADO_SEG = 'AD_EX_DIA_SABADO_SEG';
    const AD_EX_NOT_SABADO_1AS = 'AD_EX_NOT_SABADO_1AS';
    const AD_EX_NOT_SABADO_SEG = 'AD_EX_NOT_SABADO_SEG';
    const AD_EX_NOT_SABADO_CP  = 'AD_EX_NOT_SABADO_CP';

    // --Normais
    const AD_EX_DIA_NORMAL_1AS = 'AD_EX_DIA_NORMAL_1AS';
    const AD_EX_DIA_NORMAL_SEG = 'AD_EX_DIA_NORMAL_SEG';
    const AD_EX_NOT_NORMAL_1AS = 'AD_EX_NOT_NORMAL_1AS';
    const AD_EX_NOT_NORMAL_SEG = 'AD_EX_NOT_NORMAL_SEG';
    const AD_EX_NOT_NORMAL_CP  = 'AD_EX_NOT_NORMAL_CP';

    // --Noturno
    const ADICIONAL_NOTURNO    = 'ADICIONAL_NOTURNO';

    //Atrasos
    const ATRASOS_DIURNOS      = 'ATRASOS_DIURNOS';
    const ATRASOS_NOTURNOS     = 'ATRASOS_NOTURNOS';
    const ATRASOS_TOLERAVEIS   = 'ATRASOS_TOLERAVEIS';

    const AUSENCIA_MARCACAO    = 'AUSENCIA_MARCACAO';
    const DEBITO_A_COMPENSAR   = 'DEBITO_A_COMPENSAR';
    const DEBITO_PENDENTE      = 'DEBITO_PENDENTE';
    const DIFER_JORN_MES       = 'DIFER_JORN_MES';
    const DOMINGO_TRABALHADO   = 'DOMINGO_TRABALHADO';
    const DSR_DESCONTADO       = 'DSR_DESCONTADO';
    const DSR_PAGO             = 'DSR_PAGO';

    //Faltas
    const FALTAS_DIURNAS       = 'FALTAS_DIURNAS';
    const FALTAS_NOTURNAS      = 'FALTAS_NOTURNAS';

    //Intervalo
    const INTERVALO_APURADO    = 'INTERVALO_APURADO';
    const INTERVALO_ORIGINAL   = 'INTERVALO_ORIGINAL';
    const NAO_MARCOU_INTERV    = 'NAO_MARCOU_INTERV';

    const FERIADO_INTEGRAL     = 'FERIADO_INTEGRAL';
    const FERIADO_MANHA        = 'FERIADO_MANHA';
    const FERIADO_TARDE        = 'FERIADO_TARDE';
    const FERIAS               = 'FERIAS';
    const FERI_MES_SEGUINTE    = 'FERI_MES_SEGUINTE';

    const H_EXCEDE_JORNADA     = 'H_EXCEDE_JORNADA';
    const HORAS_A_FOLGAR       = 'HORAS_A_FOLGAR';
    const HORAS_CONTRATADAS    = 'HORAS_CONTRATADAS';
    const INCORP_ADCN_DSR      = 'INCORP_ADCN_DSR';
    const INTERJORNADA         = 'INTERJORNADA';

    const PONTO_FACULTATIVO    = 'PONTO_FACULTATIVO';
    const SAIDAS_DIURNAS       = 'SAIDAS_DIURNAS';
    const SAIDAS_NOTURNAS      = 'SAIDAS_NOTURNAS';

    const SUPOSTAS_FALTAS      = 'SUPOSTAS_FALTAS';
    const TODAS_TENT_DESPREZ   = 'TODAS_TENT_DESPREZ';

    //Jornada
    const JORNADA_DIARIA       = 'JORNADA_DIARIA';
    const JORNADA_DIARIA_HOR   = 'JORNADA_DIARIA_HOR';
    const JORNADA_MES_PREV     = 'JORNADA_MES_PREV';
    const JORN_COMP_FER        = 'JORN_COMP_FER';
    const JORN_COMP_FOLG       = 'JORN_COMP_FOLG';
    const JORN_COMP_NORM       = 'JORN_COMP_NORM';
    const JORN_COMP_SAB        = 'JORN_COMP_SAB';

    //Extra Feriado
    const EX_DIA_FERIAD_1AS    = 'EX_DIA_FERIAD_1AS';
    const EX_DIA_FERIAD_SEG    = 'EX_DIA_FERIAD_SEG';
    const EX_NOT_FERIAD_1AS    = 'EX_NOT_FERIAD_1AS';
    const EX_NOT_FERIAD_SEG    = 'EX_NOT_FERIAD_SEG';
    const EX_NOT_FERIAD_CP     = 'EX_NOT_FERIAD_CP';
    const EX_DIA_FERIAD_NP_1AS = 'EX_DIA_FERIAD_NP_1AS';
    const EX_DIA_FERIAD_NP_SEG = 'EX_DIA_FERIAD_NP_SEG';
    const EX_NOT_FERIAD_NP_1AS = 'EX_NOT_FERIAD_NP_1AS';
    const EX_NOT_FERIAD_NP_SEG = 'EX_NOT_FERIAD_NP_SEG';
    const EX_NOT_FERIAD_NP_CP  = 'EX_NOT_FERIAD_NP_CP';

    //Extra Folga
    const EX_DIA_FOLGA_1AS     = 'EX_DIA_FOLGA_1AS';
    const EX_DIA_FOLGA_SEG     = 'EX_DIA_FOLGA_SEG';
    const EX_NOT_FOLGA_1AS     = 'EX_NOT_FOLGA_1AS';
    const EX_NOT_FOLGA_SEG     = 'EX_NOT_FOLGA_SEG';
    const EX_NOT_FOLGA_CP      = 'EX_NOT_FOLGA_CP';
    const EX_DIA_FOLGA_NP_1AS  = 'EX_DIA_FOLGA_NP_1AS';
    const EX_DIA_FOLGA_NP_SEG  = 'EX_DIA_FOLGA_NP_SEG';
    const EX_NOT_FOLGA_NP_1AS  = 'EX_NOT_FOLGA_NP_1AS';
    const EX_NOT_FOLGA_NP_SEG  = 'EX_NOT_FOLGA_NP_SEG';
    const EX_NOT_FOLGA_NP_CP   = 'EX_NOT_FOLGA_NP_CP';

    //Extra Sábado
    const EX_DIA_SABADO_1AS    = 'EX_DIA_SABADO_1AS';
    const EX_DIA_SABADO_SEG    = 'EX_DIA_SABADO_SEG';
    const EX_NOT_SABADO_1AS    = 'EX_NOT_SABADO_1AS';
    const EX_NOT_SABADO_SEG    = 'EX_NOT_SABADO_SEG';
    const EX_NOT_SABADO_CP     = 'EX_NOT_SABADO_CP';
    const EX_DIA_SABADO_NP_1AS = 'EX_DIA_SABADO_NP_1AS';
    const EX_DIA_SABADO_NP_SEG = 'EX_DIA_SABADO_NP_SEG';
    const EX_NOT_SABADO_NP_1AS = 'EX_NOT_SABADO_NP_1AS';
    const EX_NOT_SABADO_NP_SEG = 'EX_NOT_SABADO_NP_SEG';
    const EX_NOT_SABADO_NP_CP  = 'EX_NOT_SABADO_NP_CP';

    //Extra Normal
    const EX_DIA_NORMAL_1AS    = 'EX_DIA_NORMAL_1AS';
    const EX_DIA_NORMAL_SEG    = 'EX_DIA_NORMAL_SEG';
    const EX_NOT_NORMAL_1AS    = 'EX_NOT_NORMAL_1AS';
    const EX_NOT_NORMAL_SEG    = 'EX_NOT_NORMAL_SEG';
    const EX_NOT_NORMAL_CP     = 'EX_NOT_NORMAL_CP';
    const EX_DIA_NORMAL_NP_1AS = 'EX_DIA_NORMAL_NP_1AS';
    const EX_DIA_NORMAL_NP_SEG = 'EX_DIA_NORMAL_NP_SEG';
    const EX_NOT_NORMAL_NP_1AS = 'EX_NOT_NORMAL_NP_1AS';
    const EX_NOT_NORMAL_NP_SEG = 'EX_NOT_NORMAL_NP_SEG';
    const EX_NOT_NORMAL_NP_CP  = 'EX_NOT_NORMAL_NP_CP';

    //Extra Crédito Acumulado
    const EX_DIA_CRED_ACUMULADO = 'EX_DIA_CRED_ACUMULADO';

    //Saldos a Folgar - Tipos - Com e Sem Acréscimo
    // --Normal
    const SALDO_A_FOLGAR_NORM  = 'SALDO_A_FOLGAR_NORM';
    const SALDO_FOLGAR_AP_NORM = 'SALDO_FOLGAR_AP_NORM';
    const SALDO_FOLGAR_BH_NORM = 'SALDO_FOLGAR_BH_NORM';
    const SDO_FOLG_ACR_NORM    = 'SDO_FOLG_ACR_NORM';
    const SDO_FOLG_ACR_AP_NORM = 'SDO_FOLG_ACR_AP_NORM';
    const SDO_FOLG_ACR_BH_NORM = 'SDO_FOLG_ACR_BH_NORM';

    // --Feriado
    const SALDO_FOLGAR_FER     = 'SALDO_FOLGAR_FER';
    const SALDO_FOLGAR_AP_FER  = 'SALDO_FOLGAR_AP_FER';
    const SALDO_FOLGAR_BH_FER  = 'SALDO_FOLGAR_BH_FER';
    const SDO_FOLG_ACR_FER     = 'SDO_FOLG_ACR_FER';
    const SDO_FOLG_ACR_AP_FER  = 'SDO_FOLG_ACR_AP_FER';
    const SDO_FOLG_ACR_BH_FER  = 'SDO_FOLG_ACR_BH_FER';

    // --Folga
    const SALDO_FOLGAR_FOLG    = 'SALDO_FOLGAR_FOLG';
    const SALDO_FOLGAR_AP_FOLG = 'SALDO_FOLGAR_AP_FOLG';
    const SALDO_FOLGAR_BH_FOLG = 'SALDO_FOLGAR_BH_FOLG';
    const SDO_FOLG_ACR_FOLG    = 'SDO_FOLG_ACR_FOLG';
    const SDO_FOLG_ACR_AP_FOLG = 'SDO_FOLG_ACR_AP_FOLG';
    const SDO_FOLG_ACR_BH_FOLG = 'SDO_FOLG_ACR_BH_FOLG';

    // --Sábado
    const SALDO_FOLGAR_SAB     = 'SALDO_FOLGAR_SAB';
    const SALDO_FOLGAR_AP_SAB  = 'SALDO_FOLGAR_AP_SAB';
    const SALDO_FOLGAR_BH_SAB  = 'SALDO_FOLGAR_BH_SAB';
    const SDO_FOLG_ACR_SAB     = 'SDO_FOLG_ACR_SAB';
    const SDO_FOLG_ACR_AP_SAB  = 'SDO_FOLG_ACR_AP_SAB';
    const SDO_FOLG_ACR_BH_SAB  = 'SDO_FOLG_ACR_BH_SAB';

    //Trabalho
    const TRAB_DIURNO_I        = 'TRAB_DIURNO_I';
    const TRAB_NOTURNO_I       = 'TRAB_NOTURNO_I';
    const TRAB_NOT_I_H_COMP    = 'TRAB_NOT_I_H_COMP';
    const TRAB_DIURNO_II       = 'TRAB_DIURNO_II';
    const TRAB_NOTURNO_II      = 'TRAB_NOTURNO_II';
    const TRAB_NOT_II_H_COMP   = 'TRAB_NOT_II_H_COMP';
    const TRAB_EXTRA           = 'TRAB_EXTRA';
    const TRAB_N_REM_ANTES_NOT = 'TRAB_N_REM_ANTES_NOT';
    const TRAB_N_REM_DEP_NOT   = 'TRAB_N_REM_DEP_NOT';
    const TRAB_N_REMUN_ANTES   = 'TRAB_N_REMUN_ANTES';
    const TRAB_N_REMUN_DEP     = 'TRAB_N_REMUN_DEP';

    //Código Situações Frequência
    const ACIDENTE_ATE_15_D = 'ACIDENTE_ATE_15_D';
    const ACIDENTE_15_DIAS  = 'ACIDENTE_15_DIAS';
    const AF_DIR_FGTS_INSS   = 'AF_DIR_FGTS_INSS';
    const AF_LIC_GESTANTE    = 'AF_LIC_GESTANTE';
    const AF_SERVICO_MILITAR = 'AF_SERVICO_MILITAR';
    const APOSENTADO         = 'APOSENTADO';
    const CRED_DIA_APONT     = 'CRED_DIA_APONT';
    const DEB_DIA_APONT      = 'DEB_DIA_APONT';
    const DOENCA_ATE_15_D    = 'DOENCA_ATE_15_D';
    const DOENCA_15_DIAS     = 'DOENCA_15_DIAS';
    const HORAS_CRED_PER01   = 'HORAS_CRED_PER01';
    const HORAS_CRED_PER02   = 'HORAS_CRED_PER02';
    const HORAS_CRED_PER03   = 'HORAS_CRED_PER03';
    const HORAS_CRED_PER04   = 'HORAS_CRED_PER04';
    const HORAS_CRED_PER05   = 'HORAS_CRED_PER05';
    const HORAS_DEB_PER01    = 'HORAS_DEB_PER01';
    const HORAS_DEB_PER02    = 'HORAS_DEB_PER02';
    const HORAS_DEB_PER03    = 'HORAS_DEB_PER03';
    const HORAS_DEB_PER04    = 'HORAS_DEB_PER04';
    const HORAS_DEB_PER05    = 'HORAS_DEB_PER05';
    const HOR_DIA_COMPENSADO = 'HOR_DIA_COMPENSADO';
    const HOR_DIA_FOLGA      = 'HOR_DIA_FOLGA';
    const SAL_PATERNIDADE    = 'SAL_PATERNIDADE';
    const SEM_ATIV_OCUP_VAGA = 'SEM_ATIV_OCUP_VAGA';

    //Tipos de Qtd Referência
    const HORA       = 'HORA';
    const HRMI       = 'HRMI';
    const DIAS       = 'DIAS';
    const COTA       = 'COTA';
    const DOZEAV     = '12AV';
    const PERCENTUAL = 'PERC';

    //Identificação Marcação
    const BALIZA     = 'b';
    const REGISTRO   = 'r';
    const VIRADA     = 'v';
    const AUTOMATICA = 'a';
    const DIGITADA   = 'd';
    const PROJETADA  = 'p';

    //Tipo de Horários
    const NORMAL     = 'N';
    const TURNO      = 'T';
    const FOLGA      = 'F';
    const COMPENSADO = 'C';

    //Tipo de Ajuste da Marcação
    const NUNCA  = 'N';
    const SEMPRE = 'S';
    const AJUSTA_SE_MENOR = '<';
    const AJUSTA_SE_MAIOR = '>';

    //Tipo Dia
    const FERIADO     = 'F';
    const FACULTATIVO = 'O';

    //Id Entrada/Saída
    const ENTRADA = 'E';
    const SAIDA   = 'S';

    //Dia Ocorrência
    const DIA_ANTERIOR = 'DA';
    const DIA_CORRENTE = 'DC';
    const DIA_SEGUINTE = 'DS';
    const FORCA_DIA_ANTERIOR = 'FA';
    const FORCA_DIA_CORRENTE = 'FC';
    const FORCA_DIA_SEGUINTE = 'FS';

    //Sim/Não
    const SIM = 'S';
    const NAO = 'N';

    //Data e Hora
    const FORMATO_DATA_HORAMINUTO = 'd/m/Y H:i';
    const FORMATO_HORA_MINUTO     = 'H:i';

    /* Vitor Peixoto 25/05/2015
     * Array recebido por referencia para persistencia dos dados entre os vários Dias da Apuração.
     */
    private $refAuxSaldos;

    // Array que salva por referência os resumos que serão apenas demonstrativos. Utilizado para modificações no frontend
    private $idDemonstrativos = array();
    /* END Vitor Peixoto */

    private $balizasDesprezadas = array();
    private $balizasInseridas   = array();
    private $registrosEnquadrados = array();
    private $resumosBancoHorasAGerar = array();

    // Booleana que definirá quando o aplicativo terá chamado a apuração. Nestes casos, a apuração será diária.
    private $fromAplicativo = false;

    // Parametro para definir quando uma programacao impede de gerar o desconto
    private $geraDsr = true;

    public function __construct($nrorg, $nrvinculom, $data, $escala, $turno,
                                $dentroPeriodo, $nrPeriodoApuracao, $nrHordiam, $iniPerApur, $fromAplicativo = false)
    {

        error_reporting(E_ALL ^ (E_NOTICE | E_WARNING)); 
        /** @var GpeEscalatrabm $escala */    
        $this->escala        = $escala;
        $this->data          = $data;
        $this->turno         = $turno;
        $this->dentroPeriodo = $dentroPeriodo;
        $this->nrorg         = $nrorg;
        $this->nrvinculom    = $nrvinculom;
        $this->existeAtraso  = false;
        $this->iniPerApur    = $iniPerApur;
        $this->nrPeriodoApuracao = $nrPeriodoApuracao;
        $this->fromAplicativo = $fromAplicativo;

        $this->calcSituFreq        = new CalculoSituacaoFrequencia();
        $this->extrasNoDia         = 0;
        $this->idHorasNotAdic      = 0;
        $this->idHorasExtAdic      = 0;
        $this->idHorasPextAdic     = 0;
        $this->idHorasCompensarTot = 0;

        $dtCompetencia = FPA::getDtCompetencia();
        $diaSemana = self::retornaDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO));
        //Escala Histórico
        $whereEscalaTrabH = "NRESCALATRABM = ?
                        AND NRORG = ?
                        AND DTMESCOMPETENC IN (SELECT MAX(ETH.DTMESCOMPETENC)
                                                 FROM GPE_ESCALATRABH ETH
                                                WHERE ETH.NRESCALATRABM  = ?
                                                  AND ETH.NRORG = ?
                                                  AND ETH.DTMESCOMPETENC <= TO_DATE(?, 'DD/MM/YYYY'))";

        $paramsEscalaTrabH = array(
            $this->escala->getNrescalatrabm(),
            $this->nrorg,
            $this->escala->getNrescalatrabm(),
            $this->nrorg,
            $dtCompetencia
        );

        /** @var GpeEscalatrabh $escalaHist */
        $escalaHist = GpeEscalatrabh::getObjectByWhere($whereEscalaTrabH, $paramsEscalaTrabH);
        $this->escalaHistorico = $escalaHist;

        //Situação Funcional Dia e Situação Frequência associada(caso haja).
        $whereAlteSituFunc = "NRVINCULOM = ?
                         AND NRORG = ?
                         AND DTINISITUFUNC IN (SELECT MAX(DTINISITUFUNC)
                                                 FROM GPE_ALTESITUFUNC ALT
                                                WHERE ALT.NRVINCULOM = ?
                                                  AND ALT.NRORG = ?
                                                  AND ? BETWEEN ALT.DTINISITUFUNC AND NVL(ALT.DTFIMSITUFUNC, ?))";

        $paramsAlteSituFunc = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO)
        );
        if(!is_null($escala->Qtlimsephrextra) && $escala->Qtlimsephrextra != '') {
            $this->qtLimiteSeparacaoHoraExtra = $escala->Qtlimsephrextra;
        }
        else {
            $this->qtLimiteSeparacaoHoraExtra = $escalaHist->getQthrlimitesephextra();
        }

        /** @var GpeAltesitufunc $alteSituFunc */
        $alteSituFunc = GpeAltesitufunc::getObjectByWhere($whereAlteSituFunc, $paramsAlteSituFunc);

        if (is_object($alteSituFunc)) {
            $whereSitufunch = "NRSITUFUNCM = ?
                            AND NRORG = ?
                            AND DTEFETIVA IN (SELECT MAX(DTEFETIVA)
                                                FROM GPE_SITUFUNCH
                                               WHERE NRSITUFUNCM = ?
                                                 AND NRORG = ?
                                                 AND DTEFETIVA <= TO_DATE(?, 'DD/MM/YYYY'))";

            $paramsSitufunch = array(
                $alteSituFunc->getNrsitufuncm(),
                $alteSituFunc->getNrorg(),
                $alteSituFunc->getNrsitufuncm(),
                $alteSituFunc->getNrorg(),
                $dtCompetencia
            );

            /** @var GpeSitufunch $situFuncional */
            $situFuncional       = GpeSitufunch::getObjectByWhere($whereSitufunch, $paramsSitufunch);
            $this->situFuncional = $situFuncional;

            if (is_object($this->situFuncional)) {
                if (!is_null($this->situFuncional->getSitufrequencia())) {
                    /** @var PtoSitufrequencia $situFreq */
                    $situFreq = PtoSitufrequencia::findOneByNrsitufrequencia($this->situFuncional->getNrsitufrequencia());
                } else {
                    $situFreq = '';
                }
                $this->situFreq = $situFreq;
            }
        }

        //Dia calendário
        $whereOcorCalendario = "NRCALENDARIO IN (SELECT NRCALENDARIO
                                                  FROM ESTRUTURAH
                                                 WHERE NRESTRUTURAM = (SELECT NRESTRUTLEGAL
                                                                         FROM GPE_VINCULOH
                                                                        WHERE NRVINCULOM    = ?
                                                                          AND NRORG         = ?
                                                                          AND DTMESCOMPETENC IN
                                                                                                (SELECT MAX(DTMESCOMPETENC)
                                                                                                   FROM GPE_VINCULOH
                                                                                                  WHERE NRVINCULOM = ?
                                                                                                    AND NRORG      = ?
                                                                                                    AND DTMESCOMPETENC <= TO_DATE(?, 'DD/MM/YYYY')
                                                                                                ))
                                                   AND NRORG = ?)
                            AND NRORG = ?";
        $paramsOcorCalendario = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->nrvinculom,
            $this->nrorg,
            $dtCompetencia,
            $this->nrorg,
            $this->nrorg
        );

        $diasEspeciais = Ocorcalendario::getObjectsByWhere($whereOcorCalendario, $paramsOcorCalendario);

        /** @var Ocorcalendario $diaEspecial */
        foreach ($diasEspeciais as $diaEspecial) {
            if (DateUtil::comparaDatas($this->data, $diaEspecial->getDtcalendario(), DateUtil::IGUAL)) {
                /** @var Tpcalendario $tpCalendario */
                $tpCalendario = Tpcalendario::findOneByNrtpcalendario($diaEspecial->getNrtpcalendario());
                if ($tpCalendario->getIdtipodia() == 'FERIADO') {
                    $this->idDiaCalend = self::FERIADO;
                } elseif ($tpCalendario->getIdtipodia() == 'PONTOFACULTATIVO') {
                    $this->idDiaCalend = self::FACULTATIVO;
                }
            }
        }
        $tipoDiaCalend = null;
        if ($this->idDiaCalend == self::FERIADO) {
            $tipoDiaCalend = 'FERIADO';
        } elseif ($this->idDiaCalend == self::PONTO_FACULTATIVO) {
            $tipoDiaCalend = 'PONTOFACULTATIVO';
        }

        $whereResumSituFreq = "NRVINCULOM = ?
                           AND NRORG = ?
                           AND IDFORCASITUFREQ = 'FORCA_SITU'
                           AND DTAPURACAOSITUFREQ = TO_DATE(?, 'DD/MM/YYYY')";

        $this->resumosSituFreqs = PtoResumositufreq::getObjectsByWhere($whereResumSituFreq,
                                                                        array($this->nrvinculom, $this->nrorg, $this->data->format('d/m/Y')));

        //Verifica existência de horário a ser forçado

        if($nrHordiam != '' && !is_null($nrHordiam)){
            $horario = GpeHordiam::findOneByNrorgAndNrhordiam($this->nrorg, $nrHordiam);
        }else{
            //Verifica nas Ocorrências
            $nrOrgPadrao = FPA::getNrorgPadrao();
            /** @var PtoTipoprogocorrencia $tipoProgOcor */
            $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrorgAndCdtipoprogocorrencia($nrOrgPadrao, self::IDENTIFICA_INTERVALO);

            $whereProgForcaHorario = "NRVINCULOM = ?
                                  AND IDATIVO    = 'S'
                                  AND NRORG = ?
                                  AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                                  AND NRHORDIAM IS NOT NULL
                                  AND DTINICIOPROGOCOR IN (SELECT MAX(DTINICIOPROGOCOR)
                                                             FROM PTO_PROGOCORRENCIA
                                                            WHERE NRVINCULOM = ?
                                                              AND NRORG = ?
                                                              AND NRHORDIAM IS NOT NULL
                                                              AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR
                                                                  AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY')))
                                  AND NRTIPOPROGOCORRENCIA <> ?
                                  AND IDPROGOCORCONFIRMADA = 'S'
                                  AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)";


            $paramsProgForcaHorario = array(
                $this->nrvinculom,
                $this->nrorg,
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->nrvinculom,
                $this->nrorg,
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $tipoProgOcor->getNrtipoprogocorrencia(),
                $tipoDiaCalend
            );

            /** @var PtoProgocorrencia $progForcaHorario */
            $progForcaHorario = PtoProgocorrencia::getObjectByWhere($whereProgForcaHorario, $paramsProgForcaHorario);

            if(is_object($progForcaHorario)){
                $horario = GpeHordiam::findOneByNrorgAndNrhordiam($this->nrorg, $progForcaHorario->getNrhordiam());
            }
            else{
                /** @var GpeTurno $turno*/
                $horario = self::getHorarioTurno($data,
                    $turno->getNrturno(),
                    $turno->getDtdatabase(),
                    $turno->getNrorg());
            }
        }

        // LEONARDOCARVALHO - 09/12/2015 - Adiocionado parâmetro de $tipoDiaCalend e $existeMarcacao
        $existeMarcacao = $this->existeMarcacaoPonto();
        $this->horario = new Horario($data, $horario, $tipoDiaCalend, $existeMarcacao);

        //Preenche vetor com Ocorrências e Programações de banco de horas.

        //Ocorrências
        $whereProgOcor = "NRVINCULOM = ?
                      AND NRORG = ?
                      AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                      AND NRMARCACAOPONTO IS NULL
                      AND IDPROGOCORCONFIRMADA = 'S'
                      AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                      AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)
                      AND IDATIVO = 'S'";
        $paramsProgOcor = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $tipoDiaCalend,
            $this->horario->getHorarioHistorico()->getIdtipohorario()
        );

        $programacoesOcorr = PtoProgocorrencia::getObjectsByWhere($whereProgOcor, $paramsProgOcor);

        /** @var PtoProgocorrencia $programacaoOcorr */
        foreach($programacoesOcorr as $programacaoOcorr){

            $arrayDiasSemana = str_split($programacaoOcorr->getIddiassemana());
            if (!(is_null($programacaoOcorr->getIddiassemana()) || $programacaoOcorr->getIddiassemana() == '0000000' || !(isset($arrayDiasSemana[$diaSemana]) && $arrayDiasSemana[$diaSemana] == '1'))) {
                $this->programacoesOcorrencia[] = $programacaoOcorr;
            }

//            $this->programacoesOcorrencia[] = $programacaoOcorr;
        }

        //Programações Banco de Horas
        $whereAlteBancoHoras = "NRVINCULOM = ?
                            AND NRORG = ?
                            AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOALTEBHORAS AND NVL(DTFIMALTEBHORAS, TO_DATE(?, 'DD/MM/YYYY'))";

        $paramsAlteBancoHoras = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO)
        );

        $alteBancoHoras = PtoAltebancohoras::getObjectsByWhere($whereAlteBancoHoras, $paramsAlteBancoHoras);

        /** @var PtoAltebancohoras $alteracaoBancoHoras */
        foreach($alteBancoHoras as $alteracaoBancoHoras){
            $whereProgBH = "NRBANCOHORAS = ?
                        AND NRORG = ?
                        AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGBHORAS AND NVL(DTFIMPROGBHORAS, TO_DATE(?, 'DD/MM/YYYY'))
                        AND IDATIVO = 'S'
                        AND NRTIPOPROGOCORRENCIA NOT IN (SELECT NRTIPOPROGOCORRENCIA
                                                           FROM PTO_PROGOCORRENCIA
                                                          WHERE NRVINCULOM = ?
                                                            AND NRORG      = ?
                                                            AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY')))";
            $paramsProgBH = array(
                $alteracaoBancoHoras->getNrbancohoras(),
                $this->nrorg,
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->nrvinculom,
                $this->nrorg,
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->data->format(DateUtil::FORMATO_BRASILEIRO)
            );
            $result = "SELECT IDSITUFREQS FROM PTO_BANCOHORAS WHERE NRORG = $this->nrorg AND NRBANCOHORAS = ".$alteracaoBancoHoras->getNrbancohoras();
            $idSituFreqs = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($result);
            $this->resumosBancoHorasAGerar = explode(',', $idSituFreqs[0]['IDSITUFREQS']);

            $programacoesBH = PtoBancohorasprog::getObjectsByWhere($whereProgBH, $paramsProgBH);

            foreach($programacoesBH as $programacaoBH){
                $arrayDiasSemana = str_split($programacaoBH->getIddiassemana());
                if (!(is_null($programacaoBH->getIddiassemana()) || $programacaoBH->getIddiassemana() == '0000000' || !(isset($arrayDiasSemana[$diaSemana]) && $arrayDiasSemana[$diaSemana] == '1'))) {
                    $this->programacoesOcorrencia[] = $programacaoBH;
                }
//                $this->programacoesOcorrencia[] = $programacaoBH;
            }
        }



        usort($this->programacoesOcorrencia, function ($programacaoA, $programacaoB)
        {
            //Padrão
            /** @var PtoTipoprogocorrencia $tipoProgAPadrao */
            $tipoProgAPadrao = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoA->getNrtipoprogocorrencia());

            //Tenta achar o tipo de programação da organização trabalho
            //Trabalho
            /** @var PtoTipoprogocorrencia $tipoProgATrab */
            $tipoProgATrab = PtoTipoprogocorrencia::findOneByCdtipoprogocorrenciaAndNrorg($tipoProgAPadrao->getCdtipoprogocorrencia(),
                                                                                          FPA::getNrorg());

            if(is_object($tipoProgATrab)){
                $tipoProgA = $tipoProgATrab;
            }
            else{
                $tipoProgA = $tipoProgAPadrao;
            }

            //Padrão
            /** @var PtoTipoprogocorrencia $tipoProgBPadrao */
            $tipoProgBPadrao = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoB->getNrtipoprogocorrencia());

            //Tenta achar o tipo de programação da organização trabalho
            //Trabalho
            /** @var PtoTipoprogocorrencia $tipoProgBTrab */
            $tipoProgBTrab = PtoTipoprogocorrencia::findOneByCdtipoprogocorrenciaAndNrorg($tipoProgBPadrao->getCdtipoprogocorrencia(),
                                                                                          FPA::getNrorg());

            if(is_object($tipoProgBTrab)){
                $tipoProgB = $tipoProgBTrab;
            }
            else{
                $tipoProgB = $tipoProgBPadrao;
            }

            if ($tipoProgA->getNrordemprogocorrencia() == $tipoProgB->getNrordemprogocorrencia()) {
                return 0;
            }
            return ($tipoProgA->getNrordemprogocorrencia() < $tipoProgB->getNrordemprogocorrencia()) ? -1 : 1;
        });
        

        $numPeriodos = (count($this->horario->getIntervalosHorario()) / 2);

        for ($i = 0; $i < $numPeriodos; $i++) {
            $this->periodosIntervalos[] = array(
                'ATRASOS' => 0,
                'SAIDAS'  => 0,
                'EXTRAS'  => 0
            );
        }
    }

    /**
     * @param $valorReferenciaDesconto Valor de desconto em horas(decimal)
     */
    private function descontaDsr($valorReferenciaDesconto) {
        $calculosSituacaoFrequencia = $this->calcSituFreq->getCalcSituacoesFreq();

        //<editor-fold desc="Busca a Associação de Situação de Frequência referente ao DSR">
        //Primeira busca para a organização trabalho
        /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
        $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                                     $calculosSituacaoFrequencia[self::DSR_DESCONTADO]['NRCALCULOSITUFREQ']);

        //Caso não haja associação específica para a organização de trabalho, busca a associação de organização padrão
        if (!is_object($assocSituFreqCalcSit)) {
            $nrOrgPadrao = FPA::getNrorgPadrao();
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                                         $calculosSituacaoFrequencia[self::DSR_DESCONTADO]['NRCALCULOSITUFREQ']);
        }
        //</editor-fold>

        //<editor-fold desc="Calcula a jornada de trabalho diária (DSR não pode ser maior)">
        $entrada = 0;
/*        $valorJornadaTrabalho = 0;
        foreach ($this->horario->getIntervalosHorario() as $key => $intervaloHorario) {
            if ($key % 2 != 0) { //Saída
                $valorJornadaTrabalho += ($intervaloHorario['HORA'] * 60) - $entrada;
            } else { //Entrada
                $entrada = ($intervaloHorario['HORA'] * 60);
            }
        }
        $valorJornadaTrabalho /= 6000;*/
        //</editor-fold>
        //$calculosSituacaoFrequencia[self::DSR_DESCONTADO]['HORAS'] = ($valorReferenciaDesconto > $valorJornadaTrabalho ? $valorJornadaTrabalho : $valorReferenciaDesconto);
        $calculosSituacaoFrequencia[self::DSR_DESCONTADO]['HORAS'] = $valorReferenciaDesconto;
        $this->resumosSituFreqs[] = self::criaResumoSituFreq(null,
                                                             null,
                                                             null,
                                                             $assocSituFreqCalcSit->getNrsitufrequencia(),
                                                             $calculosSituacaoFrequencia[self::DSR_DESCONTADO]['HORAS']);
        $this->calcSituFreq->setCalcSituacoesFreq($calculosSituacaoFrequencia);
    }

    /**
     * @param $refAux
     * @return array
     */
    private static function arredondaDecimal($refAux)
    {
        //<editor-fold desc="Vitor Peixoto 09/06/2015 Arredondamento customizado dos minutos">
        $strArray = explode('.', ($refAux * 60));
        
        $integer = $strArray[0];
        $decimal = isset($strArray[1]) ? $strArray[1] : '0';

        $decimalArray = array_reverse(str_split($decimal));

        $addOne = 0;
        foreach ($decimalArray as $key => $element) {
            $decimalArray[$key] += $addOne;
            if ($decimalArray[$key] >= 5) $addOne = 1;
            else $addOne = 0;
        }

        if (end($decimalArray) >= 5) {
            if(in_array('-', str_split($strArray[0]))) {
                $integer -= 1;
            }
            else $integer += 1;
        }

        $refAux = ($integer / 60);

        return $refAux;
        //</editor-fold>
    }

    public function getData()
    {
        return $this->data;
    }

    public function setData($data)
    {
        $this->data = $data;
    }

    public function getDentroPeriodo()
    {
        return $this->dentroPeriodo;
    }

    public function setDentroPeriodo($dentroPeriodo)
    {
        $this->dentroPeriodo = $dentroPeriodo;
    }

    public function getNrvinculom()
    {
        return $this->nrvinculom;
    }

    public function setNrvinculom($nrvinculom)
    {
        $this->nrvinculom = $nrvinculom;
    }

    public function getNrorg()
    {
        return $this->nrorg;
    }

    public function setNrorg($nrorg)
    {
        $this->nrorg = $nrorg;
    }

    public function getEscala()
    {
        return $this->escala;
    }

    public function setEscala($escala)
    {
        $this->escala = $escala;
    }

    public function getTurno()
    {
        return $this->turno;
    }

    public function setTurno($turno)
    {
        $this->turno = $turno;
    }

    public function getHorario()
    {
        return $this->horario;
    }

    public function setHorario($horario)
    {
        $this->horario = $horario;
    }

    public function getRegistros()
    {
        return $this->registros;
    }

    public function setRegistros($registros)
    {
        $this->registros   = $registros;
        $registrosNDesprez = array();
        foreach ($this->registros as $registro) {
            if ($registro->getMarcacao()->getIdmarcdesprezada() == self::NAO) {
                $registrosNDesprez[] = $registro;
            }
        }
        $this->registrosNDesprez = $registrosNDesprez;
    }

    /**
     * @return mixed
     */
    public function getIndexRegistros()
    {
        return $this->indexRegistros;
    }

    /**
     * @param mixed $indexRegistros
     */
    public function setIndexRegistros($indexRegistros)
    {
        $this->indexRegistros = $indexRegistros;
    }

    /**
     * @return array
     */
    public function getRegistrosNDesprez()
    {
        return $this->registrosNDesprez;
    }

    /**
     * @param array $registrosNDesprez
     */
    public function setRegistrosNDesprez($registrosNDesprez)
    {
        $this->registrosNDesprez = $registrosNDesprez;
    }

    /**
     * @return array
     */
    public function getIntervalosControle()
    {
        return $this->intervalosControle;
    }

    /**
     * @param array $intervalosControle
     */
    public function setIntervalosControle($intervalosControle)
    {
        $this->intervalosControle = $intervalosControle;
    }

    /**
     * @return array
     */
    public function getIntervalosRegistros()
    {
        return $this->intervalosRegistros;
    }

    /**
     * @param array $intervalosRegistros
     */
    public function setIntervalosRegistros($intervalosRegistros)
    {
        $this->intervalosRegistros = $intervalosRegistros;
    }

    /**
     * @return mixed
     */
    public function getPrimeiraMarcacao()
    {
        return $this->primeiraMarcacao;
    }

    /**
     * @param mixed $primeiraMarcacao
     */
    public function setPrimeiraMarcacao($primeiraMarcacao)
    {
        $this->primeiraMarcacao = $primeiraMarcacao;
    }

    /**
     * @return mixed
     */
    public function getUltimaMarcacao()
    {
        return $this->ultimaMarcacao;
    }

    /**
     * @param mixed $ultimaMarcacao
     */
    public function setUltimaMarcacao($ultimaMarcacao)
    {
        $this->ultimaMarcacao = $ultimaMarcacao;
    }

    /**
     * @return mixed
     */
    public function getIndexIntervalosRegistros()
    {
        return $this->indexIntervalosRegistros;
    }

    /**
     * @param mixed $indexIntervalosRegistros
     */
    public function setIndexIntervalosRegistros($indexIntervalosRegistros)
    {
        $this->indexIntervalosRegistros = $indexIntervalosRegistros;
    }

    /**
     * @return mixed
     */
    public function getEndOfIntervalosRegistros()
    {
        return $this->endOfIntervalosRegistros;
    }

    /**
     * @param mixed $endOfIntervalosRegistros
     */
    public function setEndOfIntervalosRegistros($endOfIntervalosRegistros)
    {
        $this->endOfIntervalosRegistros = $endOfIntervalosRegistros;
    }

    /**
     * @return mixed
     */
    public function getIndexIntervalosControle()
    {
        return $this->indexIntervalosControle;
    }

    /**
     * @param mixed $indexIntervalosControle
     */
    public function setIndexIntervalosControle($indexIntervalosControle)
    {
        $this->indexIntervalosControle = $indexIntervalosControle;
    }

    /**
     * @return mixed
     */
    public function getEndOfIntervalosControle()
    {
        return $this->endOfIntervalosControle;
    }

    /**
     * @param mixed $endOfIntervalosControle
     */
    public function setEndOfIntervalosControle($endOfIntervalosControle)
    {
        $this->endOfIntervalosControle = $endOfIntervalosControle;
    }

    /**
     * @return mixed
     */
    public function getIdTrabDia()
    {
        return $this->idTrabDia;
    }

    /**
     * @param mixed $idTrabDia
     */
    public function setIdTrabDia($idTrabDia)
    {
        $this->idTrabDia = $idTrabDia;
    }

    /**
     * @return mixed
     */
    public function getIdTrabNot()
    {
        return $this->idTrabNot;
    }

    /**
     * @param mixed $idTrabNot
     */
    public function setIdTrabNot($idTrabNot)
    {
        $this->idTrabNot = $idTrabNot;
    }

    /**
     * @return mixed
     */
    public function getCalcSituFreq()
    {
        return $this->calcSituFreq;
    }

    /**
     * @param mixed $calcSituFreq
     */
    public function setCalcSituFreq($calcSituFreq)
    {
        $this->calcSituFreq = $calcSituFreq;
    }

    /**
     * @return mixed
     */
    public function getIdHorasNotAdic()
    {
        return $this->idHorasNotAdic;
    }

    /**
     * @param mixed $idHorasNotAdic
     */
    public function setIdHorasNotAdic($idHorasNotAdic)
    {
        $this->idHorasNotAdic = $idHorasNotAdic;
    }

    /**
     * @return mixed
     */
    public function getIdHorasExtAdic()
    {
        return $this->idHorasExtAdic;
    }

    /**
     * @param mixed $idHorasExtAdic
     */
    public function setIdHorasExtAdic($idHorasExtAdic)
    {
        $this->idHorasExtAdic = $idHorasExtAdic;
    }

    /**
     * @return mixed
     */
    public function getIdHorasPextAdic()
    {
        return $this->idHorasPextAdic;
    }

    /**
     * @param mixed $idHorasPextAdic
     */
    public function setIdHorasPextAdic($idHorasPextAdic)
    {
        $this->idHorasPextAdic = $idHorasPextAdic;
    }

    /**
     * @return mixed
     */
    public function getIdDiaCalend()
    {
        return $this->idDiaCalend;
    }

    /**
     * @param mixed $idDiaCalend
     */
    public function setIdDiaCalend($idDiaCalend)
    {
        $this->idDiaCalend = $idDiaCalend;
    }

    /**
     * @return mixed
     */
    public function getExtrasNoDia()
    {
        return $this->extrasNoDia;
    }

    /**
     * @param mixed $extrasNoDia
     */
    public function setExtrasNoDia($extrasNoDia)
    {
        $this->extrasNoDia = $extrasNoDia;
    }

    /**
     * @return mixed
     */
    public function getIdExtraDia()
    {
        return $this->idExtraDia;
    }

    /**
     * @param mixed $idExtraDia
     */
    public function setIdExtraDia($idExtraDia)
    {
        $this->idExtraDia = $idExtraDia;
    }

    /**
     * @return mixed
     */
    public function getIdExtraDia2()
    {
        return $this->idExtraDia2;
    }

    /**
     * @param mixed $idExtraDia2
     */
    public function setIdExtraDia2($idExtraDia2)
    {
        $this->idExtraDia2 = $idExtraDia2;
    }

    /**
     * @return mixed
     */
    public function getIdExtraNot()
    {
        return $this->idExtraNot;
    }

    /**
     * @param mixed $idExtraNot
     */
    public function setIdExtraNot($idExtraNot)
    {
        $this->idExtraNot = $idExtraNot;
    }

    /**
     * @return mixed
     */
    public function getIdExtraNot2()
    {
        return $this->idExtraNot2;
    }

    /**
     * @param mixed $idExtraNot2
     */
    public function setIdExtraNot2($idExtraNot2)
    {
        $this->idExtraNot2 = $idExtraNot2;
    }

    /**
     * @return mixed
     */
    public function getIdPextraNComp()
    {
        return $this->idPextraNComp;
    }

    /**
     * @param mixed $idPextraNComp
     */
    public function setIdPextraNComp($idPextraNComp)
    {
        $this->idPextraNComp = $idPextraNComp;
    }

    /**
     * @return mixed
     */
    public function getIdPextraNot2()
    {
        return $this->idPextraNot2;
    }

    /**
     * @param mixed $idPextraNot2
     */
    public function setIdPextraNot2($idPextraNot2)
    {
        $this->idPextraNot2 = $idPextraNot2;
    }

    /**
     * @return mixed
     */
    public function getIdExtraNComp()
    {
        return $this->idExtraNComp;
    }

    /**
     * @param mixed $idExtraNComp
     */
    public function setIdExtraNComp($idExtraNComp)
    {
        $this->idExtraNComp = $idExtraNComp;
    }

    /**
     * @return mixed
     */
    public function getIdTipoExtra()
    {
        return $this->idTipoExtra;
    }

    /**
     * @param mixed $idTipoExtra
     */
    public function setIdTipoExtra($idTipoExtra)
    {
        $this->idTipoExtra = $idTipoExtra;
    }

    /**
     * @return mixed
     */
    public function getIdPextraDia()
    {
        return $this->idPextraDia;
    }

    /**
     * @param mixed $idPextraDia
     */
    public function setIdPextraDia($idPextraDia)
    {
        $this->idPextraDia = $idPextraDia;
    }

    /**
     * @return mixed
     */
    public function getIdPextraDia2()
    {
        return $this->idPextraDia2;
    }

    /**
     * @param mixed $idPextraDia2
     */
    public function setIdPextraDia2($idPextraDia2)
    {
        $this->idPextraDia2 = $idPextraDia2;
    }

    /**
     * @return mixed
     */
    public function getIdPextraNot()
    {
        return $this->idPextraNot;
    }

    /**
     * @param mixed $idPextraNot
     */
    public function setIdPextraNot($idPextraNot)
    {
        $this->idPextraNot = $idPextraNot;
    }

    /**
     * @return mixed
     */
    public function getIdTipoPextra()
    {
        return $this->idTipoPextra;
    }

    /**
     * @param mixed $idTipoPextra
     */
    public function setIdTipoPextra($idTipoPextra)
    {
        $this->idTipoPextra = $idTipoPextra;
    }

    /**
     * @return mixed
     */
    public function getIdTrabNComp()
    {
        return $this->idTrabNComp;
    }

    /**
     * @param mixed $idTrabNComp
     */
    public function setIdTrabNComp($idTrabNComp)
    {
        $this->idTrabNComp = $idTrabNComp;
    }

    /**
     * @return mixed
     */
    public function getIdPjornComplementar()
    {
        return $this->idPjornComplementar;
    }

    /**
     * @param mixed $idPjornComplementar
     */
    public function setIdPjornComplementar($idPjornComplementar)
    {
        $this->idPjornComplementar = $idPjornComplementar;
    }

    /**
     * @return mixed
     */
    public function getIdJornComplementar()
    {
        return $this->idJornComplementar;
    }

    /**
     * @param mixed $idJornComplementar
     */
    public function setIdJornComplementar($idJornComplementar)
    {
        $this->idJornComplementar = $idJornComplementar;
    }

    /**
     * @return mixed
     */
    public function getIdAdicHexDia()
    {
        return $this->idAdicHexDia;
    }

    /**
     * @param mixed $idAdicHexDia
     */
    public function setIdAdicHexDia($idAdicHexDia)
    {
        $this->idAdicHexDia = $idAdicHexDia;
    }

    /**
     * @return mixed
     */
    public function getIdAdicHexDia2()
    {
        return $this->idAdicHexDia2;
    }

    /**
     * @param mixed $idAdicHexDia2
     */
    public function setIdAdicHexDia2($idAdicHexDia2)
    {
        $this->idAdicHexDia2 = $idAdicHexDia2;
    }

    /**
     * @return mixed
     */
    public function getIdAdicHexNot()
    {
        return $this->idAdicHexNot;
    }

    /**
     * @param mixed $idAdicHexNot
     */
    public function setIdAdicHexNot($idAdicHexNot)
    {
        $this->idAdicHexNot = $idAdicHexNot;
    }

    /**
     * @return mixed
     */
    public function getIdAdicHexNot2()
    {
        return $this->idAdicHexNot2;
    }

    /**
     * @param mixed $idAdicHexNot2
     */
    public function setIdAdicHexNot2($idAdicHexNot2)
    {
        $this->idAdicHexNot2 = $idAdicHexNot2;
    }

    /**
     * @return mixed
     */
    public function getIdAdicHexNComp()
    {
        return $this->idAdicHexNComp;
    }

    /**
     * @param mixed $idAdicHexNComp
     */
    public function setIdAdicHexNComp($idAdicHexNComp)
    {
        $this->idAdicHexNComp = $idAdicHexNComp;
    }

    /**
     * @return mixed
     */
    public function getSituFuncional()
    {
        return $this->situFuncional;
    }

    /**
     * @param mixed $situFuncional
     */
    public function setSituFuncional($situFuncional)
    {
        $this->situFuncional = $situFuncional;
    }

    /**
     * @return mixed
     */
    public function getIdFerias()
    {
        return $this->idFerias;
    }

    /**
     * @param mixed $idFerias
     */
    public function setIdFerias($idFerias)
    {
        $this->idFerias = $idFerias;
    }

    /**
     * @return mixed
     */
    public function getIdAfastamento()
    {
        return $this->idAfastamento;
    }

    /**
     * @param mixed $idAfastamento
     */
    public function setIdAfastamento($idAfastamento)
    {
        $this->idAfastamento = $idAfastamento;
    }

    /**
     * @return mixed
     */
    public function getSituFreq()
    {
        return $this->situFreq;
    }

    /**
     * @param mixed $situFreq
     */
    public function setSituFreq($situFreq)
    {
        $this->situFreq = $situFreq;
    }

    /**
     * @return mixed
     */
    public function getExisteAtraso()
    {
        return $this->existeAtraso;
    }

    /**
     * @param mixed $existeAtraso
     */
    public function setExisteAtraso($existeAtraso)
    {
        $this->existeAtraso = $existeAtraso;
    }

    /**
     * @return array
     */
    public function getProgramacoesOcorrencia()
    {
        return $this->programacoesOcorrencia;
    }

    /**
     * @param array $programacoesOcorrencia
     */
    public function setProgramacoesOcorrencia($programacoesOcorrencia)
    {
        $this->programacoesOcorrencia = $programacoesOcorrencia;
    }

    /**
     * @return mixed
     */
    public function getResumosSituFreqs()
    {
        return $this->resumosSituFreqs;
    }

    /**
     * @param mixed $resumosSituFreqs
     */
    public function setResumosSituFreqs($resumosSituFreqs)
    {
        $this->resumosSituFreqs = $resumosSituFreqs;
    }

    /**
     * @return mixed
     */
    public function getNrPeriodoApuracao()
    {
        return $this->nrPeriodoApuracao;
    }

    /**
     * @param mixed $nrPeriodoApuracao
     */
    public function setNrPeriodoApuracao($nrPeriodoApuracao)
    {
        $this->nrPeriodoApuracao = $nrPeriodoApuracao;
    }

    /**
     * @return array
     */
    public function getPeriodosIntervalos()
    {
        return $this->periodosIntervalos;
    }

    /**
     * @param array $periodosIntervalos
     */
    public function setPeriodosIntervalos($periodosIntervalos)
    {
        $this->periodosIntervalos = $periodosIntervalos;
    }

    /**
     * @return mixed
     */
    public function getIdHorasTrabTot()
    {
        return $this->idHorasTrabTot;
    }

    /**
     * @param mixed $idHorasTrabTot
     */
    public function setIdHorasTrabTot($idHorasTrabTot)
    {
        $this->idHorasTrabTot = $idHorasTrabTot;
    }

    /**
     * @return GpeEscalatrabh
     */
    public function getEscalaHistorico()
    {
        return $this->escalaHistorico;
    }

    /**
     * @param GpeEscalatrabh $escalaHistorico
     */
    public function setEscalaHistorico($escalaHistorico)
    {
        $this->escalaHistorico = $escalaHistorico;
    }

    /**
     * @return mixed
     */
    public function getIdHorasCompensarTot()
    {
        return $this->idHorasCompensarTot;
    }

    /**
     * @param mixed $idHorasCompensarTot
     */
    public function setIdHorasCompensarTot($idHorasCompensarTot)
    {
        $this->idHorasCompensarTot = $idHorasCompensarTot;
    }

    /**
     * @return array
     */
    public function getIdFolgaAutorizadas()
    {
        return $this->idFolgaAutorizadas;
    }

    /**
     * @param array $idFolgaAutorizadas
     */
    public function setIdFolgaAutorizadas($idFolgaAutorizadas)
    {
        $this->idFolgaAutorizadas = $idFolgaAutorizadas;
    }

    /**
     * @return mixed
     */
    public function getIdHorasFaltasTot()
    {
        return $this->idHorasFaltasTot;
    }

    /**
     * @param mixed $idHorasFaltasTot
     */
    public function setIdHorasFaltasTot($idHorasFaltasTot)
    {
        $this->idHorasFaltasTot = $idHorasFaltasTot;
    }

    /**
     * @return mixed
     */
    public function getIdHorasAtrSaiTot()
    {
        return $this->idHorasAtrSaiTot;
    }

    /**
     * @param mixed $idHorasAtrSaiTot
     */
    public function setIdHorasAtrSaiTot($idHorasAtrSaiTot)
    {
        $this->idHorasAtrSaiTot = $idHorasAtrSaiTot;
    }

    /**
     * @return mixed
     */
    public function getIdHorasAtrasosTot()
    {
        return $this->idHorasAtrasosTot;
    }

    /**
     * @param mixed $idHorasAtrasosTot
     */
    public function setIdHorasAtrasosTot($idHorasAtrasosTot)
    {
        $this->idHorasAtrasosTot = $idHorasAtrasosTot;
    }

    /**
     * @return mixed
     */
    public function getIdHorasSaidasTot()
    {
        return $this->idHorasSaidasTot;
    }

    /**
     * @param mixed $idHorasSaidasTot
     */
    public function setIdHorasSaidasTot($idHorasSaidasTot)
    {
        $this->idHorasSaidasTot = $idHorasSaidasTot;
    }

    private function retornaDiaSemana($data){
        $diaSemana = DateUtil::getDiaSemana($data);
        if($diaSemana == 7){
            $diaSemana = 0;
        }
        else{
            $diaSemana;
        }

        return $diaSemana;
    }

    private function retornaDataDiaOcorrencia($horario, $data, $diaOcorrencia)
    {
        $horario = DateUtil::getHoraFloatDeString($horario);
        $horario = DateUtil::getHoraStringDeFloat($horario, true);
        if ($diaOcorrencia == self::DIA_SEGUINTE || $diaOcorrencia == self::FORCA_DIA_SEGUINTE) {
            $data = DateUtil::subtraiIntervalo($data, 1, DateUtil::DIA);
            $data = $data->format(DateUtil::FORMATO_BRASILEIRO);
            $data .= ' ' . $horario;
            $data = DateUtil::getDataDeString($data, self::FORMATO_DATA_HORAMINUTO);
        } elseif ($diaOcorrencia == self::DIA_ANTERIOR || $diaOcorrencia == self::FORCA_DIA_ANTERIOR) {
            $data = DateUtil::adicionaIntervalo($data, 1, DateUtil::DIA);
            $data = $data->format(DateUtil::FORMATO_BRASILEIRO);
            $data .= ' ' . $horario;
            $data = DateUtil::getDataDeString($data, self::FORMATO_DATA_HORAMINUTO);
        } else {
            $data = $data->format(DateUtil::FORMATO_BRASILEIRO);
            $data .= ' ' . $horario;
            $data = DateUtil::getDataDeString($data, self::FORMATO_DATA_HORAMINUTO);
        }

        return $data;
    }

    public function setRegistrosDia($horarioDiaSeguinte, $idDiaCalendSeg, &$refAuxSaldos)
    {
        $diaSemana = self::retornaDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO));
        $dtponto    = $this->data->format(DateUtil::FORMATO_BRASILEIRO);
        $dtSeguinte = DateUtil::adicionaIntervalo($this->data, 1, DateUtil::DIA);
        $dtSeguinte = $dtSeguinte->format(DateUtil::FORMATO_BRASILEIRO);
        $this->refAuxSaldos = &$refAuxSaldos;

        $dtHrIniColeta = $dtponto . ' ' . self::formataHora($this->horario->getHorarioHistorico()->getHrinicoletamarcacao());

        /** @var Horario $horarioDiaSeguinte */
        $horarioFimColeta = self::formataHora($horarioDiaSeguinte->getHorarioHistorico()->getHrinicoletamarcacao());
        $horarioFimColeta = DateUtil::subtrairHoras($horarioFimColeta, '00:01', DateUtil::HORA_MINUTO);

        $dtHrFimColeta = $dtSeguinte . ' ' . $horarioFimColeta;

        $where = "NRORG = ?
              AND NRVINCULOM = ?
              AND (((IDDIAOCORRENCIA IS NULL OR IDDIAOCORRENCIA IN ('DA', 'DC', 'DS'))
                     AND TO_DATE(TO_CHAR(DTHRAJUSTADA,'DD/MM/YYYY HH24:MI')) BETWEEN TO_DATE(?,'DD/MM/YYYY HH24:MI')
                                                                                 AND TO_DATE(?,'DD/MM/YYYY HH24:MI'))
               OR  (IDDIAOCORRENCIA = 'FA' AND TRUNC(DTHRAJUSTADA) = TO_DATE(?,'DD/MM/YYYY')+1 ) 
               OR  (IDDIAOCORRENCIA = 'FS' AND TRUNC(DTHRAJUSTADA) = TO_DATE(?,'DD/MM/YYYY')-1) 
               OR  (IDDIAOCORRENCIA = 'FC' AND TRUNC(DTHRAJUSTADA) = TO_DATE(?,'DD/MM/YYYY')))";
        // LEONARDOCARVALHO - 03/12/2015 - Adicionada order by por NRMARCACAOPONTO para corrigir a instabilidade de ausência abonada.
        $orderBy = 'DTHRMARCACAOPONTO, NRMARCACAOPONTO, NRCOLETOR';

        $params = array(
            $this->nrorg,
            $this->nrvinculom,
            $dtHrIniColeta,
            $dtHrFimColeta,
            $dtponto,
            $dtponto,
            $dtponto
        );
        $this->registros     = array();
        $idEntradaSaida      = self::ENTRADA;
        $idEntradaSaidaHBAnt = $idEntradaSaida;
        if(count($this->horario->getIntervalosHorario()) > 0){
            $dtHrtoleraAntesAnt  = $this->horario->currentHorario()->DTHRTOLERAANTES;
        }

        $marcacoesRegistros = GpeMarcacaoponto::getObjectsByWhere($where, $params, $orderBy);
        $registrosAutomaticos = array();
        if (count($marcacoesRegistros) != 0) {
            //Marcacoes Automaticas
            $intervalos = $this->horario->getIntervalosHorario();
            foreach ($intervalos as $intervalo) {
                if ($intervalo['CONTROLEMARCACAO'] == 'A') {
                    /** @var GpeParamorg $paramOrg */
                    $paramOrg = GpeParamorg::findOneByNrorg($this->nrorg);

                    $marcacaoAutomatica = new GpeMarcacaoponto();
                    $marcacaoAutomatica->setIdenquadrahorario(self::NAO);
                    $marcacaoAutomatica->setDthrmarcacaoponto(self::retornaDataDiaOcorrencia($intervalo['HORA'],
                                                                                             $this->data,
                                                                                             $intervalo['DIAOCORRENCIA']));

                    $marcacaoAutomatica->setDthrajustada(self::retornaDataDiaOcorrencia($intervalo['HORA'],
                                                                                        $this->data,
                                                                                        $intervalo['DIAOCORRENCIA']));
                    $marcacaoAutomatica->setIdmarcdesprezada(self::NAO);
                    $marcacaoAutomatica->setNrvinculom($this->nrvinculom);
                    $marcacaoAutomatica->setNrorg($this->nrorg);
                    $marcacaoAutomatica->setDsjustificativa('');
                    $marcacaoAutomatica->setIddiaocorrencia($intervalo['DIAOCORRENCIA']);
                    $marcacaoAutomatica->setNrcoletor($paramOrg->getNrcoletormarcautom());
                    $registroAutomatico = new RegistroPonto($this->data->format(DateUtil::FORMATO_BRASILEIRO),
                                                            $marcacaoAutomatica,
                                                            $intervalo['IDENTRADASAIDA'], $this->nrorg);
                    $registrosAutomaticos[] = $registroAutomatico;
                }
            }
        }

        /** @var RegistroPonto $registroAutomatico */
        foreach ($registrosAutomaticos as $registroAutomatico) {
            if (count($marcacoesRegistros) != 0) {
                foreach ($marcacoesRegistros as $key => $marcacaoRegistro) {
                    if ($marcacaoRegistro instanceof RegistroPonto) {
                        /** @var $marcacaoRegistro RegistroPonto */
                        $dataComp = $marcacaoRegistro->getMarcacao()->getDthrajustada();
                    } else {
                        /** @var $marcacaoRegistro GpeMarcacaoponto */
                        $dataComp = DateUtil::getDataDeString($marcacaoRegistro->getDthrajustada()->format(self::FORMATO_DATA_HORAMINUTO),
                            self::FORMATO_DATA_HORAMINUTO);
                    }
                    if (DateUtil::comparaDatas($dataComp,
                        $registroAutomatico->getMarcacao()->getDthrajustada(),
                        DateUtil::DEPOIS)
                    ) {
                        if  ($key == 0) {
                            $marcacoesAux[]     = $registroAutomatico;
                            $marcacoesRegistros = array_merge($marcacoesAux, $marcacoesRegistros);
                        }  else {
                            $marcacoesRegistros = self::inserePosicaoArray($key, $marcacoesRegistros, $registroAutomatico);
                        }
                        break;
                    } elseif ($key == (count($marcacoesRegistros) - 1)) {
                        $marcacoesRegistros[] = $registroAutomatico;
                    }
                }
            } else {
                $marcacoesRegistros[] = $registroAutomatico;
            }
        }

        //ver com o Newton de onde vem ParamEscala
        $paramEscala = array(
            'TRATA_PROJ_HOR_MIN' => self::SIM
        );

//        Preparação de Situações
        self::prepSits($idDiaCalendSeg, $horarioDiaSeguinte->getHorarioHistorico()->getIdtipohorario());

        //Verifica se existem ocorrências de Saida Projetada pro dia

        $nrOrgPadrao = FPA::getNrorgPadrao();
        $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrorgAndCdtipoprogocorrencia($nrOrgPadrao, self::IDENTIFICA_INTERVALO);
        
        $tipoDiaCalend = null;
        
        if ($this->idDiaCalend == self::FERIADO) {
            $tipoDiaCalend = 'FERIADO';
            $this->refAuxSaldos['FERIADO'] = true;
        } elseif ($this->idDiaCalend == self::PONTO_FACULTATIVO) {
            $tipoDiaCalend = 'PONTOFACULTATIVO';
        }

        $whereProgOcorSaida = "NRVINCULOM = ?
                           AND IDATIVO    = 'S'
                           AND NRORG      = ?
                           AND DTINICIOPROGOCOR = TO_DATE(?, 'DD/MM/YYYY')
                           AND DTFIMPROGOCOR = TO_DATE(?, 'DD/MM/YYYY')
                           AND NRMARCACAOPONTO IS NOT NULL
                           AND NRTIPOPROGOCORRENCIA = ?
                           AND NRINTERVALOHORARIO IS NOT NULL
                           AND IDPROGOCORCONFIRMADA = 'S'
                           AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                           AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)";
        $paramsProgOcorSaida = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $tipoProgOcor->getNrtipoprogocorrencia(),
            $tipoDiaCalend,
            $this->horario->getHorarioHistorico()->getIdtipohorario()
        );

        $programacoesIntervSaida = array();
        $ocorrenciasIntervSaida = PtoProgocorrencia::getObjectsByWhere($whereProgOcorSaida, $paramsProgOcorSaida);
        /** @var PtoProgocorrencia $programacaoSaida */
        foreach($ocorrenciasIntervSaida as $programacaoSaida){
            $arrayDiasSemana = str_split($programacaoSaida->getIddiassemana());
            if (!(is_null($programacaoSaida->getIddiassemana()) || $programacaoSaida->getIddiassemana() == '0000000' || !(isset($arrayDiasSemana[$diaSemana]) && $arrayDiasSemana[$diaSemana] == '1'))) {
                $programacoesIntervSaida[] = $programacaoSaida;
            }
        }

        if(count($programacoesIntervSaida) == 0){
            $programacoesIntervSaida = null;
        }
        else{
            $novoArray = array();

            foreach($programacoesIntervSaida as $programacaoSaida){
                $novoArray[$programacaoSaida->getNrmarcacaoponto()] = $programacaoSaida;
            }
            $programacoesIntervSaida = $novoArray;
        }

        $dtHrProjetada = null;
        $dtHrBaseProj  = null;

        foreach ($marcacoesRegistros as $marcacao) {
            if($marcacao instanceof RegistroPonto) {
                $registroInserir = $marcacao;
            } else {
                $registroInserir = new RegistroPonto($dtponto, $marcacao, $idEntradaSaida, $this->nrorg);
                $idEntradaSaida    = $idEntradaSaida == self::ENTRADA ? self::SAIDA : self::ENTRADA;
            }

            if(!is_null($dtHrProjetada)){
                $relacao = self::verificaRelacaoRegistroProjecao($registroInserir->getMarcacao()->getDthrajustada(),
                                                                 $dtHrProjetada, $dtHrBaseProj, $registroInserir->getIdEntradaSaida());
                if($relacao == 'DESPREZA'){
                    self::insereRegistroDesprezado($registroInserir, $idEntradaSaidaHBAnt,
                                                   $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj);
                }
                elseif($relacao == 'PROJETA'){
                    self::insereProjecaoERegistroNormal($registroInserir, $idEntradaSaidaHBAnt,
                                                        $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj);
                    $dtHrProjetada = null;
                }
                elseif($relacao == 'LIMPA_PROJECAO'){
//                    $registroInserir->setIdMarcacao('p');
                    self::insereRegistroNormal($registroInserir, $idEntradaSaidaHBAnt,
                        $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj);

                    $dtHrProjetada = null;
                }
                else{
                    self::insereRegistroNormal($registroInserir, $idEntradaSaidaHBAnt,
                                               $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj);
                    $dtHrProjetada = null;
                }
            }else{
                self::insereRegistroNormal($registroInserir, $idEntradaSaidaHBAnt,
                                           $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj, $programacoesIntervSaida);
            }
        }
        self::resetRegistros();

        self::verificaHorarioBase();
        self::verificaViradaDia();

        //Calculo de intervalos
        self::calcularIntervalosDia();

        //Transforma saídas e atrasos em falta caso não haja horas trabalhadas normais.
        self::transformaFaltas();

        self::geraResumosSituFreqsJaApurados();

        /* Cálculo do Adicional Noturno */
        $valorHoraNoturno = (60/52.5);
        $calculos = $this->calcSituFreq->getCalcSituacoesFreq();

        $horasTrabalhadas = ($calculos[$this->idTrabNot]['HORAS'] * $valorHoraNoturno);
        //$horasTrabalhadas = ($horasTrabalhadas - floor($horasTrabalhadas)) + ($calculos[$this->idTrabNot]['HORAS']);

        // LEONARDOCARVALHO - 21/12/2015 - Adicionado a soma de horas extras o '$this->idExtraNot' para quando as horas forem separadas
        $horasExtras  = ($calculos[$this->idExtraNot]['HORAS'] * $valorHoraNoturno);
        $horasExtras += ($calculos[$this->idExtraNot2]['HORAS'] * $valorHoraNoturno);
        //$horasExtras = (((int)$horasExtras) * $coeficienteAcrescimoNoturno) + ($calculos[$this->idExtraNot2]['HORAS']);

        $calculos['ADICIONAL_NOTURNO']['HORAS'] = $horasTrabalhadas + $horasExtras;

        $this->calcSituFreq->setCalcSituacoesFreq($calculos);

        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                                    $calculos['ADICIONAL_NOTURNO']['NRCALCULOSITUFREQ']);
        //Caso não haja associação específica para a organização de trabalho, busca a associação de
        //organização padrão
        if (!is_object($assocSituFreqPadrao)) {
            $nrOrgPadrao = FPA::getNrorgPadrao();
            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                                        $calculos['ADICIONAL_NOTURNO']['NRCALCULOSITUFREQ']);
        }
        if(is_object($assocSituFreqPadrao)){
            $alterou = false;
            /** @var PtoResumositufreq $currentResum */
            foreach ($this->resumosSituFreqs as &$currentResum) {
                if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $calculos['ADICIONAL_NOTURNO']['HORAS'];
                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                    $alterou = true;
                    break;
                }
            }
            if (!$alterou && $calculos['ADICIONAL_NOTURNO']['HORAS'] > 0) {
                $this->resumosSituFreqs[] = self::criaResumoSituFreq(null,
                                                                     null,
                                                                     null,
                                                                     $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                     $calculos['ADICIONAL_NOTURNO']['HORAS']);
            }
        }
        /* Fim do Cálculo do Adicional Noturno */

        // LEONARDOCARVALHO - 02/12/2015 - Cálculo de Saídas em Trabalho Noturno considerando horas compressivas
        /* Cálculo de Saídas em Trabalho Noturno */
        $horasSaidasNoturnas = ($calculos[self::SAIDAS_NOTURNAS]['HORAS'] / $valorHoraNoturno);
        $calculos[self::SAIDAS_NOTURNAS]['HORAS'] = $horasSaidasNoturnas;

        $this->calcSituFreq->setCalcSituacoesFreq($calculos);

        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
            $calculos[self::SAIDAS_NOTURNAS]['NRCALCULOSITUFREQ']);
        //Caso não haja associação específica para a organização de trabalho, busca a associação de
        //organização padrão
        if (!is_object($assocSituFreqPadrao)) {
            $nrOrgPadrao = FPA::getNrorgPadrao();
            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                $calculos[self::SAIDAS_NOTURNAS]['NRCALCULOSITUFREQ']);
        }
        if(is_object($assocSituFreqPadrao)){
            $alterou = false;
            /** @var PtoResumositufreq $currentResum */
            foreach ($this->resumosSituFreqs as &$currentResum) {
                if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                    $novoQtRefApurSituFreq = $calculos[self::SAIDAS_NOTURNAS]['HORAS'];
                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                    $alterou = true;
                    break;
                }
            }
            if (!$alterou && $calculos[self::SAIDAS_NOTURNAS]['HORAS'] > 0) {
                $this->resumosSituFreqs[] = self::criaResumoSituFreq(null,
                    null,
                    null,
                    $assocSituFreqPadrao->getNrsitufrequencia(),
                    $calculos[self::SAIDAS_NOTURNAS]['HORAS']);

            }
        }
        /* Fim Cálculo de Saídas em Trabalho Noturno */

        self::verificaProgramacoesOcorrencia($horarioDiaSeguinte, $idDiaCalendSeg);

        //<editor-fold desc="Vitor Peixoto 06/07/2015 Gera desconto de DSR de acordo com os parâmetros. TODO mover para uma funcao.">
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $calculosDeAusencias = array(self::ATRASOS_DIURNOS,
            self::ATRASOS_NOTURNOS,
            self::FALTAS_DIURNAS,
            self::FALTAS_NOTURNAS,
            self::SAIDAS_DIURNAS,
            self::SAIDAS_NOTURNAS);

        foreach($calculosDeAusencias as $calculoAusencia) {
            //<editor-fold desc="Busca a Associação de Situação de Frequência referente à Situações de falta">
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                $calcSituFreq[$calculoAusencia]['NRCALCULOSITUFREQ']);

            //Caso não haja associação específica para a organização de trabalho, busca a associação de organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                    $calcSituFreq[$calculoAusencia]['NRCALCULOSITUFREQ']);
            }
            //</editor-fold>

            if (is_object($assocSituFreqCalcSit)) {
                /** @var PtoSitufreqparam $parametrosFaltas */
                $parametrosFaltas = PtoSitufreqparam::findOneByNrorgAndNrsitufrequencia($this->nrorg, $assocSituFreqCalcSit->getNrsitufrequencia());
                if (!is_object($parametrosFaltas)) {
                    $nrOrgPadrao = FPA::getNrorgPadrao();
                    $parametrosFaltas = PtoSitufreqparam::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao, $assocSituFreqCalcSit->getNrsitufrequencia());
                }

                if (is_object($parametrosFaltas) && $parametrosFaltas->getIdperdedsr() == self::SIM) {
                    $this->refAuxSaldos['DSR_DESCONTADO'] += $calcSituFreq[$calculoAusencia]['HORAS'];
                }
            }
        }
        //</editor-fold>


        //<editor-fold desc="Vitor Peixoto 06/07/2015 Calcula e lança perda de DSR nos Domingos">
        //if($diaSemana == 0 && $this->geraDsr) { Só gera domingo
        //$this->refAuxSaldos['DSR_DESCONTADO'] -> Valor a descontar (em faltas)
        //$this->refAuxSaldos['FERIADO']        -> Se houve um feriado nessa semana
        if($this->geraDsr && !$this->refAuxSaldos['GEROU_DSR']) {
            if($this->refAuxSaldos['DSR_DESCONTADO'] > 0) {
                if($this->refAuxSaldos['FERIADO']) $this->refAuxSaldos['DSR_DESCONTADO'] *= 2;
                self::descontaDsr($this->refAuxSaldos['DSR_DESCONTADO']);
                $this->refAuxSaldos['GEROU_DSR'] = true;
                $this->refAuxSaldos['DSR_DESCONTADO'] = 0;
            }
        }
        else if($this->geraDsr && $this->idDiaCalend == self::FERIADO) {
            self::descontaDsr($this->refAuxSaldos['DSR_DESCONTADO']);
        }
        if($diaSemana == 0 && $this->geraDsr) {
            $this->refAuxSaldos['GEROU_DSR'] = false;
            $this->refAuxSaldos['FERIADO'] = false;
            $this->refAuxSaldos['DSR_DESCONTADO'] = 0;
        }
        //</editor-fold>

        // LEONARDOCARVALHO - 21/01/2016
        /* Gera Horas Extras do Trabalho quando Turno, Feriado e Domingo */
        self::extraTurnoFeriadoDomingo();
        /* Fim Gera Horas Extras do Trabalho quando Turno, Feriado e Domingo */

        self::resetRegistros();
        self::resetIntervalo();
        $this->horario->resetHorario();
    }

    public function limpaResumosNaoForcados(){
        /** @var PtoResumositufreq $resumoSituFreq */
        foreach($this->resumosSituFreqs as $key => $resumoSituFreq){
            if($resumoSituFreq->getIdforcasitufreq() != 'FORCA_SITU'){
                unset($this->resumosSituFreqs[$key]);
            }
        }
        $this->resumosSituFreqs = array_values($this->resumosSituFreqs);
    }

    private function verificaRelacaoRegistroProjecao($dtHrRegistro, &$dtHrProjetada, $dtHrBaseProj, $idEntradaSaidaRegistro){
        $relacao = 'LIMPA_PROJECAO';

        //Vitor Peixoto 29/05/2015 adicionada condição de igualdade
        if(DateUtil::comparaDatas($dtHrRegistro, $dtHrProjetada, DateUtil::ANTES)/* ||
           DateUtil::comparaDatas($dtHrRegistro, $dtHrProjetada, DateUtil::IGUAL)*/){
            $relacao = 'DESPREZA';
        }
        elseif(DateUtil::comparaDatas($dtHrRegistro, $dtHrProjetada, DateUtil::DEPOIS)){
            if(DateUtil::comparaDatas($dtHrRegistro, $dtHrBaseProj, DateUtil::DEPOIS)){
                $dtHrProjetada = $dtHrBaseProj;
                $relacao = 'PROJETA';
            }
            else{
                if($idEntradaSaidaRegistro == self::SAIDA){
                    if(DateUtil::comparaDatas($dtHrRegistro, $dtHrBaseProj, DateUtil::ANTES)){
                        $relacao = 'PROJETA';
                    }else{
                        $relacao = 'DESPREZA';
                    }
                }
            }
        }else{
            if($idEntradaSaidaRegistro == self::SAIDA){
                $relacao = 'DESPREZA';
            }
        }

        return $relacao;
    }

    private function insereRegistroDesprezado($registroInserir, $idEntradaSaidaHBAnt, $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj){
        $this->registros[] = $registroInserir;
        self::endRegistro();
        self::setEnquadraHorario($idEntradaSaidaHBAnt, $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj, true);
    }

    private function insereRegistroNormal($registroInserir, &$idEntradaSaidaHBAnt, &$dtHrtoleraAntesAnt, &$dtHrProjetada, &$dtHrBaseProj, $programacoesIntervSaida = null){
        $this->registros[] = $registroInserir;
        self::endRegistro();
        if(count($this->horario->getIntervalosHorario()) > 0){
            self::setEnquadraHorario($idEntradaSaidaHBAnt, $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj, false, false, $programacoesIntervSaida);
        }
    }

    private function insereProjecaoERegistroNormal($registroInserir, &$idEntradaSaidaHBAnt, &$dtHrtoleraAntesAnt, &$dtHrProjetada, &$dtHrBaseProj){
        //Inclusão de registro Hora Projetada
        $stDataHrProjetada = $dtHrProjetada->format(DateUtil::FORMATO_BRASILEIRO);

        //Dia Ocorrência
        $diaOcorrencia = self::retornaDiaOcorrencia($dtHrProjetada);

        /** @var GpeParamorg $paramOrg */
        $paramOrg     = GpeParamorg::findOneByNrorg($this->nrorg);

        $marcacaoHrProjetar = new GpeMarcacaoponto();
        $marcacaoHrProjetar->setIdenquadrahorario(self::NAO);
        $marcacaoHrProjetar->setDthrmarcacaoponto($dtHrProjetada);
        $marcacaoHrProjetar->setDthrajustada($dtHrProjetada);
        $marcacaoHrProjetar->setIdmarcdesprezada(self::NAO);
        $marcacaoHrProjetar->setNrvinculom($this->nrvinculom);
        $marcacaoHrProjetar->setNrorg($this->nrorg);
        $marcacaoHrProjetar->setDsjustificativa('');
        $marcacaoHrProjetar->setIddiaocorrencia($diaOcorrencia);
        $marcacaoHrProjetar->setNrcoletor($paramOrg->getNrcoletormarcprojetada());

        $registroHrProjetar = new RegistroPonto($stDataHrProjetada, $marcacaoHrProjetar, self::ENTRADA,
                                                $this->nrorg);

        $this->registros[] = $registroHrProjetar;
        self::endRegistro();
        self::setEnquadraHorario($idEntradaSaidaHBAnt, $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj, false, true);


        //Insere registro normal
        $this->registros[] = $registroInserir;
        self::endRegistro();
        self::setEnquadraHorario($idEntradaSaidaHBAnt, $dtHrtoleraAntesAnt, $dtHrProjetada, $dtHrBaseProj);
    }

    private function geraResumosSituFreqsJaApurados(){
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

        foreach($calcSituFreq as $currentCalcSituFreq){
            if($currentCalcSituFreq['HORAS'] != 0){
                /** @var PtoAssocsitufreq $assocSituFreq */
                $assocSituFreq = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq(
                    $this->nrorg, $currentCalcSituFreq['NRCALCULOSITUFREQ']);
                if(!is_object($assocSituFreq)){
                    $nrOrgPadrao = FPA::getNrorgPadrao ();

                    $assocSituFreq = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq(
                        $nrOrgPadrao, $currentCalcSituFreq['NRCALCULOSITUFREQ']);

                    if(is_object($assocSituFreq)){
                        $nrSituFreq = $assocSituFreq->getNrsitufrequencia();
                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach ($this->resumosSituFreqs as &$currentResum) {
                            if ($currentResum->getNrsitufrequencia() == $assocSituFreq->getNrsitufrequencia()) {
                                $currentResum->setQtrefapursitufreq($currentCalcSituFreq['HORAS']);
                                $alterou = true;
                                break;
                            }
                        }
                        if (!$alterou) {
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                                                                                 $assocSituFreq->getNrsitufrequencia(),
                                                                                 $currentCalcSituFreq['HORAS']);
                        }
                    }
                    else{
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null, null, $currentCalcSituFreq['HORAS']);
                    }
                }
                /* Vitor Peixoto 25/05/2015 else para Situações de Frequência Org Trabalho */
                else{
                    $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                                                                         $assocSituFreq->getNrsitufrequencia(),
                                                                         $currentCalcSituFreq['HORAS']);
                }
                /* END Vitor Peixoto */
            }
        }
    }

    private function verificaAusenciaMarcacao()
    {
        //Verifica Ausência de Marcação
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $qtdMarcacoes = 0;
        /** @var RegistroPonto $registro */
        foreach ($this->registros as $registro) {
            if (($registro->getIdMarcacao() == self::REGISTRO || $registro->getIdMarcacao() == self::DIGITADA) || $registro->getIdMarcacao() == self::AUTOMATICA /*|| $registro->getIdMarcacao() == self::PROJETADA*/){
                $qtdMarcacoes++;
            }
        }
        if ($qtdMarcacoes % 2 != 0) {
            $calcSituFreq[self::AUSENCIA_MARCACAO]['HORAS'] = 1;
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    public function calcularIntervalosDia()
    {
        $registrosNDesprez = array();
        foreach ($this->registros as $registro) {
            if ($registro->getMarcacao()->getIdmarcdesprezada() == self::NAO) {
                $registrosNDesprez[] = $registro;
            }
        }
        $this->registrosNDesprez = $registrosNDesprez;

        if(count($this->registrosNDesprez) > 0){
            $this->primeiraMarcacao  = $this->registrosNDesprez[0];
            $this->ultimaMarcacao    = $this->registrosNDesprez[(count($this->registrosNDesprez) - 1)];
        }

        //ver com o Newton de onde vem ParamEscala
        $paramEscala = array(
            'TRATA_PROJ_HOR_MIN' => self::SIM
        );

        $this->calcSituFreq = new CalculoSituacaoFrequencia();

        self::verificaAusenciaMarcacao();

        if (count($this->registros) > 0) {
            self::totalizaIntervalos($paramEscala);
        } else {
            $this->intervalosControle = array();
        }
    }

    /**
     * @param $idEntradaSaidaHBAnt
     * @param $dtHrToleAntesAnt
     * @param $dtHrProjetada
     * @param $dtHrBaseProj
     * @param bool $idDespreza
     * @param bool $idBalizaDesprezada
     * @param null $programacoesIntervSaida
     */
    public function setEnquadraHorario(&$idEntradaSaidaHBAnt, &$dtHrToleAntesAnt, &$dtHrProjetada, &$dtHrBaseProj,
                                       $idDespreza = false, $idBalizaDesprezada = false, $programacoesIntervSaida = null)
    {
        if(!$idDespreza) {
            $enqHor = self::NAO;

            $inseriuBaliza = false;
            $dtHrAjustada = self::currentRegistro()->getMarcacao()->getDthrajustada();
            $dtHrAjustada = $dtHrAjustada->format(self::FORMATO_DATA_HORAMINUTO);
            $dtHrAjustada = DateUtil::getDataDeString($dtHrAjustada, self::FORMATO_DATA_HORAMINUTO);
            $intervaloFora = false;

            if (!$this->horario->getEndOfHorario()) {
                $idEntradaSaidaAux = $this->horario->currentHorario()->IDENTRADASAIDA;
                do {
                    $inseriuBaliza = false;
                    $dtHrToleAntes = $this->horario->currentHorario()->DTHRTOLERAANTES;
                    $dtHrToleApos = $this->horario->currentHorario()->DTHRTOLERAAPOS;
                    if (DateUtil::comparaDatas($dtHrAjustada, $dtHrToleApos, DateUtil::DEPOIS)) {
                        $idEntradaSaidaHBAnt = $this->horario->getEndOfHorario() ? $idEntradaSaidaHBAnt : $idEntradaSaidaAux;
                        $dtHrToleAntesAnt = $dtHrToleAntes;

                        /** Horário corrente deve ser associado ao registro para que seja possível verificar posteriormente
                         *  o parâmetro HRPROJETARINTERVALO.
                         */
                        self::currentRegistro()->setHorarioCorrente($this->horario->currentHorario());

                        //<editor-fold desc="Vitor Peixoto 29/06 Código antigo para considerar abonos com balizas dentro (obsoleto)">
                        /*$whereProgIntervalo = "NRVINCULOM = ?
                                                                   AND NRORG  = ?
                                                                   AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                                                                   AND NRMARCACAOPONTO IS NOT NULL
                                                                   AND NRINTERVALOHORARIO IS NULL
                                                                   AND IDPROGOCORCONFIRMADA = 'S'
                                                                   AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                                                                   AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)";

                                                $paramsProgIntervalo = array(
                                                    $this->nrvinculom,
                                                    $this->nrorg,
                                                    $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                                                    $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                                                    $this->idDiaCalend,
                                                    $this->horario->getHorarioHistorico()->getIdtipohorario()
                                                );

                                                $progOcorIntervalo = PtoProgocorrencia::getObjectsByWhere($whereProgIntervalo, $paramsProgIntervalo);


                                                /** @var PtoProgocorrencia $programacaoOcor * /
                                                foreach($progOcorIntervalo as $programacaoOcor){
                                                    /** @var PtoTipoprogocorrencia $tipoProgOcor * /
                                                    $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoOcor->getNrtipoprogocorrencia());
                                                    if($tipoProgOcor->getCdtipoprogocorrencia() == self::SAIDA_AUTORIZADA){
                                                        if(!is_null($programacaoOcor->getMarcacaoponto())) {
                                                            $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->execute("SELECT DTHRAJUSTADA FROM GPE_MARCACAOPONTO WHERE NRORG = $this->nrorg AND NRMARCACAOPONTO = ".$programacaoOcor->getMarcacaoponto()->getNrmarcacaoponto());
                                                            $marcacao = DateUtil::getDataDeString($result->fetchColumn(0), 'd/m/Y H:i:s');
                                                            if(DateUtil::comparaDatas($this->horario->currentHorario()->DTHORABASE, $marcacao, DateUtil::DEPOIS)) {
                                                                /** @var $proximaMarcacao \Folha\Entities\GpeMarcacaoponto * /
                                                                $whereClause = array($this->nrorg,
                                                                                     $this->nrvinculom,
                                                                                     $marcacao->format(DateUtil::FORMATO_BRASILEIRO),
                                                                                     $marcacao->format(DateUtil::FORMATO_BRASILEIRO_DATAHORA));

                                                                $proximaMarcacao = GpeMarcacaoponto::getObjectByWhere("NRORG      = ? AND
                                                                                                                       NRVINCULOM = ? AND
                                                                                                                       TRUNC(DTHRAJUSTADA) = ?
                                                                                                                       AND DTHRAJUSTADA    > ?
                                                                                                                       ORDER BY DTHRAJUSTADA", $whereClause);

                                                                if(DateUtil::comparaDatas($this->horario->currentHorario()->DTHORABASE, $proximaMarcacao->getDthrajustada(), DateUtil::ANTES)) {
                                                                    $idBalizaDesprezada = true;
                                                                }
                                                            }
                                                        }
                                                    }
                                                }*/
                        //</editor-fold>


                        if($this->escalaHistorico->getIdhextranmarcinterv() == self::SIM) {
                            $whereProgIntervalo = "NRVINCULOM = ?
                                               AND NRORG      = ?
                                               AND IDATIVO    = 'S'
                                               AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                                               AND NRMARCACAOPONTO IS NOT NULL
                                               AND (NRINTERVALOHORARIO IS NOT NULL OR NRTIPOPROGOCORRENCIA = ?)
                                               AND IDPROGOCORCONFIRMADA = 'S'
                                               AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                                               AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)";

                            $paramsProgIntervalo = array(
                                $this->nrvinculom,
                                $this->nrorg,
                                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                                26, //Programação de intervalo não-programado. TODO implementar maneira menos estática
                                $this->idDiaCalend,
                                $this->horario->getHorarioHistorico()->getIdtipohorario()
                            );

                            $progOcorIntervalo = PtoProgocorrencia::getObjectsByWhere($whereProgIntervalo, $paramsProgIntervalo);

                            /** @var PtoProgocorrencia $programacaoOcor */
                            foreach ($progOcorIntervalo as $programacaoOcor) {
                                /** @var PtoTipoprogocorrencia $tipoProgOcor */
                                $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoOcor->getNrtipoprogocorrencia());
                                if ($tipoProgOcor->getCdtipoprogocorrencia() == self::IDENTIFICA_INTERVALO ||
                                    $tipoProgOcor->getCdtipoprogocorrencia() == self::IDENTIFICA_INTERVALO_NP) {
                                    $intervaloSaida = $programacaoOcor->getIntervalohorario();
                                    if (!is_null($intervaloSaida)) {
                                        $whereClause = "NRORG             = ?
                                                    AND NRHORDIAM         = ?
                                                    AND HRENTRADA         >
                                                       (SELECT INTERVALOS.HRSAIDA
                                                          FROM GPE_INTERVALOSHORARIO INTERVALOS
                                                         WHERE INTERVALOS.NRORG   = ?
                                                           AND INTERVALOS.NRINTERVALOHORARIO = ?
                                                           AND INTERVALOS.NRHORDIAM = ?
                                                       ) ORDER BY HRENTRADA";

                                        $paramsIntervaloSaida = array($this->nrorg,
                                            $intervaloSaida->getNrhordiam(),
                                            $this->nrorg,
                                            $intervaloSaida->getNrintervalohorario(),
                                            $intervaloSaida->getNrhordiam());

                                        /** @var GpeIntervaloshorario $intervaloEntrada */
                                        $intervaloEntrada = GpeIntervaloshorario::getObjectByWhere($whereClause, $paramsIntervaloSaida);
                                        if(!is_object($intervaloEntrada) || !is_object($intervaloSaida)){
                                            throw new \Exception('Intervalo das Ocorrências não encontrado.');
                                        }
                                        if ($intervaloSaida->getHrsaida() == str_replace(':', '', $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_HORA_MINUTO)) ||
                                            $intervaloEntrada->getHrentrada() == str_replace(':', '', $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_HORA_MINUTO))
                                        ) {
                                            $idBalizaDesprezada = true;
                                        }
                                    }
                                    else {
                                        $intervalos = $intervaloEntrada = $this->horario->getIntervalosHorario();
                                        foreach($intervalos as $key => $intervalo) {
                                            if($intervalo['IDENTRADASAIDA'] == self::SAIDA && isset($intervalos[$key + 1]['HORA'])) {
                                                if ($intervalo['HORA'] == str_replace(':', '', $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_HORA_MINUTO)) ||
                                                    $intervalos[$key + 1]['HORA'] == str_replace(':', '', $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_HORA_MINUTO))
                                                ) {
                                                    $idBalizaDesprezada = true;
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        
                        //Inclusão de registro Baliza
                        if($idBalizaDesprezada) $this->balizasDesprezadas[] = $this->horario->currentHorario()->DTHORABASE;
                        /*if(!is_numeric(array_search($this->horario->currentHorario()->DTHORABASE, $this->balizasDesprezadas))) */
                        //$arrayCount = array_count_values($this->balizasDesprezadas);
                        if(!is_numeric(array_search($this->horario->currentHorario()->DTHORABASE, $this->registrosEnquadrados)) &&
                           !is_numeric(array_search($this->horario->currentHorario()->DTHORABASE, $this->balizasInseridas))) {
                            self::insereBaliza($idBalizaDesprezada);
                            $this->balizasInseridas[] = $this->horario->currentHorario()->DTHORABASE;
                            $inseriuBaliza = true;
                        }
                        $idBalizaDesprezada = false;
                        $this->horario->nextHorario();
                    }
                    else if(DateUtil::comparaDatas($dtHrAjustada, $dtHrToleApos, DateUtil::IGUAL) && // Se a data estiver dentro da tolerância
                            $this->escalaHistorico->getIdhextranmarcinterv() == self::SIM         && // Se estiver parametrizado para não gerar extra
                            $this->horario->getIndexHorario() != 0 &&                                // Se nao for a primeira entrada
                            $this->horario->getIndexHorario() != count($this->horario->getIntervalosHorario())-1) { // E nem for a última saída
                        $entradaIntervalo = (count($this->balizasDesprezadas) > 0);
                        $this->balizasDesprezadas[] = $this->horario->currentHorario()->DTHORABASE;
                        if($this->horario->currentHorario()->IDENTRADASAIDA == self::currentRegistro()->getIdEntradaSaida()) {
                            self::currentRegistro()->getMarcacao()->setIdenquadrahorario(self::SIM);//self::NAO);
                            $enqHor = self::SIM;//self::NAO;
                        }
                        else {
                            self::currentRegistro()->getMarcacao()->setIdenquadrahorario(self::NAO);
                            $enqHor = self::NAO;
                        }
                        $intervaloFora = true;
                        if($entradaIntervalo) $this->horario->nextHorario();
                    }
                } while ((DateUtil::comparaDatas($dtHrToleApos, $dtHrAjustada, DateUtil::ANTES)) &&
                    !($this->horario->getEndOfHorario()));

                if (!$this->horario->getEndOfHorario() && !$intervaloFora) {
                    if (!(DateUtil::comparaDatas($dtHrToleAntes, $dtHrAjustada, DateUtil::DEPOIS)) &&
                        !(DateUtil::comparaDatas($dtHrToleApos, $dtHrAjustada, DateUtil::ANTES)) &&
                        self::currentRegistro()->getIdEntradaSaida() == $this->horario->currentHorario()->IDENTRADASAIDA) {

                        $enqHor = self::SIM;
                        if ($this->horario->currentHorario()->AJUSTEMARCACAO == self::SEMPRE) {
                            $novaDtHrAjustada = $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_DATA_HORAMINUTO);
                            $novaDtHrAjustada = DateUtil::getDataDeString($novaDtHrAjustada, self::FORMATO_DATA_HORAMINUTO);
                            $dtHrAjustada = $novaDtHrAjustada;
                        } else if ($this->horario->currentHorario()->AJUSTEMARCACAO == self::AJUSTA_SE_MAIOR) {
                            if (DateUtil::comparaDatas($dtHrAjustada, $this->horario->currentHorario()->DTHORABASE, DateUtil::DEPOIS)) {
                                $dtHrAjustada = $this->horario->currentHorario()->DTHORABASE;
                            }
                        } else if ($this->horario->currentHorario()->AJUSTEMARCACAO == self::AJUSTA_SE_MENOR) {
                            if (DateUtil::comparaDatas($dtHrAjustada, $this->horario->currentHorario()->DTHORABASE)) {
                                $dtHrAjustada = $this->horario->currentHorario()->DTHORABASE;
                            }
                        }
                        $idEntradaSaidaHBAnt = $this->horario->getEndOfHorario() ? $idEntradaSaidaHBAnt : $idEntradaSaidaAux;
                        $dtHrToleAntesAnt = $dtHrToleAntes;

                        /** Horário corrente deve ser associado ao registro para que seja possível verificar posteriormente
                         *  o parâmetro HRPROJETARINTERVALO.
                         */
                        self::currentRegistro()->setHorarioCorrente($this->horario->currentHorario());

                        $this->horario->nextHorario();
                    }
                }
            }
            $idDentroHrBase = self::getRegistroAnterior()->getIdDentroHoraBase();

            if (($idEntradaSaidaHBAnt == self::ENTRADA) &&
                !(DateUtil::comparaDatas($dtHrToleAntesAnt, $dtHrAjustada, DateUtil::DEPOIS))
            ) {
                if(!$this->horario->getEndOfHorario()) {
                    $idDentroHrBase = self::SIM;
                }
            }
            if (($idEntradaSaidaHBAnt == self::SAIDA) &&
                !(DateUtil::comparaDatas($dtHrToleAntesAnt, $dtHrAjustada, DateUtil::DEPOIS))
            ) {
                $idDentroHrBase = self::NAO;
            }

            //<editor-fold desc="Vitor Peixoto 16/06/2015 Correção erros na definição do parâmetro HB">
            $dtHrAjustada = self::currentRegistro()->getMarcacao()->getDthrajustada();
            $dtHrAjustada = $dtHrAjustada->format(self::FORMATO_DATA_HORAMINUTO);
            $dtHrAjustada = DateUtil::getDataDeString($dtHrAjustada, self::FORMATO_DATA_HORAMINUTO);

            $intervalosHorario = $this->horario->getIntervalosHorario();

            if($this->escalaHistorico->getIdhextranmarcinterv() == self::SIM) {
                foreach ($intervalosHorario as $key => $intervaloAtual) {
                    if ($intervaloAtual['IDENTRADASAIDA'] == 'E') {
                        $dtHrIntervalo = $intervaloAtual['DTHORABASE']->format(self::FORMATO_DATA_HORAMINUTO);
                        $dtHrIntervalo = DateUtil::getDataDeString($dtHrIntervalo, self::FORMATO_DATA_HORAMINUTO);

                        $dtHrIntervaloSaida = $intervalosHorario[$key + 1]['DTHORABASE']->format(self::FORMATO_DATA_HORAMINUTO);
                        $dtHrIntervaloSaida = DateUtil::getDataDeString($dtHrIntervaloSaida, self::FORMATO_DATA_HORAMINUTO);

                        // Vítor Peixoto 02/07 ifs para considerar marcacoes feitas no horario das balizas, mas que tem o getIdEntradaSaida contrário
                        if(DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervalo, DateUtil::IGUAL)      && // Se tiver o mesmo horário da entrada
                           self::currentRegistro()->getMarcacao()->getIdenquadrahorario() == self::NAO && // e não enquadrar, houve outro registro que enquadrou,
                           //(!is_numeric(array_search($dtHrIntervalo, $this->balizasDesprezadas)))      && // e se esse registro não estiver desprezado
                           $key != 0) {                                                                   // nem for o primeiro

                            $idDentroHrBase = self::SIM;
                        }
                        else if(DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervaloSaida, DateUtil::IGUAL) && // Se tiver o mesmo horário da saída
                                self::currentRegistro()->getMarcacao()->getIdenquadrahorario() == self::NAO && // e não enquadrar, houve outro registro que enquadrou,
                                (!is_numeric(array_search($dtHrIntervaloSaida, $this->balizasDesprezadas)))) { // e se esse registro não estiver desprezado

                            $idDentroHrBase = self::NAO;

                        }
                        /* Modificação ifs Vitor Peixoto 27/07/2015
                        if((DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervalo,      DateUtil::IGUAL)  ||
                                DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervaloSaida, DateUtil::IGUAL)) &&
                            self::currentRegistro()->getMarcacao()->getIdenquadrahorario() == self::NAO  &&
                            $key != 0 /&& $key != (count($intervalosHorario) -2)/ && //Se for a primeira ou a última entrada
                            (self::currentRegistro()->getIdEntradaSaida() == self::SAIDA ? (!is_numeric(array_search($dtHrIntervaloSaida, $this->balizasDesprezadas))) :
                                                                                           (!is_numeric(array_search($dtHrIntervalo, $this->balizasDesprezadas))))) {

                            $idDentroHrBase = self::NAO;
                        }*/
                        /*else if((DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervalo,      DateUtil::IGUAL)  ||
                                DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervaloSaida, DateUtil::IGUAL)) &&
                            self::currentRegistro()->getMarcacao()->getIdenquadrahorario() == self::NAO  &&
                            $key != 0 && (self::currentRegistro()->getIdEntradaSaida() == self::SAIDA ? ($key != (count($intervalosHorario) -2)) : true) &&
                            (self::currentRegistro()->getIdEntradaSaida() == self::SAIDA ? (is_numeric(array_search($dtHrIntervaloSaida, $this->balizasDesprezadas))) :
                                                                                           (is_numeric(array_search($dtHrIntervalo,      $this->balizasDesprezadas))))) {
                            $idDentroHrBase = self::SIM;
                        }*/
                        else if (DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervalo, DateUtil::DEPOIS) &&
                            DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervaloSaida, DateUtil::ANTES)
                        ) {

                            $idDentroHrBase = self::SIM;
                        } else if ((count($intervalosHorario) - 1) >= ($key + 2)) {
                            $dtHrIntervalo = $intervalosHorario[$key + 2]['DTHORABASE']->format(self::FORMATO_DATA_HORAMINUTO);
                            $dtHrIntervalo = DateUtil::getDataDeString($dtHrIntervalo, self::FORMATO_DATA_HORAMINUTO);

                            if (DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervalo, DateUtil::ANTES) &&
                                DateUtil::comparaDatas($dtHrAjustada, $dtHrIntervaloSaida, DateUtil::DEPOIS) &&
                                is_numeric(array_search($dtHrIntervaloSaida, $this->balizasDesprezadas))
                            ) {
                                $idDentroHrBase = self::SIM;
                            }
                        }
                    }
                }
            }
            //</editor-fold>

            // Vitor Peixoto 17/06/2015 "Marreta" para resolver problemas de identificação de intervalo
            /*if ($idDentroHrBase == self::SIM /*&& $idEntradaSaidaHBAnt == self::ENTRADA* /) {
            // END Vitor Peixoto 17/06/2015
                self::currentRegistro()->setIntervaloBaseIni($dtHrToleAntesAnt);
                if (isset($this->horario->currentHorario()->DTHORABASE)) {
                    self::currentRegistro()->setIntervaloBaseFim($this->horario->currentHorario()->DTHORABASE);
                    $enqHor = self::NAO;
                }
            }*/

            if($enqHor) $this->registrosEnquadrados[] = $dtHrAjustada;
            self::currentRegistro()->getMarcacao()->setIdenquadrahorario($enqHor);
            self::currentRegistro()->setIdDentroHoraBase($idDentroHrBase);
            self::currentRegistro()->getMarcacao()->setDthrajustada($dtHrAjustada);

            $existeSaidaRegistro = false;
            if(!is_null($programacoesIntervSaida)){
                if(array_key_exists(self::currentRegistro()->getMarcacao()->getNrmarcacaoponto(),
                                    $programacoesIntervSaida)){
                    $existeSaidaRegistro = true;
                }
            }

            //Verifica se existe horário a projetar
            if ($this->escalaHistorico->getIdprojetaintervalo() == self::SIM) {
                if($existeSaidaRegistro){
                    /** @var PtoProgocorrencia $programacaoSaida */
                    $programacaoSaida = $programacoesIntervSaida[self::currentRegistro()->getMarcacao()->getNrmarcacaoponto()];
                    /** @var GpeIntervaloshorario $intervaloHorario */
                    $intervaloHorario = GpeIntervaloshorario::findOneByNrorgAndNrintervalohorario($programacaoSaida->getNrorg(),
                                                                                                  $programacaoSaida->getNrintervalohorario());

                    $horarioIntervalo = array('HORA'                 => $intervaloHorario->getHrsaida(),
                                              'DTHORABASE'           => self::retornaDataDiaOcorrencia(
                                                                              $intervaloHorario->getHrsaida(),
                                                                              $this->data,
                                                                              $intervaloHorario->getIddiaocorresaida()),
                                              'DTHRTOLERAANTES'      => self::retornaDataDiaOcorrencia(
                                                                              $intervaloHorario->getHrtoleraantesaida(),
                                                                              $this->data,
                                                                              $intervaloHorario->getIddiaocorresaida()),
                                              'TOLERANCIAANTES'      => $intervaloHorario->getHrtoleraantesaida(),
                                              'DTHRTOLERAAPOS'       => self::retornaDataDiaOcorrencia(
                                                                              $intervaloHorario->getHrtolerapostsaida(),
                                                                              $this->data,
                                                                              $intervaloHorario->getIddiaocorresaida()),
                                              'TOLERANCIAAPOS'       => $intervaloHorario->getHrtolerapostsaida(),
                                              'HORAININUCLEO'        => $intervaloHorario->getHrinicionucleo(),
                                              'HORAFIMNUCLEO'        => $intervaloHorario->getHrfimnucleo(),
                                              'DIAOCORRENCIA'        => $intervaloHorario->getIddiaocorresaida(),
                                              'CONTROLEMARCACAO'     => $intervaloHorario->getIdctrlmarcsaida(),
                                              'AJUSTEMARCACAO'       => $intervaloHorario->getIdajustemarcsaida(),
                                              'HRPROJETARINTERVALO'  => $intervaloHorario->getHrprojetarintervalo(),
                                              'DSINTERVALOPROJETADO' => $intervaloHorario->getDsintervaloprojetado(),
                                              'IDENTRADASAIDA'       => 'S');
                    $horarioIntervalo = (object)$horarioIntervalo;
                    self::currentRegistro()->setHorarioCorrente($horarioIntervalo);

                    /*while(!(DateUtil::comparaDatas($horarioIntervalo->DTHORABASE, $this->horario->currentHorario()->DTHORABASE, DateUtil::IGUAL)) &&
                          $this->horario->currentHorario()->IDENTRADASAIDA != $horarioIntervalo->IDENTRADASAIDA){
                        if(DateUtil::comparaDatas($horarioIntervalo->DTHORABASE, $this->horario->currentHorario()->DTHORABASE, DateUtil::ANTES)){
                            $this->horario->prevHorario();
                        }
                        else{
                            $this->horario->nextHorario();
                        }
                    }*/

                    $dtHrIntervalo = $this->horario->currentHorario()->DTHORABASE->format(self::FORMATO_DATA_HORAMINUTO);
                    $dtHrIntervalo = DateUtil::getDataDeString($dtHrIntervalo, self::FORMATO_DATA_HORAMINUTO);

                    $dtHrAjustada = self::currentRegistro()->getMarcacao()->getDthrajustada();
                    $dtHrAjustada = $dtHrAjustada->format(self::FORMATO_DATA_HORAMINUTO);
                    $dtHrAjustada = DateUtil::getDataDeString($dtHrAjustada, self::FORMATO_DATA_HORAMINUTO);

                    if(($this->horario->getIndexHorario()) == (count($this->horario->getIntervalosHorario())-1)) {
                        $intervalosHorario = $this->horario->getIntervalosHorario();

                        if (DateUtil::comparaDatas($dtHrIntervalo, $dtHrAjustada, DateUtil::ANTES)) {
                            $this->horario->nextHorario();
                        }
                    }
                    else if(DateUtil::comparaDatas($dtHrIntervalo, $dtHrAjustada, DateUtil::ANTES)/* && !$inseriuBaliza*/) {
                        $this->horario->nextHorario();
                    }

                    if(!$this->horario->getEndOfHorario() &&
                       self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO != '' &&
                       !is_null(self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO)){
                        $dtHrProjetada = self::somarHoraMinuto(self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO,
                            self::currentRegistro()->getMarcacao()->getDthrajustada());
                        //<editor-fold desc="Gambiarra Vitor Peixoto 18/09/2015 Corrigir projeção errada por variação de hora base">
                        if(DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                $this->horario->currentHorario()->DTHORABASE)/3600, false) == "0000") {
                            $this->horario->nextHorario();
                            $intervBaseProj = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false);
                            $dtHrBaseProj   = self::somarHoraMinuto($intervBaseProj, self::currentRegistro()->getMarcacao()->getDthrajustada());
                            $this->horario->prevHorario();
                        }
                        // Corrige problemas quando a marcação ocorre antes do intervalo previsto
                        else if (DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false) <= "0000"){
                            $diferenca = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false);

                            while(DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                                                                                  $this->horario->currentHorario()->DTHORABASE)/3600, false) <= "0000") {
                                $this->horario->nextHorario();
                            }
                            $intervBaseProj = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false);
                            $dtHrBaseProj   = self::somarHoraMinuto($intervBaseProj, self::currentRegistro()->getMarcacao()->getDthrajustada());
                            while(DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                        $this->horario->currentHorario()->DTHORABASE)/3600, false) != $diferenca) {
                                $this->horario->prevHorario();
                            }
                        }
                        else {
                            $diferenca = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false);

                            while(DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                        $this->horario->currentHorario()->DTHORABASE)/3600, false) > self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO) {
                                $this->horario->prevHorario();
                            }
                            $intervBaseProj = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                    $this->horario->currentHorario()->DTHORABASE)/3600, false);
                            $dtHrBaseProj   = self::somarHoraMinuto($intervBaseProj, self::currentRegistro()->getMarcacao()->getDthrajustada());
                            while(DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                        $this->horario->currentHorario()->DTHORABASE)/3600, false) != $diferenca) {
                                $this->horario->nextHorario();
                            }
                        }
                        //</editor-fold>
                    }
                }
                else{
                    if (self::currentRegistro()->getIdEntradaSaida() == self::SAIDA) {
                        if (is_object(self::currentRegistro()->getHorarioCorrente()) &&
                            self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO != '' &&
                            !is_null(self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO) &&
                            !$this->horario->getEndOfHorario()
                        ) {
                            $geraDados = true;

                            //Vitor Peixoto 03/07/2015 Caso não haja identificacao de intervalo
                            if(is_null($programacoesIntervSaida)) $geraDados = false;
                            /** @var PtoProgocorrencia $programacao */
                            
                            if($geraDados){
                                foreach($programacoesIntervSaida as $programacao){
                                    /** @var GpeIntervaloshorario $intervaloHorario */
                                    $intervaloHorario = GpeIntervaloshorario::findOneByNrorgAndNrintervalohorario($programacao->getNrorg(),
                                                                                                                  $programacao->getNrintervalohorario()
                                                                                                                  );
                                    if($intervaloHorario->getDsintervaloprojetado() == self::currentRegistro()->getHorarioCorrente()->DSINTERVALOPROJETADO){
                                        $geraDados = false;
                                    }
                                }

                                $dtHrProjetada = self::somarHoraMinuto(self::currentRegistro()->getHorarioCorrente()->HRPROJETARINTERVALO,
                                    self::currentRegistro()->getMarcacao()->getDthrajustada());
                                $intervBaseProj = DateUtil::getHoraStringDeFloat(DateUtil::getIntervaloEmSegundos(self::currentRegistro()->getHorarioCorrente()->DTHORABASE,
                                        $this->horario->currentHorario()->DTHORABASE)/3600, false);
                                $dtHrBaseProj   = self::somarHoraMinuto($intervBaseProj, self::currentRegistro()->getMarcacao()->getDthrajustada());
                            }
                            else{
                                self::currentRegistro()->setHorarioCorrente(null);
                            }
                        }
                    }
                }
            }
            if(self::currentRegistro()->getIdEntradaSaida() == self::SAIDA) {
                if(!empty(self::currentRegistro()->getHorarioCorrente())){
                    if (self::currentRegistro()->getHorarioCorrente()->DSINTERVALOPROJETADO != '' &&
                        !is_null(self::currentRegistro()->getHorarioCorrente()->DSINTERVALOPROJETADO)){
                        self::currentRegistro()->setDsIntervaloProjetado(self::currentRegistro()->getHorarioCorrente()->DSINTERVALOPROJETADO);
                    }
                }
            }
        }else{
            self::currentRegistro()->getMarcacao()->setIdmarcdesprezada(self::SIM);
        }
    }

    private function retornaDiaOcorrencia($dataDiaOcorrencia){
        $dataDiaOcorrencia = DateUtil::getDataDeString($dataDiaOcorrencia->format(DateUtil::FORMATO_BRASILEIRO),DateUtil::FORMATO_BRASILEIRO, true);
        if(DateUtil::comparaDatas($dataDiaOcorrencia, $this->data, DateUtil::ANTES)){
            $diaOcorrencia = self::DIA_SEGUINTE;
        }
        elseif(DateUtil::comparaDatas($dataDiaOcorrencia, $this->data, DateUtil::DEPOIS)){
            $diaOcorrencia = self::DIA_ANTERIOR;
        }
        else{
            $diaOcorrencia = self::DIA_CORRENTE;
        }

        return $diaOcorrencia;
    }

    private function somarHoraMinuto($horaMinuto, $data){
        $hora = (int)substr($horaMinuto, 0, 2);
        $minuto = (int)substr($horaMinuto, 2, 2);

        $data = DateUtil::adicionaIntervalo($data, $hora, DateUtil::HORAS);
        $data = DateUtil::adicionaIntervalo($data, $minuto, DateUtil::MINUTOS);

        return $data;
    }

    private function insereMarcViradas()
    {
        $dtRegVir = DateUtil::adicionaIntervalo($this->data, 1, DateUtil::DIA);
        $stRegVir = $dtRegVir->format(DateUtil::FORMATO_BRASILEIRO);

        $dtRegVir = DateUtil::getDataDeString($stRegVir . ' 00:00', self::FORMATO_DATA_HORAMINUTO);

        /** @var GpeParamorg $paramOrg */
        $paramOrg = GpeParamorg::findOneByNrorg($this->nrorg);

        $marcacaoRegVir = new GpeMarcacaoponto();
        $marcacaoRegVir->setIdenquadrahorario(self::NAO);
        $marcacaoRegVir->setDthrmarcacaoponto($dtRegVir);
        $marcacaoRegVir->setDthrajustada($dtRegVir);
        $marcacaoRegVir->setIdmarcdesprezada(self::NAO);
        $marcacaoRegVir->setNrvinculom($this->nrvinculom);
        $marcacaoRegVir->setNrorg($this->nrorg);
        $marcacaoRegVir->setDsjustificativa('');
        $marcacaoRegVir->setIddiaocorrencia(self::DIA_CORRENTE);
        $marcacaoRegVir->setNrcoletor($paramOrg->getNrcoletormarcviradia());

        //Registro Virada Saída
        $regSaidVir = new RegistroPonto($stRegVir, $marcacaoRegVir, self::SAIDA, $this->nrorg);
        //Registro Virada Entrada
        $regEntrVir = new RegistroPonto($stRegVir, $marcacaoRegVir, self::ENTRADA, $this->nrorg);

        foreach ($this->registros as $key => $registro) {
            $inseriu = false;
            $dtAjustadaComp = $registro->getMarcacao()->getDthrajustada();
            $dtAjustadaComp = $dtAjustadaComp->format(self::FORMATO_DATA_HORAMINUTO);
            $dtAjustadaComp = DateUtil::getDataDeString($dtAjustadaComp, self::FORMATO_DATA_HORAMINUTO);
            if (DateUtil::comparaDatas($dtAjustadaComp, $dtRegVir, DateUtil::DEPOIS)) {
                $this->registros = self::inserePosicaoArray($key, $this->registros, $regSaidVir);
                $this->registros = self::inserePosicaoArray(($key + 1), $this->registros, $regEntrVir);
                $inseriu = true;
            }
            if ($key == (count($this->registros) - 1) && $inseriu == false) {
                $this->registros[] = $regSaidVir;
            }
            if ($inseriu == true) {
                break;
            }
        }
    }

    private function verificaViradaDia()
    {
        $registrosNDesprez = array();
        foreach ($this->registros as $registro) {
            if ($registro->getMarcacao()->getIdmarcdesprezada() == self::NAO) {
                $registrosNDesprez[] = $registro;
            }
        }
        $this->registrosNDesprez = $registrosNDesprez;

        $dtDiaSelec = $this->data;
        if ($this->escalaHistorico->getIdgeramarcviradadia() == self::SIM && !self::verificaExisteMarcVirada()) {
            /** @var RegistroPonto $registro */
            foreach ($this->registrosNDesprez as $key => $registro) {
                $sair = false;
                $dtRegistro = DateUtil::getDataDeString($registro->getMarcacao()->getDthrajustada()->format(DateUtil::FORMATO_BRASILEIRO),
                    DateUtil::FORMATO_BRASILEIRO, true);
                if (DateUtil::comparaDatas($dtRegistro, $dtDiaSelec, DateUtil::DEPOIS)) {
                    if ($registro->getIdEntradaSaida() == self::SAIDA) {
                        self::insereMarcViradas();
                    }
                    $sair = true;
                }
                if ($sair == true) {
                    break;
                }
            }
        }
    }

    private function verificaHorarioBase()
    {
        $intervalosHorario = $this->horario->getIntervalosHorario();
        if(count($intervalosHorario) == 0){
            $this->horario->setEndOfHorario(true);
        }

        while (!$this->horario->getEndOfHorario()) {
            //Registro Baliza
            $dtHoraBaliza = $this->horario->currentHorario()->DTHORABASE;
            $stDataBaliza = $dtHoraBaliza->format(DateUtil::FORMATO_BRASILEIRO);

            /** @var GpeParamorg $paramOrg */
            $paramOrg     = GpeParamorg::findOneByNrorg($this->nrorg);

            $marcacaoBaliza = new GpeMarcacaoponto();
            $marcacaoBaliza->setIdenquadrahorario(self::NAO);
            $marcacaoBaliza->setDthrmarcacaoponto($dtHoraBaliza);
            $marcacaoBaliza->setDthrajustada($dtHoraBaliza);
            $marcacaoBaliza->setIdmarcdesprezada(self::NAO);
            $marcacaoBaliza->setNrvinculom($this->nrvinculom);
            $marcacaoBaliza->setNrorg($this->nrorg);
            $marcacaoBaliza->setDsjustificativa('');
            $marcacaoBaliza->setIddiaocorrencia($this->horario->currentHorario()->DIAOCORRENCIA);
            $marcacaoBaliza->setNrcoletor($paramOrg->getNrcoletormarcgersist());

            $registroBaliza = new RegistroPonto($stDataBaliza, $marcacaoBaliza,
                $this->horario->currentHorario()->IDENTRADASAIDA, $this->nrorg);

            if (count($this->registros) == 0) {
                $this->registros[] = $registroBaliza;
            } else {
                /** @var RegistroPonto $registro */
                foreach ($this->registros as $key => $registro) {
                    $inseriu = false;
                    $dtAjustadaComp = $registro->getMarcacao()->getDthrajustada();
                    $dtAjustadaComp = $dtAjustadaComp->format(self::FORMATO_DATA_HORAMINUTO);
                    $dtAjustadaComp = DateUtil::getDataDeString($dtAjustadaComp, self::FORMATO_DATA_HORAMINUTO);
                    if (DateUtil::comparaDatas($dtAjustadaComp, $dtHoraBaliza, DateUtil::DEPOIS)) {
                        $this->registros = self::inserePosicaoArray($key, $this->registros, $registroBaliza);
                        $inseriu = true;
                    }
                    if ($key == (count($this->registros) - 1) && $inseriu == false) {
                        $this->registros[] = $registroBaliza;
                    }
                    if ($inseriu == true) {
                        break;
                    }
                }
            }
            $this->horario->nextHorario();
        }
    }

    private function insereBaliza($idBalizaDesprezada)
    {
        //Inclusão de registro Baliza
        $dtHoraBaliza = $this->horario->currentHorario()->DTHORABASE;
        $stDataBaliza = $dtHoraBaliza->format(DateUtil::FORMATO_BRASILEIRO);

        /** @var GpeParamorg $paramOrg */
        $paramOrg     = GpeParamorg::findOneByNrorg($this->nrorg);

        $marcacaoBaliza = new GpeMarcacaoponto();
        $marcacaoBaliza->setIdenquadrahorario(self::NAO);
        $marcacaoBaliza->setDthrmarcacaoponto($dtHoraBaliza);
        $marcacaoBaliza->setDthrajustada($dtHoraBaliza);
        if($idBalizaDesprezada){
            $marcacaoBaliza->setIdmarcdesprezada(self::SIM);
        }else{
            $marcacaoBaliza->setIdmarcdesprezada(self::NAO);
        }
        $marcacaoBaliza->setNrvinculom($this->nrvinculom);
        $marcacaoBaliza->setNrorg($this->nrorg);
        $marcacaoBaliza->setDsjustificativa('');
        $marcacaoBaliza->setIddiaocorrencia($this->horario->currentHorario()->DIAOCORRENCIA);
        $marcacaoBaliza->setNrcoletor($paramOrg->getNrcoletormarcgersist());

        $registroBaliza = new RegistroPonto($stDataBaliza, $marcacaoBaliza, $this->horario->currentHorario()->IDENTRADASAIDA, $this->nrorg);

        if (count($this->registros) != 1) {
            if (count($this->registros) == 0) {
                $this->registros[] = $registroBaliza;
            } else {
                /** @var RegistroPonto $registro */
                foreach ($this->registros as $key => $registro) {
                    $inseriu = false;
                    $dtAjustadaComp = $registro->getMarcacao()->getDthrajustada();
                    $dtAjustadaComp = $dtAjustadaComp->format(self::FORMATO_DATA_HORAMINUTO);
                    $dtAjustadaComp = DateUtil::getDataDeString($dtAjustadaComp, self::FORMATO_DATA_HORAMINUTO);
                    if (DateUtil::comparaDatas($dtAjustadaComp, $dtHoraBaliza, DateUtil::DEPOIS)) {
                        $this->registros = self::inserePosicaoArray($key, $this->registros, $registroBaliza);
                        $inseriu = true;
                    }
                    if ($key == (count($this->registros) - 1) && $inseriu == false) {
                       $this->registros[] = $registroBaliza;
                    }
                    if ($inseriu == true) {
                        break;
                    }
                }
            }
            self::endRegistro();
        } else {
            $registroAtual      = $this->registros[0];
            $this->registros[0] = $registroBaliza;
            $this->registros[]  = $registroAtual;
            self::endRegistro();
        }
    }

    public static function inserePosicaoArray($tamanhoArray, $array, $novaPosicao)
    {
        $arrayAux      = array_chunk($array, $tamanhoArray);
        $arrayAux[0][] = $novaPosicao;
        $novoArray     = $arrayAux[0];
        for ($i = 1; $i < count($arrayAux); $i++) {
            $novoArray = array_merge($novoArray, $arrayAux[$i]);
        }

        return $novoArray;
    }

    private function getHorarioTurno($data, $nrTurno, $dtDataBase, $nrOrg)
    {
        $diaHorario = DateUtil::getQtdeDiasEntre($dtDataBase, $data);

        $where   = 'NRTURNO = ? AND NRORG = ?';
        $params  = array($nrTurno, $nrOrg);
        $orderBy = 'NRSEQHORARIO';

        $horariosTurno = GpeHorarioturno::getObjectsByWhere($where, $params, $orderBy);
        $diaHorario    = fmod($diaHorario, count($horariosTurno));
        $horarioTurno  = $horariosTurno[$diaHorario];

        return $horarioTurno;
    }

    public function nextRegistro()
    {
        if (next($this->registros)) {
            $this->indexRegistros++;
        }
    }

    public function prevRegistro()
    {
        if (prev($this->registros)) {
            $this->indexRegistros--;
        }
    }

    public function currentRegistro()
    {
        /** @var RegistroPonto $registro */
        $registro = current($this->registros);
        return $registro;
    }

    public function endRegistro()
    {
        end($this->registros);
        $this->indexRegistros = (count($this->registros) - 1);
    }

    public function resetRegistros()
    {
        if (reset($this->registros)) {
            $this->indexRegistros = 0;
        }
    }

    public function nextIntervalo($idIntervaloCR = 'C')
    {
        if($idIntervaloCR == 'C'){
            $intervalo = next($this->intervalosControle);
            if ($intervalo) {
                $this->indexIntervalosControle++;
            } else {
                $this->endOfIntervalosControle = true;
            }
        }else{
            $intervalo = next($this->intervalosRegistros);
            if ($intervalo) {
                $this->indexIntervalosRegistros++;
            } else {
                $this->endOfIntervalosRegistros = true;
            }
        }
    }

    public function prevIntervalo($idIntervaloCR = 'C')
    {
        if($idIntervaloCR == 'C') {
            $intervalo = prev($this->intervalosControle);
            if ($intervalo) {
                $this->indexIntervalosControle--;
                $this->endOfIntervalosControle = false;
            }
        }
        else {
            $intervalo = prev($this->intervalosRegistros);
            if ($intervalo) {
                $this->indexIntervalosRegistros--;
                $this->endOfIntervalosRegistros = false;
            }
        }
    }

    public function currentIntervalo($idIntervaloCR = 'C')
    {
        if($idIntervaloCR == 'C') {
            /** @var object $intervalo */
            $intervalo = (object)current($this->intervalosControle);
            return $intervalo;
        }
        else {
            /** @var object $intervalo */
            $intervalo = (object)current($this->intervalosRegistros);
            return $intervalo;
        }
    }

    public function endIntervalo($idIntervaloCR = 'C')
    {
        if($idIntervaloCR == 'C') {
            end($this->intervalosControle);
            $this->indexIntervalosControle = (count($this->intervalosControle) - 1);
        }
        else {
            end($this->intervalosRegistros);
            $this->indexIntervalosRegistros = (count($this->intervalosRegistros) - 1);
        }
    }

    public function resetIntervalo($idIntervaloCR = 'C')
    {
        if($idIntervaloCR == 'C') {
            if (reset($this->intervalosControle)) {
                $this->indexIntervalosControle = 0;
                $this->endOfIntervalosControle = false;
            }
        }
        else{
            if (reset($this->intervalosRegistros)) {
                $this->indexIntervalosRegistros = 0;
                $this->endOfIntervalosRegistros = false;
            }
        }
    }

    public function getRegistrosDiaDatasource()
    {
        $dadosRegistros = array();

        /** @var RegistroPonto $registro */
        foreach ($this->registros as $registro) {
            $marcacao = $registro->getMarcacao();
            /** @var GpeMarcacaoponto $marcacao */
            $dadosRegistros[] = array(
                'NRORG'             => $marcacao->getNrorg(),
                'NRVINCULOM'        => $marcacao->getNrvinculom(),
                'NRMARCACAOPONTO'   => $marcacao->getNrmarcacaoponto(),
                'DTHRAJUSTADA'      => $marcacao->getDthrajustada()->format(self::FORMATO_DATA_HORAMINUTO),
                'DTHRMARCACAOPONTO' => $marcacao->getDthrmarcacaoponto()->format(self::FORMATO_DATA_HORAMINUTO),
                'IDDIAOCORRENCIA'   => $marcacao->getIddiaocorrencia(),
                'IDDENTROHORABASE'  => $registro->getIdDentroHoraBase(),
                'IDMARCDESPREZADA'  => $marcacao->getIdmarcdesprezada(),
                'IDENQUADRAHORARIO' => $marcacao->getIdenquadrahorario(),
                'IDENTRADASAIDA'    => $registro->getIdEntradaSaida(),
                'IDMARCACAO'        => $registro->getIdMarcacao(),
                'DSJUSTIFICATIVA'   => $marcacao->getDsjustificativa(),
                'IDATIVO'           => $marcacao->getIdativo(),
                'NRORGINCLUSAO'     => $marcacao->getNrorginclusao(),
                'DTINCLUSAO'        => $marcacao->getDtinclusao()->format(self::FORMATO_DATA_HORAMINUTO),
                'CDOPERINCLUSAO'    => $marcacao->getCdoperinclusao(),
                'NRORGULTATU'       => $marcacao->getNrorgultatu(),
                'DTULTATU'          => $marcacao->getDtultatu(),
                'CDOPERULTATU'      => $marcacao->getCdoperultatu());
        }

        return $dadosRegistros;
    }

    private function getRegistroAnterior()
    {
        if ($this->indexRegistros != 0) {
            $registroAnt = $this->registros[$this->indexRegistros - 1];
        } else {
            $registroAnt = self::currentRegistro();
        }

        return $registroAnt;
    }

    private function totalizaIntervalos($paramEscala)
    {
        $controle = array(
            'PASSOUPRIMMARC' => false,
            'PRIMMARCEXISTE' => false,
            'DENTROEMPRESA'  => self::NAO
        );
        /** @var RegistroPonto $registro */
        $this->intervalosRegistros = array();
        $intervalosControle = array();
        foreach ($this->registrosNDesprez as $key => $registro) {
            if ($key == 0 && count($this->registrosNDesprez) > 1) {
                $intervalosControle[]   = array('MARCINI'     => $registro,
                                                'MARCFIM'     => isset($this->registrosNDesprez[$key + 1]) ? $this->registrosNDesprez[$key + 1] : null,
                                                'MARCINIANT'  => null,
                                                'MARCFIMANT'  => null,
                                                'MARCNEXT'    => isset($this->registrosNDesprez[$key + 2]) ? $this->registrosNDesprez[$key + 2] : null,
                                                'INICIONOT'   => false,
                                                'IDINTERVALO' => '',
                                                'HORA'        => 0,
                                                'HORADIA'     => 0,
                                                'HORANOT'     => 0);
            } elseif ($key == (count($this->registrosNDesprez) - 2)) {
                $intervalosControle[]   = array('MARCINI'     => $registro,
                                                'MARCFIM'     => isset($this->registrosNDesprez[$key + 1]) ? $this->registrosNDesprez[$key + 1] : null,
                                                'MARCINIANT'  => isset($this->registrosNDesprez[$key - 1]) ? $this->registrosNDesprez[$key - 1] : null,
                                                'MARCFIMANT'  => $registro,
                                                'MARCNEXT'    => null,
                                                'INICIONOT'   => false,
                                                'IDINTERVALO' => '',
                                                'HORA'        => 0,
                                                'HORADIA'     => 0,
                                                'HORANOT'     => 0);
            } elseif ($key != (count($this->registrosNDesprez) - 1)) {
                $intervalosControle[]   = array('MARCINI'     => $registro,
                                                'MARCFIM'     => isset($this->registrosNDesprez[$key + 1]) ? $this->registrosNDesprez[$key + 1] : null,
                                                'MARCINIANT'  => isset($this->registrosNDesprez[$key - 1]) ? $this->registrosNDesprez[$key - 1] : null,
                                                'MARCFIMANT'  => $registro,
                                                'MARCNEXT'    => isset($this->registrosNDesprez[$key + 2]) ? $this->registrosNDesprez[$key + 2] : null,
                                                'INICIONOT'   => false,
                                                'IDINTERVALO' => '',
                                                'HORA'        => 0,
                                                'HORADIA'     => 0,
                                                'HORANOT'     => 0);
            }
        }
        $this->intervalosControle  = $intervalosControle;
        if(count($this->intervalosControle) > 0){
            self::resetIntervalo();
        }else{
            $this->endOfIntervalosControle = true;
        }

        do {
            if(count($intervalosControle) > 0) {
                $intervaloAtual = self::currentIntervalo();
                // Marcação existente (IDMARCACAO= self::REGISTRO) de entrada (IDENTRADASAIDA = 'E')
                if (($intervaloAtual->MARCINI->getIdEntradaSaida() == self::ENTRADA) &&
                    ($intervaloAtual->MARCINI->getIdMarcacao() != self::BALIZA)
                ) {
                    $controle['DENTROEMPRESA'] = self::SIM;
                }

                // Marcação existente (IDMARCACAO = self::REGISTRO) de saída (IDENTRADASAIDA = 'S')
                if (($intervaloAtual->MARCINI->getIdEntradaSaida() == self::SAIDA) &&
                    ($intervaloAtual->MARCINI->getIdMarcacao() != self::BALIZA)
                ) {
                    $controle['DENTROEMPRESA'] = self::NAO;
                }
                self::identificaIntervalo($controle, $paramEscala);
                self::nextIntervalo();
            }
        } while (!$this->endOfIntervalosControle);
    }

    /**
     * @param $controle
     * @param $paramEscala
     * @throws \Exception
     */
    private function identificaIntervalo(&$controle, $paramEscala)
    {
        $intervaloAtual   = self::currentIntervalo();    
        $horaNoturna = 0;
        $horaDiurna  = 0;

        $horaTotal = DateUtil::getIntervaloEmSegundos($intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                                                           $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada())/3600;

        $inicNot = self::formataHora($this->escalaHistorico->getHriniperiodonoturno());
        $fimNot  = self::formataHora($this->escalaHistorico->getHrfimperiodonoturno());

        $dtInicNot = DateUtil::getDataDeString($this->data->format(DateUtil::FORMATO_BRASILEIRO) . ' ' . $inicNot, self::FORMATO_DATA_HORAMINUTO);
        $dtFimNot  = DateUtil::getDataDeString(DateUtil::adicionaIntervalo($this->data, 1,
                                               DateUtil::DIA)->format(DateUtil::FORMATO_BRASILEIRO) . ' ' . $fimNot,
                                               self::FORMATO_DATA_HORAMINUTO);

        if ($horaTotal != 0) {
            if (!DateUtil::comparaDatas($dtInicNot,
                    $intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                    DateUtil::DEPOIS) &&
                !DateUtil::comparaDatas($dtFimNot,
                    $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada(),
                    DateUtil::ANTES)
            ) {
                $horaNoturna     = $horaTotal;
                $horaDiurna      = 0;
                $inicioIntervNot = true;
            } elseif (!DateUtil::comparaDatas($dtInicNot,
                    $intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                    DateUtil::DEPOIS) &&
                !DateUtil::comparaDatas($dtFimNot,
                    $intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                    DateUtil::ANTES)
            ) {
                $horaNoturna = DateUtil::getIntervaloEmSegundos($intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                        $dtFimNot)/3600;

                $horaDiurna = DateUtil::getIntervaloEmSegundos($dtFimNot,
                        $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada())/3600;

                $inicioIntervNot = true;
            } elseif (!DateUtil::comparaDatas($dtInicNot, $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada(),
                      DateUtil::DEPOIS) &&
                      !DateUtil::comparaDatas($dtFimNot, $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada(),
                      DateUtil::ANTES)
            ) {
                $horaNoturna = DateUtil::getIntervaloEmSegundos($dtInicNot,
                        $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada())/3600;

                $horaDiurna = DateUtil::getIntervaloEmSegundos($intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                        $dtInicNot)/3600;

                $inicioIntervNot = false;
            } elseif (DateUtil::comparaDatas($dtInicNot, $intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                                             DateUtil::DEPOIS) &&
                      DateUtil::comparaDatas($dtFimNot, $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada(),
                                             DateUtil::ANTES)
            ) {
                $horaDiurna = DateUtil::getIntervaloEmSegundos($intervaloAtual->MARCINI->getMarcacao()->getDthrajustada(),
                        $dtInicNot)/3600;
                $horaDiurna = $horaDiurna + DateUtil::getIntervaloEmSegundos($dtFimNot,
                                                       $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada())/3600;

                $horaNoturna = DateUtil::getIntervaloEmSegundos($dtInicNot, $dtFimNot)/3600;

                $inicioIntervNot = false;
            } else {
                $horaDiurna      = $horaTotal;
                $inicioIntervNot = false;
            }
        } elseif ($horaTotal == 0) {
            $this->intervalosControle[$this->indexIntervalosControle]['IDINTERVALO'] = self::IGNORADO;
            $baseIntervalo = new PtoIntervalosmarcacao();
            $baseIntervalo->setMarcacaopontoini($intervaloAtual->MARCINI->getMarcacao());
            $baseIntervalo->setMarcacaopontofim($intervaloAtual->MARCFIM->getMarcacao());
            $baseIntervalo->setIdintervalomarcacao(self::IGNORADO);
            $baseIntervalo->setQtintervmarcdiurno(0);
            $baseIntervalo->setQtintervmarcnoturno(0);

            $this->intervalosRegistros[] = $baseIntervalo;
            return;
        }

        $intervaloAtual->HORA      = $horaTotal;
        $intervaloAtual->HORADIA   = $horaDiurna;
        $intervaloAtual->HORANOT   = $horaNoturna;
        $intervaloAtual->INICIONOT = $inicioIntervNot;

        // Guarda variavel booleana para primeira marcacao existente
        if ($controle['PASSOUPRIMMARC'] == false) {
            if (($intervaloAtual->MARCFIM->getIdEntradaSaida() == self::ENTRADA) &&
                ($intervaloAtual->MARCFIM->getIdMarcacao() != self::BALIZA)
            ) {
                $controle['PRIMMARCEXISTE'] = true;
            }
        }
        $tipoDiaCalend = null;
        if ($this->idDiaCalend == self::FERIADO) {
            $tipoDiaCalend = 'FERIADO';
        } elseif ($this->idDiaCalend == self::PONTO_FACULTATIVO) {
            $tipoDiaCalend = 'PONTOFACULTATIVO';
        }

        $whereProgIntervalo = "NRVINCULOM  = ?
                               AND NRORG   = ?
                               AND IDATIVO = 'S'
                               AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                               AND NRMARCACAOPONTO = ?
                               AND (NRINTERVALOHORARIO IS NULL OR
                                    NRTIPOPROGOCORRENCIA = (SELECT NRTIPOPROGOCORRENCIA
                                                              FROM PTO_TIPOPROGOCORRENCIA
                                                             WHERE NRORG                = ?
                                                               AND CDTIPOPROGOCORRENCIA = ?))
                               AND IDPROGOCORCONFIRMADA = 'S'
                               AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                               AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)";

        $paramsProgIntervalo = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $intervaloAtual->MARCINI->getMarcacao()->getNrmarcacaoponto(),
            FPA::getNrorgPadrao(),
            self::IDENTIFICA_INTERVALO_NP,
            $tipoDiaCalend,
            $this->horario->getHorarioHistorico()->getIdtipohorario()
        );

        $diaSemana = self::retornaDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO));

        /** @var PtoProgocorrencia $progOcorIntervalo */
        $progOcorIntervalo = PtoProgocorrencia::getObjectByWhere($whereProgIntervalo, $paramsProgIntervalo);
        if(is_object($progOcorIntervalo)) {
            $arrayDiasSemana = str_split($progOcorIntervalo->getIddiassemana());
            if ((is_null($progOcorIntervalo->getIddiassemana()) || $progOcorIntervalo->getIddiassemana() == '0000000' || !(isset($arrayDiasSemana[$diaSemana]) && $arrayDiasSemana[$diaSemana] == '1'))) {
                $progOcorIntervalo = null;
            }
        }

        if(is_object($progOcorIntervalo)){
            //Vitor Peixoto 20/08/2015 Recebe o id do intervalo de acordo com o tipo da programação
            if(is_null($intervaloAtual->MARCINIANT->getMarcacao()->getDsjustificativa()) || $intervaloAtual->MARCINIANT->getMarcacao()->getDsjustificativa() == '')
                $intervaloAtual->MARCINI->getMarcacao()->setDsjustificativa($progOcorIntervalo->getDsobservacao());
                $intervaloAtual->MARCFIM->getMarcacao()->setDsjustificativa($progOcorIntervalo->getDsobservacao());

            $idIntervalo = self::verificaProgramacoesOcorrenciaIntervalo($progOcorIntervalo, $intervaloAtual);
        }
        else {

            if (count($this->horario->getIntervalosHorario()) == 0) {
                if ($intervaloAtual->MARCINI->getIdEntradaSaida() == self::ENTRADA &&
                    $intervaloAtual->MARCFIM->getIdEntradaSaida() == self::SAIDA
                ) {
                    if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
                        $idIntervalo = self::EXTRA;
                        self::contabExtra($intervaloAtual);
                    } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                        $idIntervalo = self::EXTRA;
                        self::contabExtra($intervaloAtual);
                    } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::NORMAL) {
                        $idIntervalo = self::TRABALHO;
                        self::contabTrab($intervaloAtual);
                    }
                }
                //Alteração Vitor Peixoto 20/07/2015 Identificar intervalos SE
                elseif ($intervaloAtual->MARCINI->getIdEntradaSaida() == self::SAIDA &&
                          $intervaloAtual->MARCFIM->getIdEntradaSaida() == self::ENTRADA
                ) {
                    $idIntervalo = self::identificaIntervaloSE($intervaloAtual, $controle, $paramEscala);
                }
                //END Vitor Peixoto 20/07/2015
            } else {
                if ($intervaloAtual->MARCINI->getIdEntradaSaida() == self::ENTRADA &&
                    $intervaloAtual->MARCFIM->getIdEntradaSaida() == self::SAIDA
                ) {

                    $idIntervalo = self::identificaIntervaloES($intervaloAtual, $controle);
                } elseif ($intervaloAtual->MARCINI->getIdEntradaSaida() == self::ENTRADA &&
                          $intervaloAtual->MARCFIM->getIdEntradaSaida() == self::ENTRADA
                ) {

                    $idIntervalo = self::identificaIntervaloEE($intervaloAtual, $controle);
                } elseif ($intervaloAtual->MARCINI->getIdEntradaSaida() == self::SAIDA &&
                          $intervaloAtual->MARCFIM->getIdEntradaSaida() == self::SAIDA
                ) {

                    $idIntervalo = self::identificaIntervaloSS($intervaloAtual, $controle);
                } else {
                    $idIntervalo = self::identificaIntervaloSE($intervaloAtual, $controle, $paramEscala);
                }
            }
        }

        $this->intervalosControle[$this->indexIntervalosControle]['IDINTERVALO'] = $idIntervalo;
        $this->intervalosControle[$this->indexIntervalosControle]['INICIONOT']   = $inicioIntervNot;
        $this->intervalosControle[$this->indexIntervalosControle]['HORA']        = $horaTotal;
        $this->intervalosControle[$this->indexIntervalosControle]['HORADIA']     = $horaDiurna;
        $this->intervalosControle[$this->indexIntervalosControle]['HORANOT']     = $horaNoturna;

        $baseIntervalo = new PtoIntervalosmarcacao();
        $baseIntervalo->setMarcacaopontoini($intervaloAtual->MARCINI->getMarcacao());
        $baseIntervalo->setMarcacaopontofim($intervaloAtual->MARCFIM->getMarcacao());
        if($intervaloAtual->MARCINI->getDsIntervaloProjetado() != '' &&
           !is_null($intervaloAtual->MARCINI->getDsIntervaloProjetado()) &&
            $idIntervalo == self::IGNORADO){
            $idIntervalo = self::IDENTIFICADO;
        }
        
        // LEONARDOCARVALHO - 09/11/2015 - Condição para considerar intervalos abonados em baliza como trabalho
        /*if(!is_null($intervaloAtual->MARCINI->getMarcacao()->getDsjustificativa()) &&
           $intervaloAtual->MARCINI->getMarcacao()->getDsjustificativa() != ''     &&
           !is_null($intervaloAtual->MARCFIM->getMarcacao()->getDsjustificativa()) &&
           $intervaloAtual->MARCFIM->getMarcacao()->getDsjustificativa(
           )) {
            $idIntervalo = self::TRABALHO;
        }*/
        
        $baseIntervalo->setIdintervalomarcacao($idIntervalo);
        $baseIntervalo->setQtintervmarcdiurno($horaDiurna);
        $baseIntervalo->setQtintervmarcnoturno($horaNoturna);
        $baseIntervalo->setDsintervaloidentificado($intervaloAtual->MARCINI->getDsIntervaloProjetado());

        $this->intervalosRegistros[] = $baseIntervalo;
    }

    private function contabTrab($intervaloAtual)
    {
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $calcSituFreq[$this->idTrabDia]['HORAS'] = $calcSituFreq[$this->idTrabDia]['HORAS'] + $intervaloAtual->HORADIA;
        $calcSituFreq[$this->idTrabNot]['HORAS'] = $calcSituFreq[$this->idTrabNot]['HORAS'] + $intervaloAtual->HORANOT;
        if (!($this->horario->getHorarioHistorico()->getIdtipohorario() == self::TURNO &&
            $this->idDiaCalend == self::FERIADO &&
            $this->escalaHistorico->getIdturnoextraferiado() == self::SIM)
        ) {
            // 30/09/05 - Nádia - acumular horas; a hora compress será calculada no final - HMT
            $this->idHorasNotAdic = $this->idHorasNotAdic + $intervaloAtual->HORANOT;
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);

        // LEONARDOCARVALHO - 21/01/2016 - Alterado forma de gerar horas extras em horario turno, em dia de feriado.
        //self::extraTurnoFeriado($intervaloAtual);  // uf_extra_turno_feriado (extras_no_dia, ic_dia_calend, tp_hor, marc_fim);
    }

    private function contabSaida($intervaloAtual)
    {
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'] = $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'] + $intervaloAtual->HORADIA;

        $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'] = $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'] + $intervaloAtual->HORANOT;

//        //06/09/05 FabioL - Separa saidas em periodos
//                uf_separa_atrsaihex_periodos(ai_marc_fim, iuo_pt.C_SAIDAS_DIA);
        self::separaAtrSaiHexPeriodos($intervaloAtual, self::SAIDAS_DIURNAS);

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    private function contabAtraso($intervaloAtual)
    {
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

        $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] = $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] + $intervaloAtual->HORADIA;

        $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'] = $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'] + $intervaloAtual->HORANOT;
        //Flag de atraso no dia: true quando contabiliza atraso.
        $this->existeAtraso = true;

//    //06/09/05 FabioL - Separa atrasos em periodos
//            uf_separa_atrsaihex_periodos(ai_marc_fim, iuo_pt.C_ATRASOS_DIA);
        self::separaAtrSaiHexPeriodos($intervaloAtual, self::ATRASOS_DIURNOS);

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    private function contabExtra($intervaloAtual)
    {
        // 22/09/99 - quebra do objeto uo_apuracao

        // 10/11/99 - rigel - virou parm
        if ($this->escalaHistorico->getIdmantempercvirada() == self::NAO) {
            $ls_seguinte = self::SIM;
        } else {
            $ls_seguinte = self::NAO;
        }

        // marreta pegar parm da escala
        $dtMarcIni = DateUtil::getDataDeString($intervaloAtual->MARCINI->getMarcacao()->getDthrajustada()->format(DateUtil::FORMATO_BRASILEIRO),
            DateUtil::FORMATO_BRASILEIRO, true);
        $dtMarcFim = DateUtil::getDataDeString($intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada()->format(DateUtil::FORMATO_BRASILEIRO),
            DateUtil::FORMATO_BRASILEIRO, true);

        $inicNot = self::formataHora($this->escalaHistorico->getHriniperiodonoturno());
        $fimNot = self::formataHora($this->escalaHistorico->getHrfimperiodonoturno());

        $dtInicNot = DateUtil::getDataDeString($this->data->format(DateUtil::FORMATO_BRASILEIRO) . ' ' . $inicNot, self::FORMATO_DATA_HORAMINUTO);
        $dtFimNot = DateUtil::getDataDeString(
            DateUtil::adicionaIntervalo($this->data, 1, DateUtil::DIA)->format(DateUtil::FORMATO_BRASILEIRO) . ' ' . $fimNot,
            self::FORMATO_DATA_HORAMINUTO);

        if (DateUtil::comparaDatas($dtMarcIni, $this->data, DateUtil::DEPOIS) && $ls_seguinte == self::SIM) {
            /* apura extras nas situacoes referentes ao dia seguinte */
            // 05/05/06 - Nádia - novos arg a partir de uo_marcacao
            if ($intervaloAtual->INICIONOT) {
                self::acumulaExtra($this->idPextraNot, $this->idPextraNot2, $intervaloAtual->HORANOT);

                self::acumulaExtra($this->idPextraDia, $this->idPextraDia2, $intervaloAtual->HORADIA);
            } else {
                // 05/05/06 - Nádia - novos arg a partir de uo_marcacao
                self::acumulaExtra($this->idPextraDia, $this->idPextraDia2, $intervaloAtual->HORADIA);

                self::acumulaExtra($this->idPextraNot, $this->idPextraNot2, $intervaloAtual->HORANOT);
            }

            // 30/09/05 - Nádia - acumular horas; a hora compress será calculada no final
            $this->idHorasPextAdic = $this->idHorasPextAdic + $intervaloAtual->HORANOT;
        } else {
            /* apura extras nas situacoes referentes ao dia corrente */
            if ($intervaloAtual->INICIONOT) {
                // 05/05/06 - Nádia - novos arg a partir de uo_marcacao
                self::acumulaExtra($this->idExtraNot, $this->idExtraNot2, $intervaloAtual->HORANOT);

                self::acumulaExtra($this->idExtraDia, $this->idExtraDia2, $intervaloAtual->HORADIA);
            } else {
                // 05/05/06 - Nádia - novos arg a partir de uo_marcacao
                self::acumulaExtra($this->idExtraDia, $this->idExtraDia2, $intervaloAtual->HORADIA);

                self::acumulaExtra($this->idExtraNot, $this->idExtraNot2, $intervaloAtual->HORANOT);
            }

            // 30/09/05 - Nádia - acumular horas; a hora compress será calculada no final
            $this->idHorasExtAdic = $this->idHorasExtAdic + $intervaloAtual->HORANOT;
        }

        //06/09/05 FabioL - Separa extras em periodos
        //uf_separa_atrsaihex_periodos(ai_marc_fim, iuo_pt.C_EXTRA_DIA);
        if(count($this->horario->getIntervalosHorario()) > 0){
            self::separaAtrSaiHexPeriodos($intervaloAtual, self::EX_DIA_NORMAL_1AS);
        }
    }

    private function identificaIntervaloES($intervaloAtual, &$controle)
    {
        $idIntervalo = self::IGNORADO;

        $marcIni    = $intervaloAtual->MARCINI;
        $marcIni    = $intervaloAtual->MARCINI;
        $marcFim    = $intervaloAtual->MARCFIM;
        $marcNext   = $intervaloAtual->MARCNEXT;
        $marcIniAnt = $intervaloAtual->MARCINIANT;
        $marcFimAnt = $intervaloAtual->MARCFIMANT;

        /** @var RegistroPonto $marcIniAnt */
        /** @var RegistroPonto $marcFimAnt */
        /** @var RegistroPonto $marcIni */
        /** @var RegistroPonto $marcFim */
        /** @var RegistroPonto $marcNext */

        if ($marcIni->getIdMarcacao() == self::BALIZA) {
            if (!is_null($marcIniAnt) && (DateUtil::comparaDatas($marcIniAnt->getMarcacao()->getDthrajustada(),
                    $marcIni->getMarcacao()->getDthrajustada(),
                    DateUtil::ANTES)) &&
                ($controle['DENTROEMPRESA'] == self::SIM)
            ) {
                //existe intervalo anterior
                if ($controle['DENTROEMPRESA'] == self::SIM) {
                    // ja estava na empresa
                    if (($marcFim->getIdMarcacao() == self::REGISTRO || $marcFim->getIdMarcacao() == self::DIGITADA)||/* self::BALIZA) ||*/
                        DateUtil::comparaDatas($this->ultimaMarcacao->getMarcacao()->getDthrajustada(),
                            $marcFim->getMarcacao()->getDthrajustada(),
                            DateUtil::DEPOIS)
                    ) {
                        // trabalho
                        $idIntervalo = self::TRABALHO;
                        self::contabTrab($intervaloAtual);

                    } else {
                        // decidir o que gerar ??? falta marc saida
                    }
                } else {
                    if (($marcNext->getIdEntradaSaida() == self::SAIDA) ||
                        ($marcFim->getMarcacao()->getIdenquadrahorario() == self::SIM)
                    ) {
                        // trabalho
                        $idIntervalo = self::TRABALHO;
                        self::contabTrab($intervaloAtual);
                    } else {
                        // Se E S marc_ini não existe mas gerou na virada
                        // existia intervalo antes é extra
                        if ($marcIni->getIdMarcacao() == self::VIRADA) { // v - Virada do dia (23:59 - 00:00)
                            // e EXTRA na virada da noite
                            $idIntervalo = self::EXTRA;
                            self::contabExtra($intervaloAtual);
                        } else {
                            if ($this->escalaHistorico->getIdcompensaatraso() == self::SIM) {
                                //{ deveria ter entrado e nao entrou ATRASO
                                $idIntervalo = self::ATRASO;
                                self::contabAtraso($intervaloAtual);
                            } else {
                                //  Se o func veio de manha saiu antes do almoco e nao
                                //  voltou é considerado saida e nao atraso na
                                //  parte da tarde
                                $idIntervalo = self::SAIDA_INT;
                                self::contabSaida($intervaloAtual);
                            }
                        }
                    }
                }
            } else {
                // deveria ter entrado e nao entrou ATRASO
                // Tratamento para gerar atrasos e saidas
                // de acordo com a ausencia da marcacao (manhã ou trade)

                // Verificação para gerar atraso somente para a primeira marcação para par de
                // marcaçÃµes geradas pelo sistema, quando ainda não encontrou primeira marcação válida.
                // Prevalece sobre o parm. COMPENSA_ATRASO quando ativo

                if ($this->escalaHistorico->getIdatrasosoprimarc() == self::SIM) {
                    if (($controle['PRIMMARCEXISTE'] == false) && ($controle['PASSOUPRIMMARC'] == false)) {
                        $idIntervalo = self::ATRASO;
                        self::contabAtraso($intervaloAtual);
                    } else {
                        $idIntervalo = self::SAIDA_INT;
                        self::contabSaida($intervaloAtual);
                    }
                } else {
                    if ($this->escalaHistorico->getIdcompensaatraso() == self::SIM) {
                        // deveria ter entrado e nao entrou ATRASO
                        $idIntervalo = self::ATRASO;
                        self::contabAtraso($intervaloAtual);
                    } else {
                        // se o func veio de manha saiu antes do almoco e nao
                        // voltou eles consideram saida e nao atraso na
                        // parte da tarde

                        $idIntervalo = self::SAIDA_INT;
                        self::contabSaida($intervaloAtual);
                    }
                }
            }
        } else {
            if ($marcIni->getMarcacao()->getIdenquadrahorario() == self::SIM) {
                if ((self::marcacaoAutomatica($marcIni)) &&
                    ($marcFim->getIdMarcacao() == self::BALIZA) &&
                    (($marcNext->getIdMarcacao() == self::REGISTRO) ||($marcNext->getIdMarcacao() == self::DIGITADA))
                ) {
                    // a marc_ini foi gerada automaticamente e o cara
                    // nao marcou saida
                    // deveria ter entrado e nao entrou ATRASO
                    if ($this->escalaHistorico->getIdcompensaatraso() == self::SIM) {
                        $idIntervalo = self::ATRASO;
                        self::contabAtraso($intervaloAtual);
                    } else {
                        // se o func veio de manha saiu no almoco e nao
                        // voltou eles consideram saida e nao atraso na
                        // parte da tarde
                        $idIntervalo = self::SAIDA_INT;
                        self::contabSaida($intervaloAtual);
                    }
                } else {
                    // Nem sempre que der impar significa que nao entrou dentro do horario de trabalho,
                    // no caso de varias saidas/entradas durante o expediente esta condicao fura...
                    // Esta condicao furou para HSR. Se for entrada dentro do expediente,
                    // a marcacao final tambem tem que enquadrar no horario. Pode dar problema Dori.
                    if (($marcIni->getIdDentroHoraBase() == self::SIM) ||
                        (($marcIni->getMarcacao()->getIdenquadrahorario() == self::SIM) &&
                            ($marcFim->getMarcacao()->getIdenquadrahorario() == self::SIM))
                    ) {
                        // entrou no horario normal TRABALHO
                        if (($marcFim->getIdMarcacao() != self::BALIZA) ||
                            (is_object($marcNext))
                        ) {
                            $idIntervalo = self::TRABALHO;
                            self::contabTrab($intervaloAtual);
                        } else {
                            // a marc_ini foi gerada automaticamente e o cara
                            // nao marcou saida
                            // deveria ter entrado e nao entrou ATRASO
                            $idIntervalo = self::ATRASO;
                            self::contabAtraso($intervaloAtual);
                        }
                    } else {
                        // entrou fora do horario EXTRA
                        // Resolve problema de entrada no intervalo
                        // com extra no final
                        if (($marcFim->getIdMarcacao() != self::BALIZA) ||
                            (($marcNext->getIdMarcacao() == self::REGISTRO) || ($marcNext->getIdMarcacao() == self::DIGITADA))
                        ) {
                            $idIntervalo = self::TRABALHO;
                            self::contabTrab($intervaloAtual);
                        } else {
                            // Só faz se nao tiver atraso no dia
                            if ($this->existeAtraso == false) {
                                // continua como antes
                                //entrou fora do horario EXTRA
                                $idIntervalo = self::EXTRA;
                                self::contabExtra($intervaloAtual);
                            }
                        }
                    }
                }
            } else {
                if ($marcIni->getIdDentroHoraBase() == self::SIM) {
                    // entrou atrasado no trabalho normal
                    if ((($marcFim->getIdMarcacao() == self::REGISTRO) || ($marcFim->getIdMarcacao() == self::DIGITADA))||// self::BALIZA) ||
                        isset($marcNext)
                    ) {
                        $idIntervalo = self::TRABALHO;
                        self::contabTrab($intervaloAtual);
                    } else {
                        //  decidir o que gerar ???andand### falta marc saida
                    }
                } else {
                    //  entrou fora do horario EXTRA
                    $idIntervalo = self::EXTRA;
                    self::contabExtra($intervaloAtual);
                }
            }
        }

        return $idIntervalo;
    }

    private function identificaIntervaloEE($intervaloAtual, &$controle)
    {
        $idIntervalo = self::IGNORADO;

        $marcIni = $intervaloAtual->MARCINI;
        $marcFim = $intervaloAtual->MARCFIM;
        $marcNext = $intervaloAtual->MARCNEXT;
        $marcIniAnt = $intervaloAtual->MARCINIANT;
        $marcFimAnt = $intervaloAtual->MARCFIMANT;

        /** @var RegistroPonto $marcIniAnt */
        /** @var RegistroPonto $marcFimAnt */
        /** @var RegistroPonto $marcIni */
        /** @var RegistroPonto $marcFim */
        /** @var RegistroPonto $marcNext */

        if ($marcIni->getIdMarcacao() == self::BALIZA || $marcIni->getIdMarcacao() == self::PROJETADA) {
            // Tratamento para gerar atrasos e saidas
            // de acordo com a ausencia da marcacao (manhã ou trade)

            // Verifica se gera atraso somente para a primeira marcação. Caso Sim, atrasos
            //posteriores no mesmo dia geram saída antecipada
            if ($this->escalaHistorico->getIdatrasosoprimarc() == self::SIM && $controle['PRIMMARCEXISTE'] == false) {
                $idIntervalo = self::SAIDA_INT;
                self::contabSaida($intervaloAtual);
            } else {
                // deveria ter entrado e entrou mais tarde ATRASO
                // Verifica se um intervalo foi abonado logo antes desse, que envolve uma baliza, logo deve ser abonado também
                if(!is_null($intervaloAtual->MARCINIANT) && !is_null($intervaloAtual->MARCINIANT->getMarcacao()->getDsjustificativa()) &&
                                                                     $intervaloAtual->MARCINIANT->getMarcacao()->getDsjustificativa()    != ''
                    && $marcIni->getIdMarcacao() == self::BALIZA) {
                    $idIntervalo = self::TRABALHO;
                    self::contabTrab($intervaloAtual);
                }
                else {
                    $idIntervalo = self::ATRASO;
                    self::contabAtraso($intervaloAtual);
                }
            }
            $controle['PRIMMARCEXISTE'] = false;
            $controle['PASSOUPRIMMARC'] = true;

        } else {
            if ($marcFim->getIdMarcacao() == self::BALIZA) {
                if ($marcIni->getMarcacao()->getIdenquadrahorario() == self::SIM) {
                    $idIntervalo = self::TRABALHO;
                    self::contabTrab($intervaloAtual);
                } else {
                    // entrou antecipadamente EXTRA
                    $idIntervalo = self::EXTRA;
                    self::contabExtra($intervaloAtual);
                }
            } else {
                // entrou antecipadamente EXTRA
                $idIntervalo = self::EXTRA;
                self::contabExtra($intervaloAtual);
            }
        }

        return $idIntervalo;
    }

    private function identificaIntervaloSS($intervaloAtual, &$controle)
    {
        $idIntervalo = self::IGNORADO;

        $marcIni = $intervaloAtual->MARCINI;
        $marcFim = $intervaloAtual->MARCFIM;
        $marcNext = $intervaloAtual->MARCNEXT;
        $marcIniAnt = $intervaloAtual->MARCINIANT;
        $marcFimAnt = $intervaloAtual->MARCFIMANT;

        /** @var RegistroPonto $marcIniAnt */
        /** @var RegistroPonto $marcFimAnt */
        /** @var RegistroPonto $marcIni */
        /** @var RegistroPonto $marcFim */
        /** @var RegistroPonto $marcNext */

        if ($marcIni->getIdMarcacao() == self::BALIZA) {
            // deveria ter saido e saiu mais tarde EXTRA
            $idIntervalo = self::EXTRA;
            self::contabExtra($intervaloAtual);
        } else {
            if ($marcFim->getIdMarcacao() == self::BALIZA) {
                // saiu antecipadamente
                if(!is_null($marcIni->getMarcacao()->getDsjustificativa())) {
                    $marcFim->getMarcacao()->setDsjustificativa($marcIni->getMarcacao()->getDsjustificativa());
                }
                $idIntervalo = self::SAIDA_INT;
                self::contabSaida($intervaloAtual);
            }
        }

        return $idIntervalo;
    }

    private function identificaIntervaloSE($intervaloAtual, &$controle, $paramEscala)
    {
        $idIntervalo = self::IGNORADO;
        $intervalosHorarios = $this->horario->getIntervalosHorario();

        $marcIni = $intervaloAtual->MARCINI;
        $marcFim = $intervaloAtual->MARCFIM;
        //Não utilixou até o momento
//        $marcNext = $intervaloAtual->MARCNEXT;
//        $marcIniAnt = $intervaloAtual->MARCINIANT;
//        $marcFimAnt = $intervaloAtual->MARCFIMANT;

        /** @var RegistroPonto $marcIniAnt */
        /** @var RegistroPonto $marcFimAnt */
        /** @var RegistroPonto $marcIni */
        /** @var RegistroPonto $marcFim */
        /** @var RegistroPonto $marcNext */

        // Vitor Peixoto 17/06/2015 Correção gerar trabalho quando intervalo for feito em outro horário
        $whereProgIntervalo = "NRVINCULOM = ?
                           AND IDATIVO    = 'S'
                           AND NRORG      = ?
                           AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, TO_DATE(?, 'DD/MM/YYYY'))
                           AND NRMARCACAOPONTO IS NOT NULL
                           AND NRINTERVALOHORARIO IS NOT NULL
                           AND IDPROGOCORCONFIRMADA = 'S'
                           AND (IDTIPODIACALENDARIO IS NULL OR IDTIPODIACALENDARIO = ?)
                           AND (IDTIPOHORARIO IS NULL OR IDTIPOHORARIO = ?)";

        $paramsProgIntervalo = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->data->format(DateUtil::FORMATO_BRASILEIRO),
            $this->idDiaCalend,
            $this->horario->getHorarioHistorico()->getIdtipohorario()
        );

        $progOcorIntervalo = PtoProgocorrencia::getObjectsByWhere($whereProgIntervalo, $paramsProgIntervalo);

        if (($marcFim->getIdMarcacao() == self::BALIZA) &&
            ($marcIni->getIdMarcacao() == self::BALIZA)
        ) {
            $marcFim->getMarcacao()->setDsjustificativa($marcIni->getMarcacao()->getDsjustificativa());
            //  se ini S e fim E e ambas as marcacoes sao inexistentes
            //  foram geradas pelo sistema sem serem automaticas
            if ($controle['DENTROEMPRESA'] == self::SIM) {
                if (!is_object($this->situFreq)) {
                    /* deveria ter saido e voltado - nao saiu EXTRA */
                    /* parametrizar se gera extra ou nao gera nada ????####andand */

                    // Vitor Peixoto 17/06/2015 Correção gerar trabalho quando intervalo for feito em outro horário
                    /** @var PtoProgocorrencia $programacaoOcor */
                    foreach ($progOcorIntervalo as $programacaoOcor) {
                        /** @var PtoTipoprogocorrencia $tipoProgOcor */
                        $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoOcor->getNrtipoprogocorrencia());
                        if ($tipoProgOcor->getCdtipoprogocorrencia() == self::IDENTIFICA_INTERVALO) {
                            $intervaloSaida = $programacaoOcor->getIntervalohorario();
                            if (!is_null($intervaloSaida)) {
                                $whereClause = "NRORG             = ?
                                            AND NRHORDIAM         = ?
                                            AND HRENTRADA         >
                                               (SELECT INTERVALOS.HRSAIDA
                                                  FROM GPE_INTERVALOSHORARIO INTERVALOS
                                                 WHERE INTERVALOS.NRORG   = ?
                                                   AND INTERVALOS.NRINTERVALOHORARIO = ?
                                                   AND INTERVALOS.NRHORDIAM = ?
                                               ) ORDER BY HRENTRADA";

                                $paramsIntervaloSaida = array($this->nrorg,
                                    $intervaloSaida->getNrhordiam(),
                                    $this->nrorg,
                                    $intervaloSaida->getNrintervalohorario(),
                                    $intervaloSaida->getNrhordiam());

                                /** @var GpeIntervaloshorario $intervaloEntrada */
                                $intervaloEntrada = GpeIntervaloshorario::getObjectByWhere($whereClause, $paramsIntervaloSaida);

                                if ($intervaloSaida->getHrsaida() == str_replace(':', '', $intervaloAtual->MARCINI->getMarcacao()->getDthrajustada()->format(self::FORMATO_HORA_MINUTO)) ||
                                    $intervaloEntrada->getHrentrada() == str_replace(':', '', $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada()->format(self::FORMATO_HORA_MINUTO))
                                ) {
                                    $idGeraTrabalho = true;
                                }
                            }
                        }
                    }

                    if ($this->escalaHistorico->getIdhextranmarcinterv() == self::SIM && $idGeraTrabalho) {
                        $idIntervalo = self::TRABALHO;
                        self::contabTrab($intervaloAtual);
                    }
                    else {
                        $idIntervalo = self::EXTRA;
                        self::contabExtra($intervaloAtual);
                    }

                    /* Código antigo considerando apenas extra
                    if ($this->escalaHistorico->getIdhextranmarcinterv() == self::SIM) {
                        $idIntervalo = self::EXTRA;
                        self::contabExtra($intervaloAtual);
                    }
                    */
                    // END Vitor Peixoto 17/06/2015

                    /* o sistema trata este intervalo como se as marcacoes fossem */
                    /* validas e invertidas e / s e apura como extra */
                    /* para que ele apure corretamente o intervalo seguinte e' */
                    /* necessario marretar o intervalo como valido e enquadrado */
                    /* no horario */
//                  iuo_marcacao.ids_cmarc.setitem (marc_ini, "inexistente", C_DA02_NAO)
//                  iuo_marcacao.ids_marcs.setitem (marc_ini, "enquadra_horario", C_DA02_SIM);
//                  iuo_marcacao.ids_cmarc.setitem (marc_fim, "inexistente", C_DA02_NAO);
//                  iuo_marcacao.ids_marcs.setitem (marc_fim, "enquadra_horario", C_DA02_SIM);
//                  iuo_marcacao.ids_cmarc.setitem (marc_fim, "nro_marc", 1);

                    /* gera situacao de alerta para verificacao do usuario */
                    /* func nao marcou intervalo entrou e saiu marcando */
                    /* so as extremidades */
                    $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

                    if (self::verificaAssocSituFreq(self::NAO_MARCOU_INTERV)) {
                        $calcSituFreq[self::NAO_MARCOU_INTERV]['HORAS'] = 1;
                        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
                    }
                }
            }
        } else {

            $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
//              if feito so para gerar atraso na volta do almoco com
//              larga tolerancia e maximo de uma hora
            if (($marcFim->getMarcacao()->getIdenquadrahorario() == self::SIM) && ($marcIni->getMarcacao()->getIdenquadrahorario() == self::SIM)) {
                // intervalo apurado
                $somaAux = DateUtil::getIntervaloEmSegundos($marcIni->getMarcacao()->getDthrmarcacaoponto(),
                        $marcFim->getMarcacao()->getDthrmarcacaoponto())/3600;
                if (self::verificaAssocSituFreq(self::INTERVALO_ORIGINAL)) {
                    $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] = $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] + $somaAux;
                }
                if ($this->escalaHistorico->getIdprojetaintervalo() == self::SIM) {
                    $somaAux = DateUtil::getIntervaloEmSegundos($marcIni->getMarcacao()->getDthrajustada(),
                            $marcFim->getMarcacao()->getDthrajustada())/3600;
                    // Ver proj interv no horario
                    if (DateUtil::getHoraFloatDeString($marcFim->getHorarioCorrente()->HRPROJETARINTERVALO) > 0) {
                        $qtdHrAProjInterv = DateUtil::getHoraFloatDeString(self::formataHora($marcFim->getHorarioCorrente()->HRPROJETARINTERVALO));
                    } else {
                        $qtdHrAProjInterv = DateUtil::getHoraFloatDeString(self::formataHora($this->escalaHistorico->getQthrprojetaintervalo()));
                    }
                    if ($somaAux > $qtdHrAProjInterv) {
//                          Criado parâmetro para tratar qtde de projeção
//                          como hora mínima de almoço, evitando que se gere atraso caso
//                          o func. venha a fazer mais de n qtde proj
//                          Na PBH o func. tem 2 horas de almoço porém com mínimo de 1
//                          hora. Se o func fazia as 2 horas de almoço como estava projetando intervalo
//                          de 1 hora ele gerava mais 1 hora de atraso.
                        if ($paramEscala['TRATA_PROJ_HOR_MIN'] != self::SIM) {
                            $somaAux = $somaAux - $qtdHrAProjInterv;
                            $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] = $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] + $somaAux;
                        }
//                          ?????##### testar noite e somar corretamente
                        $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'] = $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'] + $intervaloAtual->HORANOT;
                    }
                }
//                  rigel p/ acil 09/07/96
                if ($this->escalaHistorico->getIdadcnoturnointervalo() /*['ADC_NOT_INTERV_REF']*/ == self::SIM) {
                    // 30/09/05 - Nádia - incorporar intervalo somente se houver marcaçoes reais no dia
                    // pois estava fazendo quando existia somente automatica - HMT
                    if (self::existeMarcacoesRegistro()) {
//                         considera adc not no intervalo de horario noturno
                        $calcSituFreq[self::ADICIONAL_NOTURNO]['HORAS'] = $calcSituFreq[self::ADICIONAL_NOTURNO]['HORAS'] + $intervaloAtual->HORANOT;
                        // 01/10/01 - Manuel - adiciona hora nao compressiva referente intervalo
                        // refeicao
                        // 30/09/05 - Nádia - acumular horas; a hora compress será calculada no final - HMT
                        $this->idHorasNotAdic = $this->idHorasNotAdic + $intervaloAtual->HORANOT;
                    }
                }
                // 17/11/99 - rigel - apura interavlo em situacao específica
                if (self::verificaAssocSituFreq(self::INTERVALO_APURADO)) {
                    $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] = $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] + $intervaloAtual->HORADIA;
                    $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] = $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] + $intervaloAtual->HORANOT;
                }
            } else {
                //Vitor Peixoto 25/05/2015 Considerar marcações digitadas
                if ((($marcFim->getIdMarcacao() == self::REGISTRO) || ($marcFim->getIdMarcacao() == self::DIGITADA)) &&
                    (($marcIni->getIdMarcacao() == self::REGISTRO) || ($marcIni->getIdMarcacao() == self::DIGITADA)) &&
                    ($this->escalaHistorico->getIdhextranmarcinterv() == self::SIM || $marcIni->getMarcacao()->getIdenquadrahorario() == self::NAO)
                ) {
                    if ($this->horario->getHorarioHistorico()->getIdtipohorario() != self::FOLGA) {
                        //<editor-fold desc="Vitor Peixoto 19/10/2015 Modificação para verificar se a saída está dentro do HB">
                        /*if ((!is_null($marcIni->getIntervaloBaseIni()) && !DateUtil::comparaDatas($marcIni->getMarcacao()->getDthrajustada(),
                                                            $marcIni->getIntervaloBaseIni(),
                                                            DateUtil::ANTES)) &&
                                                    (!is_null($marcIni->getIntervaloBaseFim()) && DateUtil::comparaDatas($marcFim->getMarcacao()->getDthrajustada(),
                                                            $marcIni->getIntervaloBaseFim(),
                                                            DateUtil::ANTES))
                                                ) {*/
                        //</editor-fold>
                        if($marcIni->getIdDentroHoraBase() == self::SIM) {
                            // saida dentrp intervalo
                            //06/09/05 FabioL - Separa saidas em periodos

                            $idIntervalo = self::SAIDA_INT;
                            /** @var PtoProgocorrencia $progIntervalo */
                            foreach($progOcorIntervalo as $progIntervalo) {
                                if($progIntervalo->getNrmarcacaoponto() == $marcIni->getMarcacao()->getNrmarcacaoponto()) {
                                    $idIntervalo = self::IGNORADO;
                                }
                            }

                            if($idIntervalo == self::SAIDA_INT) self::contabSaida($intervaloAtual);
                            //Substituído por contabSaidas
                            //f_ho_acu_horas(id_saidas_nao_contab, f_ho_add_horas(iuo_marcacao.ids_cmarc.getitemnumber (marc_fim, "horas_dia"),iuo_marcacao.ids_cmarc.getitemnumber (marc_fim, "horas_noite")));
                            //uf_separa_atrsaihex_periodos(marc_fim, iuo_pt.C_SAIDAS_DIA);
                        } else {
                            // 01/06/04 - Rigel - refeito
                            // 20/05/04 - claudio - na verdade, deve checar também se nao esta antes do primeiro horario
                            // no caso de entrar e sair antes do inicio de horario é apenas extra e já foi contabilizado
                            // na analise do E/S
                            if (!is_null($marcIni->getIntervaloBaseIni()) &&
                                DateUtil::comparaDatas($marcIni->getMarcacao()->getDthrajustada(),
                                    $marcIni->getIntervaloBaseIni(),
                                    DateUtil::DEPOIS)
                            ) {
                                // 19/02/01 - claudio - verificar ultimo horario para ver se a marcacao
                                // realmente é uma saida (so se estiver antes da ultima hora do horario)
                                $ultimoHorario = count($intervalosHorarios);
                                // 02/12/02 - Patrícia/Nádia - Estava dando erro na apuração, no caso de não existirem horários válidos
                                if ($ultimoHorario > 0) {
                                    if (DateUtil::comparaDatas($marcIni->getMarcacao()->getDthrajustada(),
                                        $intervalosHorarios[$ultimoHorario - 1]['DTHORABASE'],
                                        DateUtil::ANTES)
                                    ) {
                                        // 30/08/00 - claudio - so é saida se tem terceiro horario cadastrado - dori
                                        if ($ultimoHorario > 2) {
                                            // saiu antecipadamente e voltou SAIDAS
                                            // 15/05/02 - Manuel/Eliz - feito condição para tratamento para
                                            // não gerar saídas antecipadas caso não exista intervalo projetado
                                            // Professores - FRSP
                                            if (($this->escalaHistorico->getIdprojetaintervalo() == self::SIM) ||
                                                (DateUtil::getHoraFloatDeString($this->escalaHistorico->getQthrprojetaintervalo()) > 0) ||
                                                DateUtil::getHoraFloatDeString($marcIni->getHorarioCorrente()->HRPROJETARINTERVALO) > 0
                                            ) {
                                                if(is_null($marcIni->getDsIntervaloProjetado()) || $marcIni->getDsIntervaloProjetado() == ''){
                                                    $idIntervalo = self::SAIDA_INT;

                                                    self::contabSaida($intervaloAtual);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    } else {
                        // 07/11/01 - Manuel - geracao intervalo refeicao para tratamento
                        // por fórmula nas folgas (sáb,dom e feriado) em função de tratamento
                        // para abril conforme comentado abaixo
                        if (self::verificaAssocSituFreq(self::INTERVALO_ORIGINAL)) {
                            $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] = $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] + $intervaloAtual->HORADIA;
                            $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] = $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] + $intervaloAtual->HORANOT;
                        }
                        if (self::verificaAssocSituFreq(self::INTERVALO_APURADO)) {
                            $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] = $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] + $intervaloAtual->HORADIA;
                            $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] = $calcSituFreq[self::INTERVALO_APURADO]['HORAS'] + $intervaloAtual->HORANOT;
                        }
                    }
                }
            }
        }
        if (self::existeMarcacoesRegistro()) {
            if (($this->escalaHistorico->getIdturnointervaloextra() == self::SIM && $this->horario->getHorarioHistorico()->getIdtipohorario() == self::TURNO &&
                    $this->idDiaCalend == self::FERIADO && $this->escalaHistorico->getIdturnoextraferiado() == self::SIM) ||
                ($this->escalaHistorico->getIddescintervalofolga() == self::NAO && $this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) ||
                ($this->escalaHistorico->getIddescintervaloferiado() == self::NAO && $this->idDiaCalend == self::FERIADO) ||
                ($this->escalaHistorico->getIddescintervalosabado() == self::NAO && (DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6))
            ) { //6 -->sábado

                // desde de que nao ultrapasse a qtde projeta intervalo
                // rigel 22/10/99
                //ld_interv_aux - SUBSTITUIDO POR $intervaloAtual->HORA

                //29/10/01 - Manuel - gera intervalo original na folga - Drogaria SP
                if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
                    if (self::verificaAssocSituFreq(self::INTERVALO_ORIGINAL)) {
                        //27/11/01 - Manuel - estava dobrando em função de tratamentos em
                        //pontos diferentes (necessários os dois)
                        if ($calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] == 0) {
                            $calcSituFreq[self::INTERVALO_ORIGINAL]['HORAS'] = $calcSituFreq['INTERVALO_ORIGINAL']['HORAS'] + $intervaloAtual->HORA;
                        }
                    }
                }

                // 23/08/05 - claudio - Antes de contabilizar HE, vai analisar se esta S e E estão dentro do horario previsto,
                //                      pois se estiver, não faz sentido gerar extra, pois é trabalho normal
                $ultimoHorario = count($intervalosHorarios);
                if ($ultimoHorario > 0) {
                    //Testa entre o primeiro e o ultimo intervaloHorario
                    if (!(DateUtil::comparaDatas($marcIni->getMarcacao()->getDthrajustada(),
                            $intervalosHorarios[0]['DTHORABASE'],
                            DateUtil::DEPOIS)) ||
                        !(DateUtil::comparaDatas($marcIni->getMarcacao()->getDthrajustada(),
                            $intervalosHorarios[$ultimoHorario - 1]['DTHORABASE'],
                            DateUtil::ANTES))
                    ) {
                        $idIntervalo = self::EXTRA;
                        self::contabExtra($intervaloAtual);
                    }
                } else {
                    $idIntervalo = self::EXTRA;
                    self::contabExtra($intervaloAtual);
                }
            }
        }

        // LEONARDOCARVALHO - 17/11/2015 - Não ignora saída fora da jornada para ESTAGIÁRIOS
        /** @var \Folha\Entities\GpeVinculom $vinculom */
        /*$vinculom = \Folha\Entities\GpeVinculom::findOneByNrorgAndNrvinculom($this->nrorg, $this->nrvinculom);
        if ($vinculom->getNrtipovinculom() == '2') {
            $idIntervalo = self::SAIDA_INT;
            self::contabSaida($intervaloAtual);
        }*/

        return $idIntervalo;
    }

    private function existeMarcacoesRegistro()
    {
        /** @var $registro RegistroPonto */
        foreach ($this->registros as $registro) {
            if ($registro->getIdMarcacao() == self::REGISTRO || $registro->getIdMarcacao() == self::DIGITADA) {
                return true;
            }
        }

        return false;
    }

    private function verificaAssocSituFreq($cdCalcSituFreq)
    {
        /** @var PtoCalculositufreq $calcSituFreq */
        $calcSituFreq = PtoCalculositufreq::findOneByCdcalculositufreq($cdCalcSituFreq);
        $nrOrgPadrao = FPA::getNrorgPadrao();
        $nrOrgTrabalho = FPA::getNrorg();
        $assocSituFreq = null;
        if (is_object($calcSituFreq) && is_object($this->situFreq)) {
            $whereAssocSituFreq = "NRSITUFREQUENCIA  = ?
                               AND NRCALCULOSITUFREQ = ?
                               AND NRORG IN (?, ?)";
            $paramsAssocSituFreq = array(
                $this->situFreq->getNrsitufrequencia(),
                $calcSituFreq->getNrcalculositufreq(),
                $nrOrgPadrao,
                $nrOrgTrabalho
            );

            /** @var PtoAssocsitufreq $assocSituFreq */
            $assocSituFreq = PtoAssocsitufreq::getObjectByWhere($whereAssocSituFreq, $paramsAssocSituFreq);
        }

        if (is_object($assocSituFreq)) {
            return true;
        }
        return false;
    }

    private function verificaExisteMarcVirada()
    {
        $dtStMarcVirada = DateUtil::adicionaIntervalo($this->data, 1, DateUtil::DIA)->format(DateUtil::FORMATO_BRASILEIRO);
        $dtHrStMarcVirada = $dtStMarcVirada . ' 00:00';
        $dtHrMarcVirada = DateUtil::getDataDeString($dtHrStMarcVirada, self::FORMATO_DATA_HORAMINUTO);

        /** @var RegistroPonto $registro */
        foreach ($this->registros as $registro) {
            if (DateUtil::comparaDatas($registro->getMarcacao()->getDthrajustada(), $dtHrMarcVirada, DateUtil::IGUAL)
            ) {
                return true;
            }
        }
        return false;
    }

    /**
     * @return mixed
     */
    public function getIniPerApur()
    {
        return $this->iniPerApur;
    }

    /**
     * @param mixed $iniPerApur
     */
    public function setIniPerApur($iniPerApur)
    {
        $this->iniPerApur = $iniPerApur;
    }

    private function getRegistroPosicao($registro)
    {
        /** @var RegistroPonto $registroDia */
        foreach ($this->registros as $key => $registroDia) {
            /** @var RegistroPonto $registro */
            if (DateUtil::comparaDatas($registroDia->getMarcacao()->getDthrajustada(),
                $registro->getMarcacao()->getDthrajustada(),
                DateUtil::IGUAL)
            ) {
                return array('CHAVE'    => $key,
                             'REGISTRO' => $registroDia);
            }
        }
    }

    public function getDatasourceIntervalos()
    {
        $dadosIntervalos = array();

        /** @var PtoIntervalosmarcacao $intervaloRegistrado */
        foreach($this->intervalosRegistros as $intervaloRegistrado){
            $dadosIntervalos[] = array(
                'HRINICIO'                => $intervaloRegistrado->getMarcacaopontoini()->getDthrajustada()->format(self::FORMATO_HORA_MINUTO),
                'HRFIM'                   => $intervaloRegistrado->getMarcacaopontofim()->getDthrajustada()->format(self::FORMATO_HORA_MINUTO),
                'TEMPODIA'                => DateUtil::getHoraStringDeFloat($intervaloRegistrado->getQtintervmarcdiurno(), true),
                'TEMPONOT'                => DateUtil::getHoraStringDeFloat($intervaloRegistrado->getQtintervmarcnoturno(), true),
                'IDINTERVALOMARCACAO'     => $intervaloRegistrado->getIdintervalomarcacao(),
                'DSINTERVALOIDENTIFICADO' => $intervaloRegistrado->getDsintervaloidentificado());
        }

        return $dadosIntervalos;
    }

    public function getDatasourceTotalizacao()
    {
        $dadosTotalizacao = array();

        /** @var PtoResumositufreq $currentResumo */
        foreach($this->resumosSituFreqs as $key => $currentResumo){
            $nmEventoH = '';
            /** @var PtoSitufrequencia $situFreq */
            $situFreq = PtoSitufrequencia::findOneByNrsitufrequenciaAndNrorg($currentResumo->getNrsitufrequencia(), $currentResumo->getNrorg());
            if(!is_object($situFreq)){
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $situFreq = PtoSitufrequencia::findOneByNrsitufrequenciaAndNrorg($currentResumo->getNrsitufrequencia(), $nrOrgPadrao);
            }
            if(is_object($situFreq)){
                /** @var PtoSitufreqparam $paramsSituFreq */
                $paramsSituFreq = PtoSitufreqparam::findOneByNrsitufrequenciaAndNrorg($situFreq->getNrsitufrequencia(), $situFreq->getNrorg());
                
                if(is_object($paramsSituFreq)){
                    $idTipoQtdRef = $paramsSituFreq->getIdtipoqtdereferencia();
                    $whereEvento = "NREVENTOM  = ?
                                AND NRORG      = ?
                                AND DTMESCOMPETENC IN (SELECT MAX(EVH.DTMESCOMPETENC)
                                                         FROM FPA_EVENTOH EVH
                                                        WHERE EVH.NREVENTOM  = '".$paramsSituFreq->getNreventom()."'
                                                          AND  EVH.NRORG     = '".FPA::getNrorgPadrao()."'
                                                          AND EVH.DTMESCOMPETENC <= TO_DATE(?, 'DD/MM/YYYY'))";
                    $paramsEvento = array(
                        $paramsSituFreq->getNreventom(),
                        $currentResumo->getNrorg(),
                        FPA::getDtCompetencia()
                    );

                    /** @var FpaEventoh $eventoH */
                    $eventoH = FpaEventoh::getObjectByWhere($whereEvento, $paramsEvento);

                    if(!is_object($eventoH)){
                        $paramsEvento = array(
                            $paramsSituFreq->getNreventom(),
                            FPA::getNrorgPadrao(),
                            FPA::getDtCompetencia()
                        );

                        $eventoH = FpaEventoh::getObjectByWhere($whereEvento, $paramsEvento);

                        if(is_object($eventoH)){
                            $nmEventoH = $eventoH->getNmeventoh();
                        }
                    }
                    else{
                        $nmEventoH = $eventoH->getNmeventoh();
                    }
                }
                else{
                    $idTipoQtdRef = null;
                }

                //Verifica se é situação de advertência
                $nrCorAdvert      = null;
                $nrPrioridade     = null;
                $dsCorHexadecimal = null;
                $advertSituFreq = $situFreq->getAdvertsitufreq();
                if(is_object($advertSituFreq)){
                    $nrCorAdvert = $advertSituFreq->getNrcoradvertsitufreq();
                    $nrPrioridade = $advertSituFreq->getNrPrioridade();
                    $dsCorHexadecimal = $advertSituFreq->getDsCorHexadecimal();
                }
            }
            else{
                $idTipoQtdRef = null;
            }

            switch($idTipoQtdRef){
                case self::HORA:
                    $qtdRef = round($currentResumo->getQtrefapursitufreq(), 2);
                    break;
                case self::DIAS:
                    $qtdRef = round(($currentResumo->getQtrefapursitufreq()/24),2);
                    break;
                case self::HRMI:
                    $qtdRef = DateUtil::getHoraStringDeFloat($currentResumo->getQtrefapursitufreq(), true);
                    break;
                case self::COTA:
                case self::DOZEAV:
                case self::PERCENTUAL:
                default:
                    $qtdRef = round($currentResumo->getQtrefapursitufreq(),2);
                    break;
            }
            $dadosTotalizacao[] = array(
                'DSCALCULOSITUFREQ'   => $situFreq->getDssitufrequencia(),
                'QTREFAPURSITUFREQ'   => $qtdRef,
                'NMEVENTOH'           => $nmEventoH,
                'NRCORADVERTSITUFREQ' => $nrCorAdvert,
                'IDDEMONSTRATIVO'     => in_array($currentResumo, $this->idDemonstrativos),
                'DSCORHEXADECIMAL'    => $dsCorHexadecimal,
                'NRPRIORIDADE'        => $nrPrioridade
                 
            );
        }

        return $dadosTotalizacao;
    }

    private function marcacaoAutomatica($marcIni)
    {
        //self::AUTOMATICA -> Marcação automática ou 'i' -> Marcacao Incondicional
        /** @var RegistroPonto $marcIni */
        return $marcIni->getIdMarcacao() == self::AUTOMATICA || $marcIni->getIdMarcacao() == 'i';
    }

    private function acumulaExtra($antesLimite, $depoisLimite, $horas)
    {
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

        $qthrlimitesephextra = DateUtil::getHoraFloatDeString($this->qtLimiteSeparacaoHoraExtra/*$this->escalaHistorico->getQthrlimitesephextra()*/);
        $extrasAux = 0;
        $para_comp_limite = 0; /* qto falta para completar limite */
        //$ld_horas_quebra  // 05/05/06 - Nadia

        if ($this->extrasNoDia < $qthrlimitesephextra) {
            $para_comp_limite = $qthrlimitesephextra - $this->extrasNoDia;
        } else {
            $para_comp_limite = 0;
        }

        $this->extrasNoDia = $this->extrasNoDia + $horas;

        if ($this->extrasNoDia <= $qthrlimitesephextra) {

            $calcSituFreq [$antesLimite]['HORAS'] = $calcSituFreq [$antesLimite]['HORAS'] + $horas;

        } else {
            $calcSituFreq [$antesLimite]['HORAS'] = $calcSituFreq [$antesLimite]['HORAS'] + $para_comp_limite;

            $extrasAux = $horas - $para_comp_limite;

            $calcSituFreq[$depoisLimite]['HORAS'] = $calcSituFreq[$depoisLimite]['HORAS'] + $extrasAux;
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    /*
     * @author ingridmoreira
     */
    public function prepSits($idDiaCalendSeg, $tpHorPost)
    {
        // rigel 26/01/99
        // atualiz
        // 20/12/00 - rigel/claudio - estava acessando horario corrente e trocamos para o do dia seguinte
        // marreta resolver rigel 26/01/99

        $isSabado = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6;
        $isSexta  = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 5;

        /* #ifdef IS_HSR
             (ac_calend = 'D') or
             so para o HSSR
             no hsr a extra no domingo e perc mais alto mesmo nao sendo folga da enfermeira
             na danone a extra no domingo para quem tem folga em outro dia e perc baixo
             bolar esquema (parm) na escala para indicar
        #endif IS_HSR
             criar outro conjunto de situacoes para o domingo
        */
        if ($this->idDiaCalend == self::FERIADO) {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idExtraDia   = self::EX_DIA_FERIAD_1AS;
                $this->idExtraDia2  = self::EX_DIA_FERIAD_SEG;
                $this->idExtraNot   = self::EX_NOT_FERIAD_1AS;
                $this->idExtraNot2  = self::EX_NOT_FERIAD_SEG;
                $this->idExtraNComp = self::EX_NOT_FERIAD_CP;
            } else {
                $this->idExtraDia   = self::EX_DIA_FERIAD_NP_1AS;
                $this->idExtraDia2  = self::EX_DIA_FERIAD_NP_SEG;
                $this->idExtraNot   = self::EX_NOT_FERIAD_NP_1AS;
                $this->idExtraNot2  = self::EX_NOT_FERIAD_NP_SEG;
                $this->idExtraNComp = self::EX_NOT_FERIAD_NP_CP;
            }
            $this->idTipoExtra = 3;
            $this->idJornComplementar = self::JORN_COMP_FER;
        } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idExtraDia   = self::EX_DIA_FOLGA_1AS;
                $this->idExtraDia2  = self::EX_DIA_FOLGA_SEG;
                $this->idExtraNot   = self::EX_NOT_FOLGA_1AS;
                $this->idExtraNot2  = self::EX_NOT_FOLGA_SEG;
                $this->idExtraNComp = self::EX_NOT_FOLGA_CP;
            } else {
                $this->idExtraDia   = self::EX_DIA_FOLGA_NP_1AS;
                $this->idExtraDia2  = self::EX_DIA_FOLGA_NP_SEG;
                $this->idExtraNot   = self::EX_NOT_FOLGA_NP_1AS;
                $this->idExtraNot2  = self::EX_NOT_FOLGA_NP_SEG;
                $this->idExtraNComp = self::EX_NOT_FOLGA_NP_CP;
            }
            // 21/02/06 - Nádia - voltei para 2 - rigel reintegrado
            // 30/09/05 - Nádia - folga é 5
            //      ii_tipo_extra = 5;
            $this->idTipoExtra = 2;
            $this->idJornComplementar = self::JORN_COMP_FOLG;
        } elseif ($isSabado) {
            if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                    $this->idExtraDia   = self::EX_DIA_SABADO_1AS;
                    $this->idExtraDia2  = self::EX_DIA_SABADO_SEG;
                    $this->idExtraNot   = self::EX_NOT_SABADO_1AS;
                    $this->idExtraNot2  = self::EX_NOT_SABADO_SEG;
                    $this->idExtraNComp = self::EX_NOT_SABADO_CP;
                } else {
                    $this->idExtraDia   = self::EX_DIA_SABADO_NP_1AS;
                    $this->idExtraDia2  = self::EX_DIA_SABADO_NP_SEG;
                    $this->idExtraNot   = self::EX_NOT_SABADO_NP_1AS;
                    $this->idExtraNot2  = self::EX_NOT_SABADO_NP_SEG;
                    $this->idExtraNComp = self::EX_NOT_SABADO_NP_CP;
                }
                $this->idTipoExtra = 3;
                $this->idJornComplementar = self::JORN_COMP_SAB;
            } else {
                if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                    $this->idExtraDia   = self::EX_DIA_NORMAL_1AS;
                    $this->idExtraDia2  = self::EX_DIA_NORMAL_SEG;
                    $this->idExtraNot   = self::EX_NOT_NORMAL_1AS;
                    $this->idExtraNot2  = self::EX_NOT_NORMAL_SEG;
                    $this->idExtraNComp = self::EX_NOT_NORMAL_CP;
                } else {
                    $this->idExtraDia   = self::EX_DIA_NORMAL_NP_1AS;
                    $this->idExtraDia2  = self::EX_DIA_NORMAL_NP_SEG;
                    $this->idExtraNot   = self::EX_NOT_NORMAL_NP_1AS;
                    $this->idExtraNot2  = self::EX_NOT_NORMAL_NP_SEG;
                    $this->idExtraNComp = self::EX_NOT_NORMAL_NP_CP;
                }
                $this->idTipoExtra = 1;
                $this->idJornComplementar = self::JORN_COMP_NORM;
            }
        } else {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idExtraDia   = self::EX_DIA_NORMAL_1AS;
                $this->idExtraDia2  = self::EX_DIA_NORMAL_SEG;
                $this->idExtraNot   = self::EX_NOT_NORMAL_1AS;
                $this->idExtraNot2  = self::EX_NOT_NORMAL_SEG;
                $this->idExtraNComp = self::EX_NOT_NORMAL_CP;
            } else {
                $this->idExtraDia   = self::EX_DIA_NORMAL_NP_1AS;
                $this->idExtraDia2  = self::EX_DIA_NORMAL_NP_SEG;
                $this->idExtraNot   = self::EX_NOT_NORMAL_NP_1AS;
                $this->idExtraNot2  = self::EX_NOT_NORMAL_NP_SEG;
                $this->idExtraNComp = self::EX_NOT_NORMAL_NP_CP;
            }
            $this->idTipoExtra = 1;
            $this->idJornComplementar = self::JORN_COMP_NORM;
        }

        /*=======hssr============================*/
        /* ???????? VIRAR PARAMETRO ????????? */
        /* so para o HSSR */ /* rigel 26/03/99 - rever */
        /* criar outro conjunto de situacoes para o domingo */    /* nao decrementa dia para pegar o dia seguinte a apuracao */
        // 20/12/00 - rigel/claudio - estava acessando horario corrente e trocamos para o do dia seguinte
        if ($idDiaCalendSeg == self::FERIADO) {
            // 30/11/01 - Claudio - Liberado situacao especial (que é a do he dia seg) tb. para domingo
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idPextraDia   = self::EX_DIA_FERIAD_1AS;
                $this->idPextraDia2  = self::EX_DIA_FERIAD_SEG;
                $this->idPextraNot   = self::EX_NOT_FERIAD_1AS;
                $this->idPextraNot2  = self::EX_NOT_FERIAD_SEG;
                $this->idPextraNComp = self::EX_NOT_FERIAD_CP;
            } else {
                $this->idPextraDia   = self::EX_DIA_FERIAD_NP_1AS;
                $this->idPextraDia2  = self::EX_DIA_FERIAD_NP_SEG;
                $this->idPextraNot   = self::EX_NOT_FERIAD_NP_1AS;
                $this->idPextraNot2  = self::EX_NOT_FERIAD_NP_SEG;
                $this->idPextraNComp = self::EX_NOT_FERIAD_NP_CP;
            }
            $this->idTipoPextra = 3;
            $this->idPjornComplementar = self::JORN_COMP_FER;
        } elseif ($tpHorPost == self::FOLGA) {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idPextraDia   = self::EX_DIA_FOLGA_1AS;
                $this->idPextraDia2  = self::EX_DIA_FOLGA_SEG;
                $this->idPextraNot   = self::EX_NOT_FOLGA_1AS;
                $this->idPextraNot2  = self::EX_NOT_FOLGA_SEG;
                $this->idPextraNComp = self::EX_NOT_FOLGA_CP;
            } else {
                $this->idPextraDia   = self::EX_DIA_FOLGA_NP_1AS;
                $this->idPextraDia2  = self::EX_DIA_FOLGA_NP_SEG;
                $this->idPextraNot   = self::EX_NOT_FOLGA_NP_1AS;
                $this->idPextraNot2  = self::EX_NOT_FOLGA_NP_SEG;
                $this->idPextraNComp = self::EX_NOT_FOLGA_NP_CP;
            }
            $this->idTipoPextra = 2;
            $this->idPjornComplementar = self::JORN_COMP_FOLG;
        } /* testa se hoje é sexta porque assim o dia seguinte será sabado */
        elseif ($isSexta) {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idPextraDia   = self::EX_DIA_SABADO_1AS;
                $this->idPextraDia2  = self::EX_DIA_SABADO_SEG;
                $this->idPextraNot   = self::EX_NOT_SABADO_1AS;
                $this->idPextraNot2  = self::EX_NOT_SABADO_SEG;
                $this->idPextraNComp = self::EX_NOT_SABADO_CP;
            } else {
                $this->idPextraDia   = self::EX_DIA_SABADO_NP_1AS;
                $this->idPextraDia2  = self::EX_DIA_SABADO_NP_SEG;
                $this->idPextraNot   = self::EX_NOT_SABADO_NP_1AS;
                $this->idPextraNot2  = self::EX_NOT_SABADO_NP_SEG;
                $this->idPextraNComp = self::EX_NOT_SABADO_NP_CP;
            }
            $this->idTipoPextra = 3;
            $this->idPjornComplementar = self::JORN_COMP_SAB;
        } else {
            if ($this->escalaHistorico->getIdexigeauthoraextra() == self::NAO) {
                $this->idPextraDia   = self::EX_DIA_NORMAL_1AS;
                $this->idPextraDia2  = self::EX_DIA_NORMAL_SEG;
                $this->idPextraNot   = self::EX_NOT_NORMAL_1AS;
                $this->idPextraNot2  = self::EX_NOT_NORMAL_SEG;
                $this->idPextraNComp = self::EX_NOT_NORMAL_CP;
            } else {
                $this->idPextraDia   = self::EX_DIA_NORMAL_NP_1AS;
                $this->idPextraDia2  = self::EX_DIA_NORMAL_NP_SEG;
                $this->idPextraNot   = self::EX_NOT_NORMAL_NP_1AS;
                $this->idPextraNot2  = self::EX_NOT_NORMAL_NP_SEG;
                $this->idPextraNComp = self::EX_NOT_NORMAL_NP_CP;
            }
            $this->idTipoPextra = 1;
            $this->idPjornComplementar = self::JORN_COMP_NORM;
        }

        /*=======hssr============================*/
        if ($this->idDiaCalend == self::FERIADO) {
            $this->idAdicHexDia   = self::AD_EX_DIA_FERIAD_1AS;
            $this->idAdicHexDia2  = self::AD_EX_DIA_FERIAD_SEG;
            $this->idAdicHexNot   = self::AD_EX_NOT_FERIAD_1AS;
            $this->idAdicHexNot2  = self::AD_EX_NOT_FERIAD_SEG;
            $this->idAdicHexNComp = self::AD_EX_NOT_FERIAD_CP;
        } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
            $this->idAdicHexDia   = self::AD_EX_DIA_FOLGA_1AS;
            $this->idAdicHexDia2  = self::AD_EX_DIA_FOLGA_SEG;
            $this->idAdicHexNot   = self::AD_EX_NOT_FOLGA_1AS;
            $this->idAdicHexNot2  = self::AD_EX_NOT_FOLGA_SEG;
            $this->idAdicHexNComp = self::AD_EX_NOT_FOLGA_CP;
        } elseif ($isSabado) {
            $this->idAdicHexDia   = self::AD_EX_DIA_SABADO_1AS;
            $this->idAdicHexDia2  = self::AD_EX_DIA_SABADO_SEG;
            $this->idAdicHexNot   = self::AD_EX_NOT_SABADO_1AS;
            $this->idAdicHexNot2  = self::AD_EX_NOT_SABADO_SEG;
            $this->idAdicHexNComp = self::AD_EX_NOT_SABADO_CP;
        } else {
            $this->idAdicHexDia   = self::AD_EX_DIA_NORMAL_1AS;
            $this->idAdicHexDia2  = self::AD_EX_DIA_NORMAL_SEG;
            $this->idAdicHexNot   = self::AD_EX_NOT_NORMAL_1AS;
            $this->idAdicHexNot2  = self::AD_EX_NOT_NORMAL_SEG;
            $this->idAdicHexNComp = self::AD_EX_NOT_NORMAL_CP;
        }

        $where = "NRVINCULOM = ?
              AND NRORG = ?
              AND DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                       FROM GPE_VINCULOH VIH
                                      WHERE VIH.NRVINCULOM  = ?
                                        AND VIH.NRORG = ?
                                        AND VIH.DTMESCOMPETENC <= TO_DATE(?,'DD/MM/YYYY'))";

        $params = array(
            $this->nrvinculom,
            $this->nrorg,
            $this->nrvinculom,
            $this->nrorg,
            FPA::getDtCompetencia()
        );

        /** @var GpeVinculoh $vinculo */
        $vinculo = GpeVinculoh::getObjectByWhere($where, $params);

        //Olhar com Rigel
        if (($vinculo->getIdremuneracao() == 'SAL2') || ($vinculo->getIdremuneracao() == 'SAL2_RSR')) {
            $this->idTrabDia   = 'TRAB_DIURNO_II';
            $this->idTrabNot   = 'TRAB_NOTURNO_II';
            $this->idTrabNComp = 'TRAB_NOT_II_H_COMP';
        } else {
            $this->idTrabDia   = 'TRAB_DIURNO_I';
            $this->idTrabNot   = 'TRAB_NOTURNO_I';
            $this->idTrabNComp = 'TRAB_NOT_I_H_COMP';
        }
    }

    private function transformaFaltas()
    {
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        /* caso o horario seja Opcional o sistema nao transforma */
        /* atrasos e saidas em faltas para que os mesmos entrem no */
        /* esquema normal de compensacao mensal */
        if ($calcSituFreq[$this->idTrabDia]['HORAS'] == 0 && $calcSituFreq[$this->idTrabNot]['HORAS'] == 0) {
            /* se nao achou horas trabalhadas - transforma os atrasos */
            /* e saidas em faltas e zera os mesmos */
            $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'] = $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'] +
                                                            $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'];

            $calcSituFreq[self::FALTAS_DIURNAS]['HORAS']  = $calcSituFreq[self::FALTAS_DIURNAS]['HORAS'] +
                                                            $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'];

            $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'] = $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'] +
                                                            $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'];

            $calcSituFreq[self::FALTAS_DIURNAS]['HORAS']  = $calcSituFreq[self::FALTAS_DIURNAS]['HORAS'] +
                                                            $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'];

            //Zera Atrasos e Saídas
            $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'] = 0;
            $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS']  = 0;
            $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS']  = 0;
            $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS']   = 0;

            $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
        }
    }

    /**
     * Retorna hora convertida do formato HHMI para HH:MI.
     *
     * @param $hora
     * @return string $hora
     */
    private function formataHora($hora)
    {
        $hora = DateUtil::getHoraFloatDeString($hora);
        $hora = DateUtil::getHoraStringDeFloat($hora, true);

        return $hora;
    }

    // Descrição: Função que separa os atrasos, saidas e horas extras entre os períodos
    private function separaAtrSaiHexPeriodos($intervaloAtual, $calcSituFreqTrat)
    {
        $horasApuradas      = $intervaloAtual->HORA;
        $dtHrAjustada       = $intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada();
        $intervalosHorarios = $this->horario->getIntervalosHorario();
        $countIntervalos    = count($intervalosHorarios);
        $ultPeriodo         = $countIntervalos / 2;
        $periodo            = 1;

        do {
            $dtHoraBaseFim = $intervalosHorarios[$periodo]['DTHORABASE'];
            $dtHoraBaseIni = $intervalosHorarios[$periodo - 1]['DTHORABASE'];

            if ($periodo == 1) {
                /* primeiro período */
                if (!(DateUtil::comparaDatas($dtHrAjustada, $dtHoraBaseFim, DateUtil::DEPOIS))) {
                    break;
                }
            } elseif ($periodo == $ultPeriodo) {
                /* último período */
                if (!(DateUtil::comparaDatas($dtHrAjustada, $dtHoraBaseIni, DateUtil::ANTES))) {
                    break;
                }
            } else {
                /* todos os outros períodos */
                if (!(DateUtil::comparaDatas($dtHrAjustada, $dtHoraBaseIni, DateUtil::ANTES)) &&
                    !(DateUtil::comparaDatas($dtHrAjustada, $dtHoraBaseFim, DateUtil::DEPOIS))
                ) {
                    break;
                }
            }
            $periodo++;
        } while ($periodo <= $ultPeriodo);

        // 06/06/06 - Nádia - testar li_ult_periodo zero
        // 12/05/06 - Nádia - Fiemg - evita erro de array boundary para horario com 10 marc
        if ($periodo > $ultPeriodo && $ultPeriodo > 0) {
            $periodo = $ultPeriodo;
        }

        switch ($calcSituFreqTrat) {
            case self::ATRASOS_DIURNOS:
            case self::ATRASOS_NOTURNOS:
                $this->periodosIntervalos[$periodo - 1]['ATRASOS'] = $this->periodosIntervalos[$periodo - 1]['ATRASOS'] + $horasApuradas;
                break;
            case self::SAIDAS_DIURNAS:
            case self::SAIDAS_NOTURNAS:
                $this->periodosIntervalos[$periodo - 1]['SAIDAS'] = $this->periodosIntervalos[$periodo - 1]['SAIDAS'] + $horasApuradas;
                break;
            case self::EX_DIA_NORMAL_1AS:
            case self::EX_NOT_NORMAL_1AS:
                $this->periodosIntervalos[$periodo - 1]['EXTRAS'] = $this->periodosIntervalos[$periodo - 1]['EXTRAS'] + $horasApuradas;
                break;
        }
    }

    public function extraTurnoFeriado($intervaloAtual)
    {
        // rigel 29/12/98
        // 22/09/99 - quebra do objeto uo_apuracao

        /* esta funcao testa e gera como hora extra os intervalos trabalhados */
        /* em feriados por funcionarios em horario de turno - algumas empresas */
        /* pagam como extra - outras dao folga em outro dia do mes */
        if (($this->horario->getHorarioHistorico()->getIdtipohorario() == self::TURNO) &&
            ($this->idDiaCalend == self::FERIADO) && ($this->escalaHistorico->getIdturnoextraferiado() == self::SIM)
        ) {
            // 05/05/06 - Nadia - novos args a partir de uo_marcacao
            if ($intervaloAtual->INICIONOT) {
                self::acumulaExtra($this->idExtraNot, $this->idExtraNot2, $intervaloAtual->HORANOT);
                self::acumulaExtra($this->idExtraDia, $this->idExtraDia2, $intervaloAtual->HORADIA);
            } else {
                self::acumulaExtra($this->idExtraDia, $this->idExtraDia2, $intervaloAtual->HORADIA);
                self::acumulaExtra($this->idExtraNot, $this->idExtraNot2, $intervaloAtual->HORANOT);
            }

            // 30/09/05 - Nádia - acumular horas; a hora compress será calculada no final
            $this->idHorasExtAdic = $this->idHorasExtAdic + $intervaloAtual->HORANOT;
        }
    }

    /*
     * Transforma horas trabalhadas no dia em horas extras quando, horario for turno, for feriado ou domingo e Idturnoextraferiado estiver marcado
     * LEONARDOCARVALHO - 21/01/2016
     * */
    public function extraTurnoFeriadoDomingo()
    {
        $alterou = false;
        
        if (($this->horario->getHorarioHistorico()->getIdtipohorario() == self::TURNO) &&
            (($this->idDiaCalend == self::FERIADO) || (DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 7)) &&
            ($this->escalaHistorico->getIdturnoextraferiado() == self::SIM)
        ) {

            $calculos = $this->calcSituFreq->getCalcSituacoesFreq();
            $horasTrabalhadas = ($calculos[$this->idTrabNot]['HORAS'] + $calculos[$this->idTrabDia]['HORAS']);

            $horasExtras  = ($calculos[$this->idExtraDia]['HORAS']);
            $horasExtras += ($calculos[$this->idExtraDia2]['HORAS']);
            $horasExtras += ($calculos[$this->idExtraNot]['HORAS']);
            $horasExtras += ($calculos[$this->idExtraNot2]['HORAS']);

            $calculos[self::EX_DIA_NORMAL_SEG]['HORAS'] = $horasTrabalhadas + $horasExtras;
            // LEONARDOCARVALHO - 29/04/2016 - Comentado linha abaixo pois estava duplicando as horas extras diurnas no dia
            //$calculos[self::EX_DIA_NORMAL_SEG]['HORAS'] += $horasTrabalhadas + $horasExtras;
            // LEONARDOCARVALHO - 25/01/2016 - Comentado linha abaixo, gera o dobro de hora extra no dia
            //$calculos[self::EX_DIA_NORMAL_SEG]['HORAS'] += $calculos[self::EX_NOT_NORMAL_SEG]['HORAS'];

            $this->calcSituFreq->setCalcSituacoesFreq($calculos);

            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                $calculos[self::EX_DIA_NORMAL_SEG]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if (!is_object($assocSituFreqPadrao)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                    $calculos[self::EX_DIA_NORMAL_SEG]['NRCALCULOSITUFREQ']);
            }
            if(is_object($assocSituFreqPadrao)){
                $alterou = false;
                /** @var PtoResumositufreq $currentResum */
                foreach ($this->resumosSituFreqs as &$currentResum) {
                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {                      
                        $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $calculos[self::EX_DIA_NORMAL_SEG]['HORAS'];
                        $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                        $alterou = true;
                        break;
                    }
                }
                if (!$alterou && $calculos[self::EX_DIA_NORMAL_SEG]['HORAS'] > 0) {
                    $this->resumosSituFreqs[] = self::criaResumoSituFreq(null,
                        null,
                        null,
                        $assocSituFreqPadrao->getNrsitufrequencia(),
                        $calculos[self::EX_DIA_NORMAL_SEG]['HORAS']);
                }
            }

            // remove resumo de situação de frequência de 'Trabalho Diurno e Noturno' pois foi transformado em horas extras
            $trabalhoDiurnoNoturno = array(self::TRAB_DIURNO_I,
                                           self::TRAB_NOTURNO_I);

            foreach ($trabalhoDiurnoNoturno as $trabalho) {
                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                    $calculos[$trabalho]['NRCALCULOSITUFREQ']);
                //Caso não haja associação específica para a organização de trabalho, busca a associação de
                //organização padrão
                if (!is_object($assocSituFreqPadrao)) {
                    $nrOrgPadrao = FPA::getNrorgPadrao();
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                        $calculos[$trabalho]['NRCALCULOSITUFREQ']);
                }
                if (is_object($assocSituFreqPadrao)) {
                    /** @var PtoResumositufreq $currentResum */
                    foreach ($this->resumosSituFreqs as &$currentResum) {
                        if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                            $currentResum->setQtrefapursitufreq(0);
                            break;
                        }
                    }
                }
            }
        }
    }

    public function verificaProgramacoesOcorrencia($horarioDiaSeguinte, $idDiaCalendSeg){
        foreach($this->programacoesOcorrencia as $programacaoOcor){
            /** @var PtoTipoprogocorrencia $tipoProgOcor */
            $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoOcor->getNrtipoprogocorrencia());
            switch($tipoProgOcor->getCdtipoprogocorrencia()){
                case self::ATRASO_AUTORIZADO:
                case self::FALTA_ABONADA:
                case self::SAIDA_ATRASO_AUT:
                case self::SAIDA_AUTORIZADA:
                    self::progOcorAusenciaAutorizada($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;

                //<editor-fold desc="Vitor Peixoto 12/06/2015 Cálculo que abona apenas as ausências que ocorrem dentro do período trabalhado">
                case self::ATRASO_INTRA_AUTORIZADO:
                case self::SAIDA_ATRASO_INTRA_AUT:
                case self::SAIDA_INTRA_AUTORIZADA:
                    self::progOcorAusenciaIntrajornadaAutorizada($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;
                //</editor-fold>

                //<editor-fold desc="Vitor Peixoto 19/06/2015 Cálculo que abona ausências justificadas que ocorrem fora da jornada, lançando o valor trabalhado definido">
                case self::AUSENCIA_EXTRAJORNADA:
                    self::progOcorAusenciaExtrajornadaAutorizada($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;
                //</editor-fold>

                case self::ATRASO_COMP_SE_CRED:
                case self::AUSENCIA_COMPENSAR:
                case self::AUSENC_COMP_SE_CRED:
                case self::SAIDA_COMP_SE_CRED:
                    self::progOcorAusencias($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;

                //<editor-fold desc="Vitor Peixoto 26/05/2015 Cálculo para complemento da jornada diária (Débito > Trabalho)">
                case self::COMPLEMENTA_TRABALHO:
                    self::progOcorComplementaTrabalho($programacaoOcor, $horarioDiaSeguinte, $idDiaCalendSeg);
                    break;
                //</editor-fold>

                case self::DSR_ABONADO:
                    break;

                case self::HORAS_FOLGAR:
                case self::HORAS_FOLGAR_ACRESC:
                    self::progOcorHorasFolgar($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;

                case self::HR_EXTRA_AUTORIZADA:
                    self::progOcorHorasExtraAutorizada($programacaoOcor, $horarioDiaSeguinte, $idDiaCalendSeg);
                    break;

                case self::QUEBRA_HRFOLGA_HRAUT:
                    break;

                case self::QUITA_CRED_ACUMULADO:
                case self::QUITA_DEBITO:
                case self::QUITA_SALDO_OU_DEB:
                    self::progOcorQuitaDebitoQuitaSaldoQuitaSaldoDebito($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia());
                    break;

                case self::SIMPLES_REGISTRO:
                    break;

                case self::SITUACAO_PROGRAMADA:
                    break;

                case self::SOBREPOE_CALENDARIO:
                    break;
                default:
                    break;
            }
        }
    }

    public function verificaProgramacoesOcorrenciaIntervalo($programacaoOcor, $intervaloAtual){
        /** @var PtoTipoprogocorrencia $tipoProgOcor */
        $tipoProgOcor = PtoTipoprogocorrencia::findOneByNrtipoprogocorrencia($programacaoOcor->getNrtipoprogocorrencia());
        switch($tipoProgOcor->getCdtipoprogocorrencia()){
            case self::ATRASO_AUTORIZADO:
            case self::FALTA_ABONADA:
            case self::SAIDA_ATRASO_AUT:
            case self::SAIDA_AUTORIZADA:
                self::progOcorAusenciaAutorizada($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia(), $intervaloAtual);
                $idIntervalo = ($intervaloAtual->MARCINI->getIdDentroHoraBase() == self::SIM ? self::TRABALHO : self::EXTRA);
                return ($intervaloAtual->IDINTERVALO == "" ? $idIntervalo : $intervaloAtual->IDINTERVALO);

            case self::SITUACAO_PROGRAMADA:
                break;

            case self::IDENTIFICA_INTERVALO_NP:
                self::progOcorIdentificaIntervaloNaoProgramado($programacaoOcor, $tipoProgOcor->getCdtipoprogocorrencia(), $intervaloAtual);
                return self::IGNORADO;

            default:
                break;
        }
    }

    private function retornaDadosProgramacao($programacao){
        //Pega os dados do objeto correto: PtoProgocorrencia ou PtoBancohorasprog
        $qtRefMin = -100000;
        $qtRefMax = 0;
        $qtRefMinGatilho = 0;
        $qtRefMaxGatilho = 0 ;
        $nrMotivoOcorFreq = '';
        $nrProgOcor = null;

        /* Vitor Peixoto 25/05/2015 Divisão por 60 para tratamento de minutos */
        if($programacao instanceof PtoBancohorasprog){
            if($programacao->getNrsitufreqgatilho()!= '' && !is_null($programacao->getNrsitufreqgatilho())){
                $qtRefMinGatilho = DateUtil::getHoraFloatDeString($programacao->getQtmingatilhoprogbhoras());
                $qtRefMaxGatilho = DateUtil::getHoraFloatDeString($programacao->getQtmaxgatilhoprogbhoras());
            }
            $nrMotivoOcorFreq = '';
            $qtRefMin         = ($programacao->getQtminimaprogbhoras() != null ? DateUtil::getHoraFloatDeString($programacao->getQtminimaprogbhoras()) : $qtRefMin);
            $qtRefMax         = ($programacao->getQtmaximaprogbhoras() != null ? DateUtil::getHoraFloatDeString($programacao->getQtmaximaprogbhoras()) : $qtRefMax);
            $nrProgOcor       = $programacao->getNrbancohorasprog();
        }
        else{
            if($programacao->getNrsitufreqgatilho()!= '' && !is_null($programacao->getNrsitufreqgatilho())){
                $qtRefMinGatilho = DateUtil::getHoraFloatDeString($programacao->getQtmingatilhoprogocor());
                $qtRefMaxGatilho = DateUtil::getHoraFloatDeString($programacao->getQtmaxgatilhoprogocor());
            }
            $nrMotivoOcorFreq = $programacao->getNrmotivoocorfreq();
            $qtRefMin         = ($programacao->getQtminimaprogocor() != null ? DateUtil::getHoraFloatDeString($programacao->getQtminimaprogocor()) : $qtRefMin);
            $qtRefMax         = ($programacao->getQtmaximaprogocor() != null ? DateUtil::getHoraFloatDeString($programacao->getQtmaximaprogocor()) : $qtRefMax);
            $nrProgOcor       = $programacao->getNrprogocorrencia();
        }
        /* END Vitor Peixoto */
        $dadosProgram = array(
            'NRPROGOCOR'       => $nrProgOcor,
            'NRMOTIVOOCORFREQ' => $nrMotivoOcorFreq,
            'QTREFMIN'         => $qtRefMin,
            'QTREFMAX'         => $qtRefMax,
            'QTREFMINGATILHO'  => $qtRefMinGatilho,
            'QTREFMAXGATILHO'  => $qtRefMaxGatilho
        );

        return $dadosProgram;
    }

    private function sitsPadraoProgHoraExtra($idDiaCalendSeg, $tpHorPost){

        $arraySitsPadrao = array();

        $isSabado = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6;
        $isSexta  = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 5;

        if ($this->idDiaCalend == self::FERIADO) {
            $arraySitsPadrao[] = self::EX_DIA_FERIAD_1AS;
            $arraySitsPadrao[] = self::EX_DIA_FERIAD_SEG;
            $arraySitsPadrao[] = self::EX_NOT_FERIAD_1AS;
            $arraySitsPadrao[] = self::EX_NOT_FERIAD_SEG;

        } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
            $arraySitsPadrao[] = self::EX_DIA_FOLGA_1AS;
            $arraySitsPadrao[] = self::EX_DIA_FOLGA_SEG;
            $arraySitsPadrao[] = self::EX_NOT_FOLGA_1AS;
            $arraySitsPadrao[] = self::EX_NOT_FOLGA_SEG;
        } elseif ($isSabado) {
            if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                $arraySitsPadrao[] = self::EX_DIA_SABADO_1AS;
                $arraySitsPadrao[] = self::EX_DIA_SABADO_SEG;
                $arraySitsPadrao[] = self::EX_NOT_SABADO_1AS;
                $arraySitsPadrao[] = self::EX_NOT_SABADO_SEG;

            } else {
                $arraySitsPadrao[] = self::EX_DIA_NORMAL_1AS;
                $arraySitsPadrao[] = self::EX_DIA_NORMAL_SEG;
                $arraySitsPadrao[] = self::EX_NOT_NORMAL_1AS;
                $arraySitsPadrao[] = self::EX_NOT_NORMAL_SEG;

            }
        } else {
            $arraySitsPadrao[] = self::EX_DIA_NORMAL_1AS;
            $arraySitsPadrao[] = self::EX_DIA_NORMAL_SEG;
            $arraySitsPadrao[] = self::EX_NOT_NORMAL_1AS;
            $arraySitsPadrao[] = self::EX_NOT_NORMAL_SEG;
        }

        /*if(is_null($idDiaCalendSeg) || is_null($tpHorPost)) return $arraySitsPadrao;*/

        if($this->idTipoExtra != $this->idTipoPextra){
            if ($idDiaCalendSeg == self::FERIADO) {
                $arraySitsPadrao[]   = self::EX_DIA_FERIAD_1AS;
                $arraySitsPadrao[]  = self::EX_DIA_FERIAD_SEG;
                $arraySitsPadrao[]   = self::EX_NOT_FERIAD_1AS;
                $arraySitsPadrao[]  = self::EX_NOT_FERIAD_SEG;

            } elseif ($tpHorPost == self::FOLGA) {
                $arraySitsPadrao[]   = self::EX_DIA_FOLGA_1AS;
                $arraySitsPadrao[]  = self::EX_DIA_FOLGA_SEG;
                $arraySitsPadrao[]   = self::EX_NOT_FOLGA_1AS;
                $arraySitsPadrao[]  = self::EX_NOT_FOLGA_SEG;
            } /* testa se hoje é sexta porque assim o dia seguinte será sabado */
            elseif ($isSexta) {
                $arraySitsPadrao[]   = self::EX_DIA_SABADO_1AS;
                $arraySitsPadrao[]  = self::EX_DIA_SABADO_SEG;
                $arraySitsPadrao[]   = self::EX_NOT_SABADO_1AS;
                $arraySitsPadrao[]  = self::EX_NOT_SABADO_SEG;
            } else {
                $arraySitsPadrao[]   = self::EX_DIA_NORMAL_1AS;
                $arraySitsPadrao[]  = self::EX_DIA_NORMAL_SEG;
                $arraySitsPadrao[]   = self::EX_NOT_NORMAL_1AS;
                $arraySitsPadrao[]  = self::EX_NOT_NORMAL_SEG;
            }
        }

        return $arraySitsPadrao;
    }

    private function progOcorHorasExtraAutorizada($programacao, $horarioDiaSeguinte, $idDiaCalendSeg){
        $alterou = false;
        $refAux = 0;
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

        $dadosProgram = self::retornaDadosProgramacao($programacao);

        $vetCalcSit [] = $calcSituFreq[$this->idExtraDia]['CDCALCULOSITUFREQ'];
        $vetCalcSit [] = $calcSituFreq[$this->idExtraDia2]['CDCALCULOSITUFREQ'];
        $vetCalcSit [] = $calcSituFreq[$this->idExtraNot]['CDCALCULOSITUFREQ'];
        $vetCalcSit [] = $calcSituFreq[$this->idExtraNot2]['CDCALCULOSITUFREQ'];

        if($this->idTipoExtra != $this->idTipoPextra){
            $vetCalcSit [] = $calcSituFreq[$this->idPextraDia]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idPextraDia2]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idPextraNot]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idPextraNot2]['CDCALCULOSITUFREQ'];
        }

        foreach ($vetCalcSit as $key => $sit) {
            $refAux += $calcSituFreq[$sit]['HORAS'];
        }

        if($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())){
            /** @var PtoResumositufreq $resumSituFreq */
            foreach($this->resumosSituFreqs as $resumSituFreq){
                if($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()){
                    if($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                        $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']){
                        if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                            $novaQtApurSituFreq = (($programacao->getVrcoeficienteacrescimo()/100)+1)*($resumSituFreq->getQtrefapursitufreq());
                        }
                        else{
                            $novaQtApurSituFreq = $resumSituFreq->getQtrefapursitufreq();
                        }
                        //Olhar se caso esteja fora realmente faz nada ou se joga pra cima ou pra baixo
                        //Olhar se cria um novo resumo com a situação freq ou só coloca a nova nesse msm resumo

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $novaQtApurSituFreq;
                                $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                 $programacao->getNrsitufrequencia(),
                                                                                 $novaQtApurSituFreq);
                        }

                        //Atualiza $calcSituFreq
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                            $programacao->getNrsitufrequencia());
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if(!is_object($assocSituFreqPadrao)){
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                $programacao->getNrsitufrequencia());
                        }

                        if(is_object($assocSituFreqPadrao)){
                            $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $novaQtApurSituFreq;
                        }
                    }
                    break;
                }
            }
        }
        else{
            if($refAux != 0.0){
                if ($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) {
                    $refAux = $dadosProgram['QTREFMAX'];
                }
                if ($refAux < $dadosProgram['QTREFMIN']) {
                    $refAux = $dadosProgram['QTREFMIN'];
                }
                $refAuxAtualizaDados = $refAux;
                if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                    /* soma a ref na sit_apur cadastrada */

                    $alterou = false;
                    /** @var PtoResumositufreq $currentResum */
                    foreach($this->resumosSituFreqs as &$currentResum){
                        if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                            $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAux;
                            $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                            $alterou = true;
                            break;
                        }
                    }
                    if(!$alterou){
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                             $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                             $programacao->getNrsitufrequencia(),
                                                                             $refAux);
                    }

                    //Atualiza $calcSituFreq
                    //Primeira busca para a organização trabalho
                    /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                        $programacao->getNrsitufrequencia());
                    //Caso não haja associação específica para a organização de trabalho, busca a associação de
                    //organização padrão
                    if(!is_object($assocSituFreqPadrao)){
                        $nrOrgPadrao = FPA::getNrorgPadrao();
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                            $programacao->getNrsitufrequencia());
                    }

                    if(is_object($assocSituFreqPadrao)){
                        $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                    }

                    $soma = false;
                }
                else{
                    $refAuxAtualizaDados = $refAux;
                    $arraySitsPadrao = self::sitsPadraoProgHoraExtra($horarioDiaSeguinte, $idDiaCalendSeg);

                    foreach ($vetCalcSit as $key => $calcSit) {
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
                        $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[$arraySitsPadrao[$key]]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if (!is_object($assocSituFreqCalcSit)) {
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[$arraySitsPadrao[$key]]['NRCALCULOSITUFREQ']);
                        }

                        if (is_object($assocSituFreqCalcSit)) {

                            if ($refAux > $calcSituFreq[$calcSit]['HORAS']) {
                                $saldoAGerar = $calcSituFreq[$calcSit]['HORAS'];
                                $sair = false;
                                $refAux = $refAux - $calcSituFreq[$calcSit]['HORAS'];
                            } elseif ($refAux < $calcSituFreq[$calcSit]['HORAS'] || $refAux == $calcSituFreq[$calcSit]['HORAS']) {
                                $saldoAGerar = $refAux;
                                $sair = true;
                                $refAux = 0;
                            }

                            /** @var PtoResumositufreq $resumoAtual */
                            foreach ($this->resumosSituFreqs as &$resumoAtual) {
                                if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                                    $saldoAGerar = $resumoAtual->getQtrefapursitufreq() + $saldoAGerar;
                                    $resumoAtual->setQtrefapursitufreq($saldoAGerar);
                                    $alterou = true;
                                    break;
                                }
                            }

                            if(!$alterou && $saldoAGerar != 0){
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                     $assocSituFreqCalcSit->getNrsitufrequencia(),
                                                                                     $saldoAGerar);
                                //passa - usa refAux
                            }

                            $calcSituFreq[$arraySitsPadrao[$key]]['HORAS'] += $saldoAGerar;
                            $soma = true;
                        }

                        if ($sair) {
                            break;
                        }
                    }
                }
            }
        }

        foreach ($vetCalcSit as $calcSit) {
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                          $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                          $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            }

            if (is_object($assocSituFreqCalcSit)) {
                /** @var PtoResumositufreq $resumoAtual */
                foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                    if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                        if ($refAuxAtualizaDados > $resumoAtual->getQtrefapursitufreq()) {
                            $refAuxAtualizaDados = $refAuxAtualizaDados - $resumoAtual->getQtrefapursitufreq();
                            $calcSituFreq[$calcSit]['HORAS'] = 0;
                            unset($this->resumosSituFreqs[$key]);
                        }
                        elseif((string)$refAuxAtualizaDados == (string)$resumoAtual->getQtrefapursitufreq()){
                            $refAuxAtualizaDados = 0;
                            $calcSituFreq[$calcSit]['HORAS'] = 0;
                            unset($this->resumosSituFreqs[$key]);
                        }
                        elseif ($refAuxAtualizaDados < $resumoAtual->getQtrefapursitufreq()) {
                            $resumoAtual->setQtrefapursitufreq(($resumoAtual->getQtrefapursitufreq() - $refAuxAtualizaDados));
                            $calcSituFreq[$calcSit]['HORAS'] = 0;
                            $refAuxAtualizaDados = 0;
                        }
                        break;
                    }
                }
            }

            $calcSituFreq[$calcSit]['HORAS'] = 0;

            if ($refAuxAtualizaDados == 0) {
                break;
            }
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    private function progOcorHorasFolgar($programacao, $cdTipoProgOcorrencia){
        $refAux = 0;
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

        $vetCalcSit = [];

        $dadosProgram = self::retornaDadosProgramacao($programacao);

        if($cdTipoProgOcorrencia == self::HORAS_FOLGAR) {
            $vetCalcSit [] = $calcSituFreq[$this->idExtraDia]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idExtraDia2]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idExtraNot]['CDCALCULOSITUFREQ'];
            $vetCalcSit [] = $calcSituFreq[$this->idExtraNot2]['CDCALCULOSITUFREQ'];

            if ($this->idTipoExtra != $this->idTipoPextra) {
                $vetCalcSit [] = $calcSituFreq[$this->idPextraDia]['CDCALCULOSITUFREQ'];
                $vetCalcSit [] = $calcSituFreq[$this->idPextraDia2]['CDCALCULOSITUFREQ'];
                $vetCalcSit [] = $calcSituFreq[$this->idPextraNot]['CDCALCULOSITUFREQ'];
                $vetCalcSit [] = $calcSituFreq[$this->idPextraNot2]['CDCALCULOSITUFREQ'];
            }

            foreach ($vetCalcSit as $key => $sit) {
                $refAux += $calcSituFreq[$sit]['HORAS'];
            }
        }

        //Acresce nas horas extras o valor definido (se houver)
        //Vitor Peixoto 08/06/2015
        if($cdTipoProgOcorrencia == self::HORAS_FOLGAR_ACRESC){
            $idTipoHorario = $this->horario->getHorarioHistorico()->getIdtipohorario();
            if($idTipoHorario == self::NORMAL) $refAux = $calcSituFreq[self::SALDO_A_FOLGAR_NORM]['HORAS'];
            elseif($idTipoHorario == self::FERIADO) $refAux = $calcSituFreq[self::SALDO_FOLGAR_FER]['HORAS'];
            elseif($idTipoHorario == self::COMPENSADO) $refAux = $calcSituFreq[self::SALDO_FOLGAR_SAB]['HORAS'];
            elseif($idTipoHorario == self::FOLGA) $refAux = $calcSituFreq[self::SALDO_FOLGAR_FOLG]['HORAS'];
            if($refAux >= 0) $refAux = $refAux * (($programacao->getVrcoeficienteacrescimo()/100)+1);
        }

        //Transforma todas as horas extras encontradas em Horas a Folgar (Default) ou na situação configurada
        else if($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())){
            /** @var PtoResumositufreq $resumSituFreq */
            foreach($this->resumosSituFreqs as $resumSituFreq){
                if($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()){
                    if(($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                        $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']) ||
                    ($dadosProgram['QTREFMAXGATILHO'] == 0 && $dadosProgram['QTREFMAXGATILHO'] == 0)
                    ){

                        if(is_null($programacao->getNrsitufrequencia())) {
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                                                        $calcSituFreq[self::HORAS_A_FOLGAR]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if(!is_object($assocSituFreqPadrao)){
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                                                            $calcSituFreq[self::HORAS_A_FOLGAR]['NRCALCULOSITUFREQ']);
                            }
                        }

                        if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                            $novaQtApurSituFreq = (($programacao->getVrcoeficienteacrescimo()/100)+1)*($resumSituFreq->getQtrefapursitufreq());
                        }
                        else{
                            $novaQtApurSituFreq = $resumSituFreq->getQtrefapursitufreq();
                        }
                        $refAux = $novaQtApurSituFreq;
                        //Olhar se caso esteja fora realmente faz nada ou se joga pra cima ou pra baixo
                        //Olhar se cria um novo resumo com a situação freq ou só coloca a nova nesse msm resumo

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == (is_null($programacao->getNrsitufrequencia()) ? $assocSituFreqPadrao->getNrsitufrequencia() : $programacao->getNrsitufrequencia())){
                                $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $novaQtApurSituFreq;
                                $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                    (is_null($programacao->getNrsitufrequencia()) ? $assocSituFreqPadrao->getNrsitufrequencia()
                                                                                                                                  : $programacao->getNrsitufrequencia()),
                                                                                 $novaQtApurSituFreq);
                        }

                        if(is_object($assocSituFreqPadrao)){
                            $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $novaQtApurSituFreq;
                        }
                        else {
                            //Atualiza $calcSituFreq
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                                $programacao->getNrsitufrequencia());
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                    $programacao->getNrsitufrequencia());
                            }
                            if(is_object($assocSituFreqPadrao)){
                                $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $novaQtApurSituFreq;
                            }
                        }
                    }
                    break;
                }
            }
        }
        else{
            if($refAux != 0.0){
                $qtLim = DateUtil::getHoraFloatDeString($this->qtLimiteSeparacaoHoraExtra/*$this->escalaHistorico->getQthrlimitesephextra()*/);
                if ($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) {
                    $refAux = $dadosProgram['QTREFMAX'];
                }
                if ($refAux < $dadosProgram['QTREFMIN']) {
                    $refAux = $dadosProgram['QTREFMIN'];
                }
                else if($refAux > $qtLim) $refAux = $qtLim;
                if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                    /* soma a ref na sit_apur cadastrada */

                    $alterou = false;
                    /** @var PtoResumositufreq $currentResum */
                    foreach($this->resumosSituFreqs as &$currentResum){
                        if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                            $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAux;
                            $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                            $alterou = true;
                            break;
                        }
                    }
                    if(!$alterou){
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                             $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                             $programacao->getNrsitufrequencia(),
                                                                             $refAux);
                    }

                    //Atualiza $calcSituFreq
                    //Primeira busca para a organização trabalho
                    /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                                                                                  $programacao->getNrsitufrequencia());
                    //Caso não haja associação específica para a organização de trabalho, busca a associação de
                    //organização padrão
                    if(!is_object($assocSituFreqPadrao)){
                        $nrOrgPadrao = FPA::getNrorgPadrao();
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                            $programacao->getNrsitufrequencia());
                    }

                    if(is_object($assocSituFreqPadrao)){
                        $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                    }

                    $soma = false;
                }
                else{
                    $calculoSituFreqPadrao = self::HORAS_A_FOLGAR;

                    //Primeira busca para a organização trabalho
                    /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                    $calcSituFreq[$calculoSituFreqPadrao]['NRCALCULOSITUFREQ']);
                    //Caso não haja associação específica para a organização de trabalho, busca a associação de
                    //organização padrão
                    if(!is_object($assocSituFreqPadrao)){
                        $nrOrgPadrao = FPA::getNrorgPadrao();
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                        $calcSituFreq[$calculoSituFreqPadrao]['NRCALCULOSITUFREQ']);
                    }

                    $alterou = false;
                    /** @var PtoResumositufreq $currentResum */
                    foreach($this->resumosSituFreqs as &$currentResum){
                        if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                            $refAux = $currentResum->getQtrefapursitufreq() + $refAux;
                            $currentResum->setQtrefapursitufreq($refAux);
                            $alterou = true;
                            break;
                        }
                    }
                    if(!$alterou){
                        // LEONARDOCARVALHO - 09/12/2015 - Não gera resumos de horas a folgar quando for feriado.
                        if ($this->idDiaCalend != self::FERIADO) {
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                            $dadosProgram['NRMOTIVOOCORFREQ'], null,
                            $assocSituFreqPadrao->getNrsitufrequencia(),
                            $refAux);
                            //passa
                        }
                    }

                    $calcSituFreq[$calculoSituFreqPadrao]['HORAS'] += $refAux;
                    $soma = true;
                }
            }
        }

        //Cálculo de Saldos
        $refAuxSaldos = &$this->refAuxSaldos;
        $refAuxSaldos[$cdTipoProgOcorrencia]['DIA'] = $refAux;

        $isSabado = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6;

        //<editor-fold desc="Vitor Peixoto 08/06/2015 Alteração para considerar situações de saldo com acrescimo">
        if($cdTipoProgOcorrencia == self::HORAS_FOLGAR_ACRESC){
            if ($this->idDiaCalend == self::FERIADO) {
                $calcSaldos['DIA'] = self::SDO_FOLG_ACR_FER;
                $calcSaldos['PER'] = self::SDO_FOLG_ACR_AP_FER;
                $calcSaldos['BDH'] = self::SDO_FOLG_ACR_BH_FER;
            } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
                $calcSaldos['DIA'] = self::SDO_FOLG_ACR_FOLG;
                $calcSaldos['PER'] = self::SDO_FOLG_ACR_AP_FOLG;
                $calcSaldos['BDH'] = self::SDO_FOLG_ACR_BH_FOLG;
            } elseif ($isSabado) {
                if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                    $calcSaldos['DIA'] = self::SDO_FOLG_ACR_SAB;
                    $calcSaldos['PER'] = self::SDO_FOLG_ACR_AP_SAB;
                    $calcSaldos['BDH'] = self::SDO_FOLG_ACR_BH_SAB;
                } else {
                    $calcSaldos['DIA'] = self::SDO_FOLG_ACR_NORM;
                    $calcSaldos['PER'] = self::SDO_FOLG_ACR_AP_NORM;
                    $calcSaldos['BDH'] = self::SDO_FOLG_ACR_BH_NORM;
                }
            } else {
                $calcSaldos['DIA'] = self::SDO_FOLG_ACR_NORM;
                $calcSaldos['PER'] = self::SDO_FOLG_ACR_AP_NORM;
                $calcSaldos['BDH'] = self::SDO_FOLG_ACR_BH_NORM;
            }
        }
        //</editor-fold>

        else if ($this->idDiaCalend == self::FERIADO) {
            $calcSaldos['DIA'] = self::SALDO_FOLGAR_FER;
            $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_FER;
            $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_FER;
        } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
            $calcSaldos['DIA'] = self::SALDO_FOLGAR_FOLG;
            $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_FOLG;
            $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_FOLG;
        } elseif ($isSabado) {
            if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                $calcSaldos['DIA'] = self::SALDO_FOLGAR_SAB;
                $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_SAB;
                $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_SAB;
            } else {
                $calcSaldos['DIA'] = self::SALDO_A_FOLGAR_NORM;
                $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_NORM;
                $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_NORM;
            }
        } else {
            $calcSaldos['DIA'] = self::SALDO_A_FOLGAR_NORM;
            $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_NORM;
            $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_NORM;
        }
        //Saldo Dia
        $refAuxSaldos[$cdTipoProgOcorrencia]['DIA'] = $refAux;

        //Saldo Periodo
        if(DateUtil::comparaDatas($this->data, $this->iniPerApur, DateUtil::IGUAL)){
            $refAuxSaldos[$cdTipoProgOcorrencia]['PER'] = $refAux;
        }
        else{
            $dataPerApur = DateUtil::subtraiIntervalo($this->data, 1, DateUtil::DIA);

            $assocSituFreq = PtoAssocsitufreq::getObjectByWhere("NRCALCULOSITUFREQ in (?)", array($calcSituFreq[$calcSaldos['PER']]['NRCALCULOSITUFREQ']));

            if($assocSituFreq){
                /** @var PtoResumositufreq $resumSituFreq */
                $resumSituFreq = PtoResumositufreq::getObjectByWhere("DTAPURACAOSITUFREQ = ?
                                                                  AND NRSITUFREQUENCIA = ?
                                                                  AND NRORG = ?
                                                                  AND NRVINCULOM = ?",
                    array($dataPerApur,
                        $assocSituFreq->getNrsitufrequencia(),
                        $this->nrorg,
                        $this->nrvinculom));
                if(is_object($resumSituFreq)){
                    $refAuxSaldos[$cdTipoProgOcorrencia]['PER'] += $resumSituFreq->getQtrefapursitufreq() + $refAux;

                }else{
                    $refAuxSaldos[$cdTipoProgOcorrencia]['PER'] += $refAux;
                }
            }
        }

        //Saldo Banco de Horas
        $whereAlteBancoHoras = "NRVINCULOM = ?
                                AND NRORG = ?
                                AND DTINICIOALTEBHORAS IN (SELECT MAX(DTINICIOALTEBHORAS)
                                                             FROM PTO_ALTEBANCOHORAS
                                                             WHERE TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOALTEBHORAS AND NVL(DTFIMALTEBHORAS, TO_DATE(?, 'DD/MM/YYYY'))
                                                               AND NRVINCULOM = ?
                                                               AND NRORG = ?)";

        $paramsAlteBancoHoras = array(
            $this->nrvinculom,
            $this->nrorg,
            FPA::getDtCompetencia(),
            FPA::getDtCompetencia(),
            $this->nrvinculom,
            $this->nrorg
        );

        /** @var PtoAltebancohoras $bancoHorasDia */
        $bancoHorasDia = PtoAltebancohoras::getObjectByWhere($whereAlteBancoHoras, $paramsAlteBancoHoras);

        if(is_object($bancoHorasDia)) {
            $wherePeriodoBH = "NRBANCOHORAS = ?
                           AND NRORG = ?
                           AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPERIODOBHORAS AND NVL(DTFIMPERIODOBHORAS, TO_DATE(?, 'DD/MM/YYYY'))";
            $paramsPeriodoBH = array(
                $bancoHorasDia->getNrbancohoras(),
                $this->nrorg,
                $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                $this->data->format(DateUtil::FORMATO_BRASILEIRO)
            );

            /** @var PtoBancohorasperiodo $periodoBancoHoras */
            $periodoBancoHoras = PtoBancohorasperiodo::getObjectByWhere($wherePeriodoBH, $paramsPeriodoBH);

            if (is_object($periodoBancoHoras)) {
                if (DateUtil::comparaDatas($this->data, $periodoBancoHoras->getDtinicioperiodobhoras(), DateUtil::IGUAL)) {
                    $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = $refAux;
                } else {
                    $assocSituFreq = PtoAssocsitufreq::getObjectByWhere("NRCALCULOSITUFREQ in (?)", array($calcSituFreq[$calcSaldos['BDH']]['NRCALCULOSITUFREQ']));

                    if($assocSituFreq){
                        $whereClause = "   NRSITUFREQUENCIA = ?
                                       AND NRORG = ?
                                       AND NRVINCULOM = ?
                                       AND DTAPURACAOSITUFREQ =
                                          (SELECT MAX(RESUMO.DTAPURACAOSITUFREQ)
                                             FROM PTO_RESUMOSITUFREQ RESUMO
                                            WHERE e.NRSITUFREQUENCIA = RESUMO.NRSITUFREQUENCIA
                                              AND e.NRORG            = RESUMO.NRORG
                                              AND e.NRVINCULOM       = RESUMO.NRVINCULOM
                                              AND RESUMO.DTAPURACAOSITUFREQ BETWEEN ? AND ?
                                              AND RESUMO.DTAPURACAOSITUFREQ < ?)";

                        /** @var PtoResumositufreq $resumSituFreq */
                        $params = array($assocSituFreq->getNrsitufrequencia(),
                                        $this->nrorg,
                                        $this->nrvinculom,
                                        $periodoBancoHoras->getDtinicioperiodobhoras(),
                                        $periodoBancoHoras->getDtfimperiodobhoras(),
                                        //$this->iniPerApur);
                                        $this->data);

                        $resumSituFreq = PtoResumositufreq::getObjectByWhere($whereClause,
                                                                             $params);

                        if(is_object($resumSituFreq) && (!$refAuxSaldos[$cdTipoProgOcorrencia]['SOMOU_SALDO_BDH_ANTIGO'] || $this->fromAplicativo)){
                            //Em caso de números muito pequenos arredonda antes para evitar erros com ponto flutuante
                            if(($refAux * 60) < 0.5 && ($refAux * 60) > -0.5) $refAux = 0;

                            $refAux = self::arredondaDecimal($refAux);
                            if($this->fromAplicativo){
                                $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = $resumSituFreq->getQtrefapursitufreq() + $refAux;
                            }
                            else {
                                $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] += $resumSituFreq->getQtrefapursitufreq() + $refAux;
                                $refAuxSaldos[$cdTipoProgOcorrencia]['SOMOU_SALDO_BDH_ANTIGO'] = true;
                            }
                            //Em caso de números muito pequenos arredonda antes para evitar erros com ponto flutuante
                            if(($refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] * 60) < 0.5 &&
                                ($refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] * 60) > -0.5)
                                $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = 0;

                            $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = self::arredondaDecimal($refAuxSaldos[$cdTipoProgOcorrencia]['BDH']);
                        } else{
                            //Em caso de números muito pequenos arredonda antes para evitar erros com ponto flutuante
                            if(($refAux * 60) < 0.5 && ($refAux * 60) > -0.5) $refAux = 0;

                            $refAux = self::arredondaDecimal($refAux);
                            $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] += $refAux;
                            
                            //Em caso de números muito pequenos arredonda antes para evitar erros com ponto flutuante
                            if(($refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] * 60) < 0.5 && 
                               ($refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] * 60) > -0.5) 
                                    $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = 0;
                            
                            $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'] = self::arredondaDecimal($refAuxSaldos[$cdTipoProgOcorrencia]['BDH']);
                        }
                    }
                }
            }

            //<editor-fold desc="Vítor Peixoto 29/05 alteração query">
            /*if (is_object($periodoBancoHoras)) {
                if (DateUtil::comparaDatas($this->data, $periodoBancoHoras->getDtinicioperiodobhoras(), DateUtil::IGUAL)) {
                    $dataBH = $this->data;
                    $refAuxSaldos['BDH'] = $refAux;
                } else {
                    $dataBH = DateUtil::subtraiIntervalo($this->data, 1, DateUtil::DIA);
                    $assocSituFreq = PtoAssocsitufreq::getObjectByWhere("NRCALCULOSITUFREQ in (?)", array($calcSituFreq[$calcSaldos['BDH']]['NRCALCULOSITUFREQ']));

                    if($assocSituFreq){
                        /** @var PtoResumositufreq $resumSituFreq * /
                        $resumSituFreq = PtoResumositufreq::getObjectByWhere("TRUNC(DTAPURACAOSITUFREQ) = ?
                                                                  AND NRSITUFREQUENCIA = ?
                                                                  AND NRORG = ?
                                                                  AND NRVINCULOM = ?",
                            array($dataBH,
                                $assocSituFreq->getNrsitufrequencia(),
                                $this->nrorg,
                                $this->nrvinculom));
                        if(is_object($resumSituFreq)){
                            $refAuxSaldos['BDH'] += DateUtil::getHoraFloatDeString($resumSituFreq->getQtrefapursitufreq()) + $refAux;
                        }else{
                            $refAuxSaldos['BDH'] += $refAux;
                        }
                    }
                }
            }*/
            //</editor-fold>

            //Vitor Peixoto 13/08/2015 Updata calculos para uso em outras programacoes, como a progOcorQuitaDebitoQuitaSaldoQuitaSaldoDebito
            $calcSituFreq[$calcSaldos['BDH']]['HORAS'] = $refAuxSaldos[$cdTipoProgOcorrencia]['BDH'];
        }

        /**
         * Percorre o array $calcSaldos que contem as chaves correspondentes
         * aos saldos e cria/altera os resumos para cada um deles.
         */
        foreach($calcSaldos as $keySaldo => $calcSaldo){
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                    $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
            }

            if (is_object($assocSituFreqCalcSit)) {
                $alterou = false;
                /** @var PtoResumositufreq $currentResum */
                foreach ($this->resumosSituFreqs as &$currentResum) {
                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                        if(!in_array($currentResum->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) unset($this->resumosSituFreqs[$key]);
                        else if($this->idDiaCalend != self::FERIADO) {
                            $refAuxSaldos[$cdTipoProgOcorrencia][$keySaldo] += $currentResum->getQtrefapursitufreq();
                            $currentResum->setQtrefapursitufreq($refAuxSaldos[$cdTipoProgOcorrencia][$keySaldo]);
                        } else {
                            $refAux += $currentResum->getQtrefapursitufreq();
                            $currentResum->setQtrefapursitufreq($refAux);
                        }
                        $alterou = true;
                        break;
                    }
                }
                if (!$alterou && in_array($assocSituFreqCalcSit->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) {
                    if($this->idDiaCalend != self::FERIADO) {
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                            $assocSituFreqCalcSit->getNrsitufrequencia(),
                            $refAuxSaldos[$cdTipoProgOcorrencia][$keySaldo]);
                        //passa
                    }
                    else {
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                            $assocSituFreqCalcSit->getNrsitufrequencia(),
                            $refAux);
                    }
                }
            }

            $idTipoHorario = $this->horario->getHorarioHistorico()->getIdtipohorario();
            if($keySaldo == 'DIA') {
                if($idTipoHorario == self::NORMAL) $calcSituFreq[self::SALDO_A_FOLGAR_NORM]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FERIADO) $calcSituFreq[self::SALDO_FOLGAR_FER]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::COMPENSADO) $calcSituFreq[self::SALDO_FOLGAR_SAB]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FOLGA) $calcSituFreq[self::SALDO_FOLGAR_FOLG]['HORAS'] = $refAux;
            }
            elseif($keySaldo == 'PER') {
                if($idTipoHorario == self::NORMAL) $calcSituFreq[self::SALDO_FOLGAR_AP_NORM]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FERIADO) $calcSituFreq[self::SALDO_FOLGAR_AP_FER]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::COMPENSADO) $calcSituFreq[self::SALDO_FOLGAR_AP_SAB]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FOLGA) $calcSituFreq[self::SALDO_FOLGAR_AP_FOLG]['HORAS'] = $refAux;
            }
            else {
                if($idTipoHorario == self::NORMAL) $calcSituFreq[self::SALDO_FOLGAR_BH_NORM]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FERIADO) $calcSituFreq[self::SALDO_FOLGAR_BH_FER]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::COMPENSADO) $calcSituFreq[self::SALDO_FOLGAR_BH_SAB]['HORAS'] = $refAux;
                elseif($idTipoHorario == self::FOLGA) $calcSituFreq[self::SALDO_FOLGAR_BH_FOLG]['HORAS'] = $refAux;
            }

        }

        foreach ($vetCalcSit as $calcSit) {
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                        $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                        $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            }

            if (is_object($assocSituFreqCalcSit)) {
                /** @var PtoResumositufreq $resumoAtual */
                foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                    if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                        if(!in_array($currentResum->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) {
                            unset($this->resumosSituFreqs[$key]);
                        }
                        else if ($refAux > $resumoAtual->getQtrefapursitufreq()) {
                            $refAux = $refAux - $resumoAtual->getQtrefapursitufreq();
                            $calcSituFreq[$calcSit]['HORAS'] = 0;
                            unset($this->resumosSituFreqs[$key]);
                        }
                        elseif((string)$refAux == (string)$resumoAtual->getQtrefapursitufreq()){
                            $refAux = 0;
                            $calcSituFreq[$calcSit]['HORAS'] = 0;
                            unset($this->resumosSituFreqs[$key]);
                        }
                        elseif ($refAux < $resumoAtual->getQtrefapursitufreq()) {
                            //$resumoAtual->setQtrefapursitufreq(($resumoAtual->getQtrefapursitufreq() - $refAux));
                            //$calcSituFreq[$calcSit]['HORAS'] = 0;
                            // LEONARDOCARVALHO - 16/11/2015 - Correção para autorizar hora extra noturna, não deve zerar o cálculo nesse ponto
                            $calcSituFreq[$calcSit]['HORAS'] = $resumoAtual->getQtrefapursitufreq() - $refAux;
                            unset($this->resumosSituFreqs[$key]);
                            $refAux = 0;
                        }
                        break;
                    }
                }
            }
            //$calcSituFreq[$calcSit]['HORAS'] = 0;

            if ($refAux == 0) {
                break;
            }
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    private function progOcorAusencias($programacao, $cdTipoProgOcorrencia){
        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $refAux = 0;

        $dadosProgram = self::retornaDadosProgramacao($programacao);
        $refAuxSaldos = &$this->refAuxSaldos;

        if($cdTipoProgOcorrencia == self::AUSENC_COMP_SE_CRED || $cdTipoProgOcorrencia == self::AUSENCIA_COMPENSAR){
            /*$refAux = $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] + $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::FALTAS_DIURNAS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'];

            $vetCalcSit[] = self::ATRASOS_DIURNOS;
            $vetCalcSit[] = self::ATRASOS_NOTURNOS;
            $vetCalcSit[] = self::SAIDAS_DIURNAS;
            $vetCalcSit[] = self::SAIDAS_NOTURNAS;
            $vetCalcSit[] = self::FALTAS_DIURNAS;
            $vetCalcSit[] = self::FALTAS_NOTURNAS;*/
            
            // LEONARDOCARVALHO - 13112015 - NAO COMPENSAÇÃO DE FALTA PARA ESTAGIÁRIO
            /** @var \Folha\Entities\GpeVinculom $vinculom */
            $vinculom = \Folha\Entities\GpeVinculom::findOneByNrorgAndNrvinculom($this->nrorg, $this->nrvinculom);
        
            $refAux = $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] + $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'];
            $refAux = $refAux + $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'];
            if ($vinculom->getNrtipovinculom() != '2') {
                $refAux = $refAux + $calcSituFreq[self::FALTAS_DIURNAS]['HORAS'];
                $refAux = $refAux + $calcSituFreq[self::FALTAS_NOTURNAS]['HORAS'];
            }

            $vetCalcSit[] = self::ATRASOS_DIURNOS;
            $vetCalcSit[] = self::ATRASOS_NOTURNOS;
            $vetCalcSit[] = self::SAIDAS_DIURNAS;
            $vetCalcSit[] = self::SAIDAS_NOTURNAS;
            if ($vinculom->getNrtipovinculom() != '2') {
                $vetCalcSit[] = self::FALTAS_DIURNAS;
                $vetCalcSit[] = self::FALTAS_NOTURNAS;
            }
        }elseif(self::SAIDA_COMP_SE_CRED){
            $refAux = $calcSituFreq[self::SAIDAS_DIURNAS]['HORAS'] + $calcSituFreq[self::SAIDAS_NOTURNAS]['HORAS'];

            $vetCalcSit[] = self::SAIDAS_DIURNAS;
            $vetCalcSit[] = self::SAIDAS_NOTURNAS;
        }
        else{
            $refAux = $calcSituFreq[self::ATRASOS_DIURNOS]['HORAS'] + $calcSituFreq[self::ATRASOS_NOTURNOS]['HORAS'];

            $vetCalcSit[] = self::ATRASOS_DIURNOS;
            $vetCalcSit[] = self::ATRASOS_NOTURNOS;
        }

        if ($cdTipoProgOcorrencia == self::AUSENC_COMP_SE_CRED || $cdTipoProgOcorrencia == self::SAIDA_COMP_SE_CRED || $cdTipoProgOcorrencia == self::ATRASO_COMP_SE_CRED){
            $saldoAux = 0;

            $whereAlteBancoHoras = "NRVINCULOM = ?
                                AND NRORG = ?
                                AND DTINICIOALTEBHORAS IN (SELECT MAX(DTINICIOALTEBHORAS)
                                                             FROM PTO_ALTEBANCOHORAS
                                                             WHERE TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOALTEBHORAS AND
                                                                                                    NVL(DTFIMALTEBHORAS, TO_DATE(?, 'DD/MM/YYYY'))
                                                               AND NRVINCULOM = ?
                                                               AND NRORG = ?)";

            $paramsAlteBancoHoras = array(
                $this->nrvinculom,
                $this->nrorg,
                FPA::getDtCompetencia(),
                FPA::getDtCompetencia(),
                $this->nrvinculom,
                $this->nrorg
            );

            /** @var PtoAltebancohoras $bancoHorasDia */
            $bancoHorasDia = PtoAltebancohoras::getObjectByWhere($whereAlteBancoHoras, $paramsAlteBancoHoras);

            if(is_object($bancoHorasDia)){
                $wherePeriodoBH = "NRBANCOHORAS = ?
                               AND NRORG = ?
                               AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN DTINICIOPERIODOBHORAS AND NVL(DTFIMPERIODOBHORAS, TO_DATE(?, 'DD/MM/YYYY'))";
                $paramsPeriodoBH = array(
                    $bancoHorasDia->getNrbancohoras(),
                    $this->nrorg,
                    $this->data->format(DateUtil::FORMATO_BRASILEIRO),
                    $this->data->format(DateUtil::FORMATO_BRASILEIRO)
                );

                /** @var PtoBancohorasperiodo $periodoBancoHoras */
                $periodoBancoHoras = PtoBancohorasperiodo::getObjectByWhere($wherePeriodoBH, $paramsPeriodoBH);

                if(is_object($periodoBancoHoras)){
                    //Vitor Peixoto 08/06/2015 Conferencia de saldos antiga, sendo feita agora na progOcorHorasFolgar
                    /* if(DateUtil::comparaDatas($this->data, $periodoBancoHoras->getDtinicioperiodobhoras())){
                                            $saldoAux = 0;
                                        }
                                        else{
                                            $paramsCalculos = array(
                                                $calcSituFreq[self::SDO_FOLG_ACR_BH_NORM]['NRCALCULOSITUFREQ'],
                                                $calcSituFreq[self::SDO_FOLG_ACR_BH_FER]['NRCALCULOSITUFREQ'],
                                                $calcSituFreq[self::SDO_FOLG_ACR_BH_FOLG]['NRCALCULOSITUFREQ'],
                                                $calcSituFreq[self::SDO_FOLG_ACR_BH_SAB]['NRCALCULOSITUFREQ']
                                            );

                                            $associacoesSituFreq = PtoAssocsitufreq::getObjectsByWhere("NRCALCULOSITUFREQ in (?, ?, ?, ?)", $paramsCalculos);

                                            /** @var PtoAssocsitufreq $assocSituFreq * /
                                            foreach($associacoesSituFreq as $assocSituFreq) {
                                                /** @var PtoResumositufreq $resumSituFreq * /
                                                $resumSituFreq = PtoResumositufreq::getObjectByWhere("DTAPURACAOSITUFREQ = TO_DATE(?, 'DD/MM/YYYY HH24:MM:SS')
                                                                                      AND NRSITUFREQUENCIA = ?
                                                                                      AND NRORG = ?
                                                                                      AND NRVINCULOM = ?",
                                                    array(DateUtil::subtraiIntervalo($this->data,1,DateUtil::DIA),
                                                        $assocSituFreq->getNrsitufrequencia(),
                                                        $this->nrorg,
                                                        $this->nrvinculom));
                                                if(is_object($resumSituFreq)){
                                                    $saldoAux += $resumSituFreq->getQtrefapursitufreq();
                                                }
                                                else {
                                                    $saldoAux = $refAuxSaldos[self::HORAS_FOLGAR]['BDH'];
                                                }
                                            }
                                        }*/
                    $saldoAux = $refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['BDH'];
                }
                else {
                    throw new \Exception('Período não encontrado para o banco de horas '.$bancoHorasDia->getNrbancohoras().'.');//
                    //tk_abort('Período não encontrado para o banco de horas '.$bancoHorasDia->getNrbancohoras().'.');
                }
            }
            else {
                throw new \Exception('Banco de Horas não encontrado.');//
                //tk_abort('Banco de Horas não encontrado.');
            }
            if ((int)($saldoAux*60) < (int)($refAux*60)) {
                // LEONARDOCARVALHO - 18/12/2015 - Apaga a programação de ocorrência de compensação, caso o mesmo não tenha saldo suficiente.
                $programacao->delete();
                //O saldo nao é suficiente
                return;
            }

            /*---Este código seria para tratar ausências compensar se crédito nos casos em que há crédito, porém não o
             * suficiente para compesar toda a ausência. Desta forma, o valor a ser compensado que seria gerado seria
             * somente o que o crédito permite. Até o momento, o tratamento está similar ao da Teknisa no qual quando
             * não há crédito suficiente para toda a ausência nada é feito.
             */
//            if ($saldoAux <= 0) {
//                //O saldo nao é suficiente, lê proxima prog
//                return;
//            }
//            if ($refAux > $saldoAux){
//                O saldo dá para compensar parte das horas
//                $refAux = $saldoAux;
//            }
        }

        if($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())){
            /** @var PtoResumositufreq $resumSituFreq */
            foreach($this->resumosSituFreqs as $resumSituFreq){
                if($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()){
                    if($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                        $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']){
                        if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                            $novaQtApurSituFreq = (($programacao->getVrcoeficienteacrescimo()/100)+1)*($resumSituFreq->getQtrefapursitufreq());
                        }
                        else{
                            $novaQtApurSituFreq = $resumSituFreq->getQtrefapursitufreq();
                        }
                        //Olhar se caso esteja fora realmente faz nada ou se joga pra cima ou pra baixo
                        //Olhar se cria um novo resumo com a situação freq ou só coloca a nova nesse msm resumo

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                if($dadosProgram['QTREFMAX'] != 0) $novaQtApurSituFreq = $dadosProgram['QTREFMAX'];
                                $novaQtApurSituFreq = $currentResum->getQtrefapursitufreq() + $novaQtApurSituFreq;
                                $currentResum->setQtrefapursitufreq($novaQtApurSituFreq);
                                /* Vitor Peixoto 25/05/2015 */
                                $refAuxSaldos[self::HORAS_FOLGAR]['PER'] += $novaQtApurSituFreq;
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            if($dadosProgram['QTREFMAX'] != 0) $novaQtApurSituFreq = $dadosProgram['QTREFMAX'];
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                 $programacao->getNrsitufrequencia(),
                                                                                 $novaQtApurSituFreq);
                            /* Vitor Peixoto 25/05/2015 */
                            $refAuxSaldos[self::HORAS_FOLGAR]['PER'] += $novaQtApurSituFreq;
                        }

                        //Atualiza $calcSituFreq
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                            $programacao->getNrsitufrequencia());
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if(!is_object($assocSituFreqPadrao)){
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                $programacao->getNrsitufrequencia());
                        }

                        if(is_object($assocSituFreqPadrao)){
                            $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $novaQtApurSituFreq;
                        }
                    }
                    break;
                }
            }
        }
        else{
            if($refAux != 0.0){
                if ($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) {
                    $refAux = $dadosProgram['QTREFMAX'];
                }
                if ($refAux < $dadosProgram['QTREFMIN']) {
                    $refAux = $dadosProgram['QTREFMIN'];
                }
                if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                    /* soma a ref na sit_apur cadastrada */

                    $alterou = false;
                    /** @var PtoResumositufreq $currentResum */
                    foreach($this->resumosSituFreqs as &$currentResum){
                        if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                            if($dadosProgram['QTREFMAX'] != 0) $refAux = $dadosProgram['QTREFMAX'];
                            $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAux;
                            $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                            /* Vitor Peixoto 25/05/2015 */
                            $refAuxSaldos[self::HORAS_A_FOLGAR]['PER'] += $novoQtRefApurSituFreq;
                            $alterou = true;
                            break;
                        }
                    }
                    if(!$alterou){
                        if($dadosProgram['QTREFMAX'] != 0) $refAux = $dadosProgram['QTREFMAX'];
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                             $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                             $programacao->getNrsitufrequencia(),
                                                                             $refAux);
                        /* Vitor Peixoto 25/05/2015 */
                        $refAuxSaldos[self::HORAS_FOLGAR]['PER'] += $refAux;
                    }

                    //Atualiza $calcSituFreq
                    //Primeira busca para a organização trabalho
                    /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                        $programacao->getNrsitufrequencia());
                    //Caso não haja associação específica para a organização de trabalho, busca a associação de
                    //organização padrão
                    if(!is_object($assocSituFreqPadrao)){
                        $nrOrgPadrao = FPA::getNrorgPadrao();
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                            $programacao->getNrsitufrequencia());
                    }

                    if(is_object($assocSituFreqPadrao)){
                        $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                    }

                    $soma = false;
                }
                else{

                    $calculoSituFreqPadrao = self::DEBITO_A_COMPENSAR;

                    //Primeira busca para a organização trabalho
                    /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                    $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                        $calcSituFreq[$calculoSituFreqPadrao]['NRCALCULOSITUFREQ']);
                    //Caso não haja associação específica para a organização de trabalho, busca a associação de
                    //organização padrão
                    if(!is_object($assocSituFreqPadrao)){
                        $nrOrgPadrao = FPA::getNrorgPadrao();
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                            $calcSituFreq[$calculoSituFreqPadrao]['NRCALCULOSITUFREQ']);
                    }

                    /* Vitor Peixoto 26/05/2015 */
                    $refAuxSaldos[self::HORAS_FOLGAR]['DIA'] -= $refAux;
                    $refAuxSaldos[self::HORAS_FOLGAR]['PER'] -= $refAux;
                    $refAuxSaldos[self::HORAS_FOLGAR]['BDH'] -= $refAux;

                    $refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['DIA'] -= $refAux;
                    $refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['PER'] -= $refAux;
                    $refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['BDH'] -= $refAux;

                    //Se compensar, não desconta o DSR
                    if($refAuxSaldos['DSR_DESCONTADO'] > 0) {
                        $refAuxSaldos['DSR_DESCONTADO'] -= $refAux;
                    }

                    if(($refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['BDH']*60) > -0.5 &&
                        ($refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['BDH']*60) < 0.5) $refAuxSaldos[self::HORAS_FOLGAR_ACRESC]['BDH'] = 0;

                    if(($refAuxSaldos[self::HORAS_FOLGAR]['BDH']*60) > -0.5 &&
                        ($refAuxSaldos[self::HORAS_FOLGAR]['BDH']*60) < 0.5) $refAuxSaldos[self::HORAS_FOLGAR]['BDH'] = 0;

                    /*if($refAuxSaldos['DIA'] <= 0){
                        //Remove o resumo de Débito
                    }*/

                    /* Altera os resumos de Saldo */

                    $isSabado = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6;

                    if ($this->idDiaCalend == self::FERIADO) {
                        $calcSaldos['DIA'] = self::SALDO_FOLGAR_FER;
                        $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_FER;
                        $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_FER;

                        $calcSaldosAcr['DIA'] = self::SDO_FOLG_ACR_FER;
                        $calcSaldosAcr['PER'] = self::SDO_FOLG_ACR_AP_FER;
                        $calcSaldosAcr['BDH'] = self::SDO_FOLG_ACR_BH_FER;
                    } elseif ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA) {
                        $calcSaldos['DIA'] = self::SALDO_FOLGAR_FOLG;
                        $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_FOLG;
                        $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_FOLG;

                        $calcSaldosAcr['DIA'] = self::SDO_FOLG_ACR_FOLG;
                        $calcSaldosAcr['PER'] = self::SDO_FOLG_ACR_AP_FOLG;
                        $calcSaldosAcr['BDH'] = self::SDO_FOLG_ACR_BH_FOLG;
                    } elseif ($isSabado) {
                        if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
                            $calcSaldos['DIA'] = self::SALDO_FOLGAR_SAB;
                            $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_SAB;
                            $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_SAB;

                            $calcSaldosAcr['DIA'] = self::SDO_FOLG_ACR_SAB;
                            $calcSaldosAcr['PER'] = self::SDO_FOLG_ACR_AP_SAB;
                            $calcSaldosAcr['BDH'] = self::SDO_FOLG_ACR_BH_SAB;
                        } else {
                            $calcSaldos['DIA'] = self::SALDO_A_FOLGAR_NORM;
                            $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_NORM;
                            $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_NORM;

                            $calcSaldosAcr['DIA'] = self::SDO_FOLG_ACR_NORM;
                            $calcSaldosAcr['PER'] = self::SDO_FOLG_ACR_AP_NORM;
                            $calcSaldosAcr['BDH'] = self::SDO_FOLG_ACR_BH_NORM;
                        }
                    } else {
                        $calcSaldos['DIA'] = self::SALDO_A_FOLGAR_NORM;
                        $calcSaldos['PER'] = self::SALDO_FOLGAR_AP_NORM;
                        $calcSaldos['BDH'] = self::SALDO_FOLGAR_BH_NORM;

                        $calcSaldosAcr['DIA'] = self::SDO_FOLG_ACR_NORM;
                        $calcSaldosAcr['PER'] = self::SDO_FOLG_ACR_AP_NORM;
                        $calcSaldosAcr['BDH'] = self::SDO_FOLG_ACR_BH_NORM;
                    }

                    /**
                     * Percorre o array $calcSaldos que contem as chaves correspondentes
                     * aos saldos e cria/altera os resumos para cada um deles.
                     */
                    foreach($calcSaldos as $keySaldo => $calcSaldo){
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
                        $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if (!is_object($assocSituFreqCalcSit)) {
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
                        }

                        if (is_object($assocSituFreqCalcSit)) {
                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum */
                            foreach ($this->resumosSituFreqs as $key => &$currentResum) {
                                if ($currentResum->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                                    if(!in_array($currentResum->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) unset($this->resumosSituFreqs[$key]);
                                    else {
                                        $currentResum->setQtrefapursitufreq($refAuxSaldos[self::HORAS_FOLGAR][$keySaldo]);
                                        $alterou = true;
                                    }
                                    break;
                                }
                            }
                            if (!$alterou && in_array($assocSituFreqCalcSit->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) {
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                                    $assocSituFreqCalcSit->getNrsitufrequencia(),
                                    $refAuxSaldos[self::HORAS_FOLGAR][$keySaldo]);
                            }
                        }

                        $calcSituFreq[$calcSaldo]['HORAS'] = $refAuxSaldos[self::HORAS_FOLGAR][$keySaldo];
                    }

                    /**
                     * Percorre o array $calcSaldosAcr que contem as chaves correspondentes
                     * aos saldos e cria/altera os resumos para cada um deles.
                     */
                    foreach($calcSaldosAcr as $keySaldo => $calcSaldo){
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
                        $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if (!is_object($assocSituFreqCalcSit)) {
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[$calcSaldo]['NRCALCULOSITUFREQ']);
                        }

                        if (is_object($assocSituFreqCalcSit)) {
                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum */
                            foreach ($this->resumosSituFreqs as $key => &$currentResum) {
                                if ($currentResum->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                                    if(!in_array($currentResum->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) unset($this->resumosSituFreqs[$key]);
                                    else {
                                        $currentResum->setQtrefapursitufreq($refAuxSaldos[self::HORAS_FOLGAR_ACRESC][$keySaldo]);
                                        $alterou = true;
                                    }
                                    break;
                                }
                            }
                            if (!$alterou && in_array($assocSituFreqCalcSit->getNrsitufrequencia(), $this->resumosBancoHorasAGerar)) {
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq(null, null, null,
                                    $assocSituFreqCalcSit->getNrsitufrequencia(),
                                    $refAuxSaldos[self::HORAS_FOLGAR_ACRESC][$keySaldo]);
                            }
                        }

                        $calcSituFreq[$calcSaldo]['HORAS'] = $refAuxSaldos[self::HORAS_FOLGAR_ACRESC][$keySaldo];
                    }

                    $soma = true;

                    $alterou = false;
                    /** @var PtoResumositufreq $currentResum */
                    foreach($this->resumosSituFreqs as &$currentResum){
                        if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                            $refAux = $currentResum->getQtrefapursitufreq() + $refAux;
                            $currentResum->setQtrefapursitufreq($refAux);
                            //$this->idDemonstrativos[$key] = true;
                            $alterou = true;
                            break;
                        }
                    }
                    if(!$alterou){
                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                        $dadosProgram['NRMOTIVOOCORFREQ'], null,
                        $assocSituFreqPadrao->getNrsitufrequencia(),
                        $refAux);
                        $this->idDemonstrativos[] = end($this->resumosSituFreqs);
                        //passa
                    }

                    $calcSituFreq[$calculoSituFreqPadrao]['HORAS'] += $refAux;

                    $soma = true;
                }
            }

        }

        foreach($vetCalcSit as $calcSit){
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                        $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if(!is_object($assocSituFreqCalcSit)){
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                            $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
            }

            if(is_object($assocSituFreqCalcSit)){
                /** @var PtoResumositufreq $resumoAtual */
                foreach($this->resumosSituFreqs as $key => $resumoAtual){
                    if($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()){
                        unset($this->resumosSituFreqs[$key]);
                        break;
                    }
                }
            }

            $calcSituFreq[$calcSit]['HORAS'] = 0;
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
    }

    private function progOcorAusenciaAutorizada($programacao, $cdTipoProgOcorrencia, &$intervaloAtual = null){     
        //<editor-fold desc="Correções de abono quando há uma baliza entre o intervalo">
        if(!is_null($intervaloAtual) && !is_null($intervaloAtual->MARCFIM) && $intervaloAtual->MARCFIM->getIdMarcacao() == self::BALIZA) {
            $calcs = $this->calcSituFreq->getCalcSituacoesFreq();
            // Adicionado validação is_null MARCNEXT
            if($intervaloAtual->MARCFIM->getidEntradaSaida() == self::SAIDA && !is_null($intervaloAtual->MARCNEXT)) {
                $gerarExtras = (DateUtil::getIntervaloEmSegundos($intervaloAtual->MARCFIM->getMarcacao()->getDthrajustada(), $intervaloAtual->MARCNEXT->getMarcacao()->getDthrajustada()) / 3600);
                $calcs[self::EX_DIA_NORMAL_NP_SEG]['HORAS'] += $gerarExtras;
                $intervaloAtual->IDINTERVALO = self::TRABALHO;
            }
            else {
                $intervaloAtual->IDINTERVALO = self::EXTRA;
            }
            $this->calcSituFreq->setCalcSituacoesFreq($calcs);
        }
        //</editor-fold>

        $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();
        $refAux = 0;
        $refAuxDia = 0;
        $refAuxNot = 0;
        $vetCalcSit = array();

        /* inic vet com situacoes normais - caso usuario na especifique */
        if($this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA ||
           $this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO) {
            $calculoSituFreqPadraoDia = $this->idExtraDia2; //Diurno  -> posições ímpares do array $vetSit
            $calculoSituFreqPadraoNot = $this->idExtraNot2; //Noturno -> posições pares do array $vetSit
        }
        else {
            $calculoSituFreqPadraoDia = $this->idTrabDia; //Diurno  -> posições ímpares do array $vetSit
            $calculoSituFreqPadraoNot = $this->idTrabNot; //Noturno -> posições pares do array $vetSit
        }

        $dadosProgram = self::retornaDadosProgramacao($programacao);

        // 03/07/00 - Claudio - novo ctrl programacao falta abonada - permite ref max
        if ((($calcSituFreq[$this->idTrabDia]['HORAS'] != 0) ||
            ($calcSituFreq[$this->idTrabNot]['HORAS'] != 0) ||
            ($dadosProgram['QTREFMAX'] == 0) ||
            ($cdTipoProgOcorrencia == self::FALTA_ABONADA) ||
            ($cdTipoProgOcorrencia == self::SAIDA_ATRASO_AUT))
            && !is_null($intervaloAtual)){
            if($intervaloAtual->HORA == 0){
                /* se achou pelo menos horas trabalhadas *
                /* inic vet com possiveis situacoes apuradas */
                $vetCalcSit [1] = self::ATRASOS_DIURNOS;
                $vetCalcSit [2] = self::ATRASOS_NOTURNOS;
                $vetCalcSit [3] = self::SAIDAS_DIURNAS;
                $vetCalcSit [4] = self::SAIDAS_NOTURNAS;

                //31/07/06 - claudio/eduardo - se for atraso, seta apenas atrasos (idem para saida)
                if ($cdTipoProgOcorrencia == self::ATRASO_AUTORIZADO) {
                    $vetCalcSit [1] = self::ATRASOS_DIURNOS;
                    $vetCalcSit [2] = self::ATRASOS_NOTURNOS;
                    unset($vetCalcSit[3]);
                    unset($vetCalcSit[4]);
                }
                elseif ($cdTipoProgOcorrencia == self::SAIDA_AUTORIZADA) {
                    $vetCalcSit [1] = self::SAIDAS_DIURNAS;
                    $vetCalcSit [2] = self::SAIDAS_NOTURNAS;
                    unset($vetCalcSit[3]);
                    unset($vetCalcSit[4]);
                }
                elseif($cdTipoProgOcorrencia == self::FALTA_ABONADA){
                    $vetCalcSit [1] = self::FALTAS_DIURNAS;
                    $vetCalcSit [2] = self::FALTAS_NOTURNAS;
                    unset($vetCalcSit[3]);
                    unset($vetCalcSit[4]);
                }

                foreach ($vetCalcSit as $key => $sit) {
                    $refAux += $calcSituFreq[$sit]['HORAS'];
                    if ($key % 2 != 0) {
                        $refAuxDia += $calcSituFreq[$sit]['HORAS'];
                    } else {
                        $refAuxNot += $calcSituFreq[$sit]['HORAS'];
                    }
                }
            }
            else{
                $refAux    = $intervaloAtual->HORA;
                $refAuxDia = $intervaloAtual->HORADIA;
                $refAuxNot = $intervaloAtual->HORANOT;
                if($intervaloAtual->MARCINI->getIdDentroHoraBase() == self::NAO) {
                    $calculoSituFreqPadraoDia = $this->idExtraDia2; //Diurno  -> posições ímpares do array $vetSit
                    $calculoSituFreqPadraoNot = $this->idExtraNot2; //Noturno -> posições pares do array $vetSit
                }
            }

            if ($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())) {
                /** @var PtoResumositufreq $resumSituFreq */
                foreach ($this->resumosSituFreqs as $resumSituFreq) {
                    if ($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()) {
                        if ($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                            $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']
                        ) {
                            if ($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())) {
                                $refAux = (($programacao->getVrcoeficienteacrescimo() / 100) + 1) * ($resumSituFreq->getQtrefapursitufreq());
                            } else {
                                $refAux = $resumSituFreq->getQtrefapursitufreq();
                            }
                            //Olhar se caso esteja hora realmente faz nada ou se joga pra cima ou pra baixo
                            //Olhar se cria um novo resumo com a situação freq ou só coloca a nova nesse msm resumo

                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum */
                            foreach ($this->resumosSituFreqs as &$currentResum) {
                                if ($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()) {
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAux;
                                    $refAux = $novoQtRefApurSituFreq;
                                    $currentResum->setQtrefapursitufreq($refAux);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if (!$alterou) {
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'],
                                                                                     null,
                                                                                     $programacao->getNrsitufrequencia(),
                                                                                     $refAux);
                            }

                            //Atualiza $calcSituFreq
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                                $programacao->getNrsitufrequencia());
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                    $programacao->getNrsitufrequencia());
                            }

                            if (is_object($assocSituFreqPadrao)) {
                                $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                            }
                        }
                        break;
                    }
                }
            } else {
                if ($refAux != 0) {
                    if ($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) {
                        $refAux = $dadosProgram['QTREFMAX'];
                    }
                    if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                        /* soma a ref na sit_apur cadastrada */
                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach ($this->resumosSituFreqs as &$currentResum) {
                            if ($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()) {
                                $refAux = $currentResum->getQtrefapursitufreq() + $refAux;
                                $currentResum->setQtrefapursitufreq($refAux);
                                $alterou = true;
                                break;
                            }
                        }
                        /*if (!$alterou) {
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'],
                                                                                 null,
                                                                                 $programacao->getNrsitufrequencia(),
                                                                                 $refAux);
                        }*/

                        //Atualiza $calcSituFreq
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                            $programacao->getNrsitufrequencia());
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if (!is_object($assocSituFreqPadrao)) {
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                $programacao->getNrsitufrequencia());
                        }

                        if (is_object($assocSituFreqPadrao)) {
                            $calcSituFreq[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                        }

                        $soma = false;
                    } else {
                        //Situação frequencia padrão dia
                        if ($refAuxDia != 0) {
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calcSituFreq[$calculoSituFreqPadraoDia]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calcSituFreq[$calculoSituFreqPadraoDia]['NRCALCULOSITUFREQ']);
                            }
                            if(is_object($assocSituFreqPadrao)){
                                $alterou = false;
                                /** @var PtoResumositufreq $currentResum */
                                foreach ($this->resumosSituFreqs as &$currentResum) {
                                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                                        if($dadosProgram['QTREFMAX'] != 0 && $refAuxDia > $dadosProgram['QTREFMAX']) $refAuxDia = $dadosProgram['QTREFMAX'];
                                        $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAuxDia;
                                        $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                        $alterou = true;
                                        break;
                                    }
                                }
                                if (!$alterou) {
                                    if($dadosProgram['QTREFMAX'] != 0 && $refAuxDia > $dadosProgram['QTREFMAX']) $refAuxDia = $dadosProgram['QTREFMAX'];
                                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                        $dadosProgram['NRMOTIVOOCORFREQ'],
                                        null,
                                        $assocSituFreqPadrao->getNrsitufrequencia(),
                                        $refAuxDia);
                                    //passa
                                }
                            }
                        }

                        //Situação frequencia padrão noite
                        if ($refAuxNot != 0) {
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calcSituFreq[$calculoSituFreqPadraoNot]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calcSituFreq[$calculoSituFreqPadraoNot]['NRCALCULOSITUFREQ']);
                            }

                            if(is_object($assocSituFreqPadrao)){
                                $alterou = false;
                                /** @var PtoResumositufreq $currentResum */
                                foreach ($this->resumosSituFreqs as &$currentResum) {
                                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                                        $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAuxNot;
                                        $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                        $alterou = true;
                                        break;
                                    }
                                }
                                if (!$alterou) {
                                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                         $dadosProgram['NRMOTIVOOCORFREQ'],
                                                                                         null,
                                                                                         $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                         $dadosProgram['QTREFMAX']);
                                }
                            }
                        }

                        $calcSituFreq[$calculoSituFreqPadraoDia]['HORAS'] += $refAuxDia;
                        $calcSituFreq[$calculoSituFreqPadraoNot]['HORAS'] += $refAuxNot;

                        $soma = true;
                    }

                    //30/11/03 - Nádia - argumento  'N'
                    /* subtrai a ref da saida/atraso autorizado */
                    //Verificar se continua fazendo isso
                    //iuo_situacao . uf_ref_sub($refAux, $vetSit, vet_sit_prog, soma, 'N');
                }
            }

            foreach ($vetCalcSit as $calcSit) {
                //Primeira busca para a organização trabalho
                /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                    $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
                //Caso não haja associação específica para a organização de trabalho, busca a associação de
                //organização padrão
                if (!is_object($assocSituFreqCalcSit)) {
                    $nrOrgPadrao = FPA::getNrorgPadrao();
                    $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                        $calcSituFreq[$calcSit]['NRCALCULOSITUFREQ']);
                }

                if (is_object($assocSituFreqCalcSit)) {
                    /** @var PtoResumositufreq $resumoAtual */
                    foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                        if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                            if ($refAux > $resumoAtual->getQtrefapursitufreq()) {
                                $refAux = $refAux - $resumoAtual->getQtrefapursitufreq();
                                $calcSituFreq[$calcSit]['HORAS'] = 0;
                                unset($this->resumosSituFreqs[$key]);
                            }
                            elseif((string)$refAux == (string)$resumoAtual->getQtrefapursitufreq()){
                                $refAux = 0;
                                $calcSituFreq[$calcSit]['HORAS'] = 0;
                                unset($this->resumosSituFreqs[$key]);
                            }
                            elseif ($refAux < $resumoAtual->getQtrefapursitufreq()) {
                                $value = ($resumoAtual->getQtrefapursitufreq() - $refAux);
                                $resumoAtual->setQtrefapursitufreq($value);
                                $calcSituFreq[$calcSit]['HORAS'] = $value;
                                $refAux = 0;
                            }

                            break;
                        }
                    }
                }
                else $calcSituFreq[$calcSit]['HORAS'] = 0;

                if ($refAux == 0) {
                    break;
                }
            }

            $this->calcSituFreq->setCalcSituacoesFreq($calcSituFreq);
        }
    }

    //<editor-fold desc="Vitor Peixoto 20/08/2015 Ocorrência que permite a identificação de intervalos não previstos pela escala, como os do Artigo 71 CLT">
    /** @var PtoProgocorrencia $programacao */
    private function progOcorIdentificaIntervaloNaoProgramado($programacao, $cdTipoProgOcorrencia, $intervaloAtual = null) {
        //Recebe os Cálculos das Situações de Frequência
        $calculosSituacoesFrequencia = $this->calcSituFreq->getCalcSituacoesFreq();

        //Valor de referência da ocorrência
        $refAux = 0;

        //Vetor que receberá as Situações de Frequência referentes à esta programação
        $vetorCalculoSituacoes = array();

        $calculoSituFreqPadrao = self::NAO_MARCOU_INTERV;

        //Recebe array com as informações definidas no cadastro da programação
        $dadosProgram = self::retornaDadosProgramacao($programacao);

        //Intervalo ocorreu, ignoramos ele.
        if(!is_null($intervaloAtual)) {
            $refAux = $intervaloAtual->HORA;
            $calculosSituacoesFrequencia[self::SAIDAS_DIURNAS]['HORAS']  -= $intervaloAtual->HORADIA;
            $calculosSituacoesFrequencia[self::SAIDAS_NOTURNAS]['HORAS'] -= $intervaloAtual->HORANOT;
        }

    }
    //</editor-fold>

    //<editor-fold desc="Vitor Peixoto 12/06/2015 Ocorrência que considera apenas as ausências que ocorrem dentro do período trabalhado">
    private function progOcorAusenciaIntrajornadaAutorizada($programacao, $cdTipoProgOcorrencia, $intervaloAtual = null){
        //Recebe os Cálculos das Situações de Frequência
        $calculosSituacoesFrequencia = $this->calcSituFreq->getCalcSituacoesFreq();

        //Valores de referência da ocorrência
        $refAux = 0;
        $refAuxDia = 0;
        $refAuxNot = 0;

        //Vetor que receberá as Situações de Frequência referentes à esta programação
        $vetorCalculoSituacoes = array();

        /* Cálculos padrões a serem utilizados caso não sejam especificados na programação */
        $calculoSituFreqPadraoDia = $this->idTrabDia; //Diurno  -> posições ímpares do array $vetSit
        $calculoSituFreqPadraoNot = $this->idTrabNot; //Noturno -> posições pares do array $vetSit

        //Recebe array com as informações definidas no cadastro da programação
        $dadosProgram = self::retornaDadosProgramacao($programacao);

        /* Se tiver trabalhado no dia, se a quantidade máxima permitida pela programação for 0 ou se a programação
           abonar ambos atraso e saída */
        if (($calculosSituacoesFrequencia[$this->idTrabDia]['HORAS'] != 0) ||
            ($calculosSituacoesFrequencia[$this->idTrabNot]['HORAS'] != 0) ||
            ($dadosProgram['QTREFMAX'] == 0)                               ||
            ($cdTipoProgOcorrencia == self::SAIDA_ATRASO_INTRA_AUT)){

            //<editor-fold desc="Define as Situações de Freqência e os valores de referência das mesmas">
            if($intervaloAtual->HORA == 0){
                /* Adiciona ao vetor as possíveis Situações de Frequência para esta programação */
                $vetorCalculoSituacoes [1] = self::ATRASOS_DIURNOS;
                $vetorCalculoSituacoes [2] = self::ATRASOS_NOTURNOS;
                $vetorCalculoSituacoes [3] = self::SAIDAS_DIURNAS;
                $vetorCalculoSituacoes [4] = self::SAIDAS_NOTURNAS;

                //Filtra dentre as Situações adicionadas aquelas que são referentes ao $cdTipoProgOcorrencia
                if ($cdTipoProgOcorrencia == self::ATRASO_INTRA_AUTORIZADO) {
                    $vetorCalculoSituacoes [1] = self::ATRASOS_DIURNOS;
                    $vetorCalculoSituacoes [2] = self::ATRASOS_NOTURNOS;
                    unset($vetorCalculoSituacoes[3]);
                    unset($vetorCalculoSituacoes[4]);
                }
                elseif ($cdTipoProgOcorrencia == self::SAIDA_INTRA_AUTORIZADA) {
                    $vetorCalculoSituacoes [1] = self::SAIDAS_DIURNAS;
                    $vetorCalculoSituacoes [2] = self::SAIDAS_NOTURNAS;
                    unset($vetorCalculoSituacoes[3]);
                    unset($vetorCalculoSituacoes[4]);
                }

                foreach ($vetorCalculoSituacoes as $key => $situacao) {
                    $refAux += $calculosSituacoesFrequencia[$situacao]['HORAS'];
                    if ($key % 2 != 0) {
                        $refAuxDia += $calculosSituacoesFrequencia[$situacao]['HORAS'];
                    } else {
                        $refAuxNot += $calculosSituacoesFrequencia[$situacao]['HORAS'];
                    }
                }
            }
            else{
                $refAux    = $intervaloAtual->HORA;
                $refAuxDia = $intervaloAtual->HORADIA;
                $refAuxNot = $intervaloAtual->HORANOT;
            }
            //</editor-fold>

            /** @var RegistroPonto $ultimoRegistro */
            $ultimoRegistro = end($this->registrosNDesprez);
            $penultimoRegistro = $this->registrosNDesprez[count($this->registrosNDesprez)-2];
            $valorUltimaSaida = 0;
            if($ultimoRegistro->getIdMarcacao() == self::BALIZA) {
                $valorUltimaSaida = DateUtil::getIntervaloEmSegundos($penultimoRegistro->getMarcacao()->getDthrajustada(),
                                                                     $ultimoRegistro->getMarcacao()->getDthrajustada());
                $valorUltimaSaida /= 3600;
                $refAux -= $valorUltimaSaida;
                $refAuxDia -= $valorUltimaSaida;
            }

            // Caso tenha sido configurada na Programação uma Situação como gatilho
            if ($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())) {
                /** @var PtoResumositufreq $resumoSituacaoFrequencia */
                foreach ($this->resumosSituFreqs as $resumoSituacaoFrequencia) {
                    if ($resumoSituacaoFrequencia->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()) {
                        // Quando o valor do Resumo da Situação atender às condições impostas no gatilho da Programação
                        if ($resumoSituacaoFrequencia->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                            $resumoSituacaoFrequencia->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']) {

                            // Se tiver configurado na Programação um valor coeficiente para multiplicar no valor do Resumo
                            if ($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())) {
                                $refAux = (($programacao->getVrcoeficienteacrescimo() / 100) + 1) * ($resumoSituacaoFrequencia->getQtrefapursitufreq());
                            } else {
                                $refAux = $resumoSituacaoFrequencia->getQtrefapursitufreq();
                            }

                            //Atualiza o valor do Resumo caso exista. Caso não, cria um novo
                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum */
                            foreach ($this->resumosSituFreqs as &$currentResum) {
                                if ($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()) {
                                    //Atualiza
                                    if($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) $refAux = $dadosProgram['QTREFMAX'];
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAux;
                                    $refAux = $novoQtRefApurSituFreq;
                                    $currentResum->setQtrefapursitufreq($refAux);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if (!$alterou) {
                                // Cria
                                if($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) $refAux = $dadosProgram['QTREFMAX'];
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                    $dadosProgram['NRMOTIVOOCORFREQ'],
                                    null,
                                    $programacao->getNrsitufrequencia(),
                                    $refAux);
                            }

                            //Atualiza $calcSituFreq
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                                $programacao->getNrsitufrequencia());
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                    $programacao->getNrsitufrequencia());
                            }

                            if (is_object($assocSituFreqPadrao)) {
                                $calculosSituacoesFrequencia[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                            }
                        }
                        break;
                    }
                }
            } else {
                if ($refAux != 0) {
                    if ($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) {
                        $refAux = $dadosProgram['QTREFMAX'];
                    }
                    if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                        /* soma a ref na sit_apur cadastrada */
                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum */
                        foreach ($this->resumosSituFreqs as &$currentResum) {
                            if ($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()) {
                                if($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) $refAux = $dadosProgram['QTREFMAX'];
                                $refAux = $currentResum->getQtrefapursitufreq() + $refAux;
                                $currentResum->setQtrefapursitufreq($refAux);
                                $alterou = true;
                                break;
                            }
                        }
                        if (!$alterou) {
                            if($dadosProgram['QTREFMAX'] != 0 && $refAux > $dadosProgram['QTREFMAX']) $refAux = $dadosProgram['QTREFMAX'];
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                $dadosProgram['NRMOTIVOOCORFREQ'],
                                null,
                                $programacao->getNrsitufrequencia(),
                                $refAux);
                        }

                        //Atualiza $calcSituFreq
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                            $programacao->getNrsitufrequencia());
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if (!is_object($assocSituFreqPadrao)) {
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                $programacao->getNrsitufrequencia());
                        }

                        if (is_object($assocSituFreqPadrao)) {
                            $calculosSituacoesFrequencia[$assocSituFreqPadrao->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] += $refAux;
                        }

                        $soma = false;
                    } else {
                        //Situação frequencia padrão dia
                        if ($refAuxDia != 0) {
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calculosSituacoesFrequencia[$calculoSituFreqPadraoDia]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calculosSituacoesFrequencia[$calculoSituFreqPadraoDia]['NRCALCULOSITUFREQ']);
                            }
                            if(is_object($assocSituFreqPadrao)){
                                $alterou = false;
                                /** @var PtoResumositufreq $currentResum */
                                foreach ($this->resumosSituFreqs as &$currentResum) {
                                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                                        if($dadosProgram['QTREFMAX'] != 0 && $refAuxDia > $dadosProgram['QTREFMAX']) $refAuxDia = $dadosProgram['QTREFMAX'];
                                        $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAuxDia;
                                        $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                        $alterou = true;
                                        break;
                                    }
                                }
                                if (!$alterou) {
                                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                        $dadosProgram['NRMOTIVOOCORFREQ'],
                                        null,
                                        $assocSituFreqPadrao->getNrsitufrequencia(),
                                        $refAuxDia);
                                }
                            }
                        }

                        //Situação frequencia padrão noite
                        if ($refAuxNot != 0) {
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calculosSituacoesFrequencia[$calculoSituFreqPadraoNot]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if (!is_object($assocSituFreqPadrao)) {
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calculosSituacoesFrequencia[$calculoSituFreqPadraoNot]['NRCALCULOSITUFREQ']);
                            }

                            if(is_object($assocSituFreqPadrao)){
                                $alterou = false;
                                /** @var PtoResumositufreq $currentResum */
                                foreach ($this->resumosSituFreqs as &$currentResum) {
                                    if ($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                                        if($dadosProgram['QTREFMAX'] != 0 && $refAuxNot > $dadosProgram['QTREFMAX']) $refAuxNot = $dadosProgram['QTREFMAX'];
                                        $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $refAuxNot;
                                        $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                        $alterou = true;
                                        break;
                                    }
                                }
                                if (!$alterou) {
                                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                        $dadosProgram['NRMOTIVOOCORFREQ'],
                                        null,
                                        $assocSituFreqPadrao->getNrsitufrequencia(),
                                        $refAuxNot);
                                }
                            }
                        }

                        $calculosSituacoesFrequencia[$calculoSituFreqPadraoDia]['HORAS'] += $refAuxDia;
                        $calculosSituacoesFrequencia[$calculoSituFreqPadraoNot]['HORAS'] += $refAuxNot;

                        $soma = true;
                    }
                }
            }

            foreach ($vetorCalculoSituacoes as $calcSit) {
                //Primeira busca para a organização trabalho
                /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                    $calculosSituacoesFrequencia[$calcSit]['NRCALCULOSITUFREQ']);
                //Caso não haja associação específica para a organização de trabalho, busca a associação de
                //organização padrão
                if (!is_object($assocSituFreqCalcSit)) {
                    $nrOrgPadrao = FPA::getNrorgPadrao();
                    $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                        $calculosSituacoesFrequencia[$calcSit]['NRCALCULOSITUFREQ']);
                }

                if (is_object($assocSituFreqCalcSit)) {
                    /** @var PtoResumositufreq $resumoAtual */
                    foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                        if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                            if ($refAux > $resumoAtual->getQtrefapursitufreq()) {
                                $refAux = $refAux - $resumoAtual->getQtrefapursitufreq();
                                $calculosSituacoesFrequencia[$calcSit]['HORAS'] = 0;
                                unset($this->resumosSituFreqs[$key]);
                            }
                            elseif((string)$refAux == (string)$resumoAtual->getQtrefapursitufreq()){
                                $refAux = 0;
                                $calculosSituacoesFrequencia[$calcSit]['HORAS'] = 0;
                                unset($this->resumosSituFreqs[$key]);
                            }
                            elseif ($refAux < $resumoAtual->getQtrefapursitufreq()) {
                                $value = ($resumoAtual->getQtrefapursitufreq() - $refAux);
                                $resumoAtual->setQtrefapursitufreq($value);
                                $calculosSituacoesFrequencia[$calcSit]['HORAS'] = $value;
                                $refAux = 0;
                            }

                            break;
                        }
                    }
                }
                else $calculosSituacoesFrequencia[$calcSit]['HORAS'] = 0;

                if ($refAux == 0) {
                    break;
                }
            }

            $this->calcSituFreq->setCalcSituacoesFreq($calculosSituacoesFrequencia);
        }
    }
    //</editor-fold>

    //<editor-fold desc="Vitor Peixoto 19/06/2015 Cálculo que abona ausências justificadas que ocorrem fora da jornada, lançando o valor trabalhado definido">
    private function progOcorAusenciaExtrajornadaAutorizada($programacao, $cdTipoProgOcorrencia){
        $valorTrabalhado = 0;
        $valorFaltas = 0;
        $idDia = 'DIURNO';
        $geraExtra = false;

        $calculosSituacoesFrequencia = $this->calcSituFreq->getCalcSituacoesFreq();
        $vetorCalculosSituacoes = array();

        $programacaoOcorrencia = self::retornaDadosProgramacao($programacao);

        //<editor-fold desc="Define o tipo de horário entre Diurno e Noturno">
        $horario = reset($this->horario->getIntervalosHorario());
        $primeiraEntrada = $horario['HORA'];
        $horario = end($this->horario->getIntervalosHorario());
        $ultimaSaida = $horario['HORA'];

        $inicioPeriodoNoturno = self::formataHora($this->escalaHistorico->getHriniperiodonoturno());
        $fimPeriodoNoturno = self::formataHora($this->escalaHistorico->getHrfimperiodonoturno());

        $isSabado = DateUtil::getDiaSemana($this->data->format(DateUtil::FORMATO_BRASILEIRO)) == 6;

        // Se não tiver jornada (Sab, Dom e Feriado gera extra)
        if ($this->idDiaCalend == self::FERIADO || $this->horario->getHorarioHistorico()->getIdtipohorario() == self::FOLGA    ||
           ($isSabado                           && $this->horario->getHorarioHistorico()->getIdtipohorario() == self::COMPENSADO)) {
            $geraExtra = true;
        }
        elseif ($primeiraEntrada  >= $fimPeriodoNoturno    && $ultimaSaida < $inicioPeriodoNoturno) $idDia = 'DIURNO';
        else if ($primeiraEntrada >= $inicioPeriodoNoturno && $ultimaSaida < $fimPeriodoNoturno)    $idDia = 'NOTURNO';
        else throw new \Exception('Trabalho Diurno e Noturno no dia '.$this->data->__toString());//tk_warning('Trabalho Diurno e Noturno no mesmo dia.');

        if($geraExtra) {
            $vetorCalculosSituacoes[] = $idTrabalho = $this->idExtraDia2; //Define o id como extra
        } elseif($idDia == 'DIURNO') {
            $vetorCalculosSituacoes[] = $idTrabalho = $this->idTrabDia;
            $vetorCalculosSituacoes[] = $idFaltas   = self::FALTAS_DIURNAS;
            $vetorCalculosSituacoes[] = $idAtrasos  = self::ATRASOS_DIURNOS;
        } else {
            $vetorCalculosSituacoes[] = $idTrabalho = $this->idTrabNot;
            $vetorCalculosSituacoes[] = $idFaltas   = self::FALTAS_NOTURNAS;
            $vetorCalculosSituacoes[] = $idAtrasos  = self::ATRASOS_NOTURNOS;
        }
        //</editor-fold>

        $valorTrabalhado = $calculosSituacoesFrequencia[$idTrabalho]['HORAS'];
        $valorFaltas     = $calculosSituacoesFrequencia[$idFaltas]['HORAS'];
        $calculoSituFreqPadraoDia = $idTrabalho;


        //<editor-fold desc="Altera os cálculos no caso de haver falta no dia">
        if($geraExtra) {
            $calculosSituacoesFrequencia[$calculoSituFreqPadraoDia]['HORAS'] += $programacaoOcorrencia['QTREFMAX'];
        } elseif($valorFaltas != 0 && $programacaoOcorrencia['QTREFMAX'] >= $valorFaltas) {
            $calculosSituacoesFrequencia[$idFaltas]['HORAS'] = 0;
            $calculosSituacoesFrequencia[$idTrabalho]['HORAS'] = $programacaoOcorrencia['QTREFMAX'];
        } else if($valorFaltas != 0 && $programacaoOcorrencia['QTREFMAX'] < $valorFaltas) {
            $calculosSituacoesFrequencia[$idFaltas]['HORAS']  = 0;
            $calculosSituacoesFrequencia[$idAtrasos]['HORAS'] = $valorFaltas - $programacaoOcorrencia['QTREFMAX'];
        } else {
            $calculosSituacoesFrequencia[$calculoSituFreqPadraoDia]['HORAS'] += $programacaoOcorrencia['QTREFMAX'];
            $calculosSituacoesFrequencia[$idAtrasos]['HORAS'] -= $programacaoOcorrencia['QTREFMAX'];
        }
        //</editor-fold>


        foreach($vetorCalculosSituacoes as $calculo) {
            /** @var PtoAssocsitufreq $assocSituFreqPadrao */
            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                                                                        $calculosSituacoesFrequencia[$calculo]['NRCALCULOSITUFREQ']);
            //Caso não haja associação específica para a organização de trabalho, busca a associação de
            //organização padrão
            if (!is_object($assocSituFreqPadrao)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                                                                            $calculosSituacoesFrequencia[$calculo]['NRCALCULOSITUFREQ']);
            }

            if(is_object($assocSituFreqPadrao)){
                $alterou = false;
                /** @var PtoResumositufreq $currentResum */
                foreach ($this->resumosSituFreqs as $key => &$currentResum) {
                    if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()) {
                        if($calculosSituacoesFrequencia[$calculo]['HORAS'] != 0){
                            $currentResum->setQtrefapursitufreq($calculosSituacoesFrequencia[$calculo]['HORAS']);
                        }
                        else {
                            unset($this->resumosSituFreqs[$key]);
                        }
                        $alterou = true;
                        break;
                    }
                }
                if (!$alterou && $calculosSituacoesFrequencia[$calculo]['HORAS'] != 0) {
                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($programacaoOcorrencia['NRPROGOCOR'],
                        $programacaoOcorrencia['NRMOTIVOOCORFREQ'],
                        null,
                        $assocSituFreqPadrao->getNrsitufrequencia(),
                        $calculosSituacoesFrequencia[$calculo]['HORAS']);
                }
            }
        }

        $this->calcSituFreq->setCalcSituacoesFreq($calculosSituacoesFrequencia);
    }
    //</editor-fold>

    //<editor-fold desc="desc="Vitor Peixoto 26/05/2015 Cálculo para complemento da jornada diária (Débito > Trabalho)">
    private function progOcorComplementaTrabalho($programacao, $horarioDiaSeguinte, $idDiaCalendSeg)
    {
        $valorAusencias       = 0;
        $valorExtras          = 0;
        $extrasDiurnas        = 0;
        $extrasNoturnas       = 0;
        $valorTrabalhado      = 0;
        $valorJornadaTrabalho = 0;

        $idTrabalho = $this->idTrabDia;
        $idFalta    = self::FALTAS_DIURNAS;

        $calculosDeAusencias   = array();
        $calculosDeExtras      = array();
        $vetorCalculoSituacoes = array();

        $calculosSituacaoFrequencia = $this->calcSituFreq->getCalcSituacoesFreq();
        $programacaoOcorrencia      = self::retornaDadosProgramacao($programacao);

        //<editor-fold desc="Define o tipo de horário entre Diurno e Noturno">
        $intervHorario =$this->horario->getIntervalosHorario();
        $horario = reset($intervHorario);
        $primeiraEntrada = $horario['HORA'];
        $intervHorario = $this->horario->getIntervalosHorario();
        $horario = end($intervHorario);
        $ultimaSaida = $horario['HORA'];

        $inicioPeriodoNoturno = self::formataHora($this->escalaHistorico->getHriniperiodonoturno());
        $fimPeriodoNoturno = self::formataHora($this->escalaHistorico->getHrfimperiodonoturno());

        if ($primeiraEntrada >= $fimPeriodoNoturno && $ultimaSaida < $inicioPeriodoNoturno) {
            $idTipoHorario = 'DIURNO';
            $idTrabalho = $this->idTrabDia;
            $idFalta    = self::FALTAS_DIURNAS;
        }
        else if ($primeiraEntrada >= $inicioPeriodoNoturno && $ultimaSaida < $fimPeriodoNoturno) {
            $idTipoHorario = 'NOTURNO';
            $idTrabalho = $this->idTrabNot;
            $idFalta    = self::FALTAS_NOTURNAS;
        }
        // LEONARDOCARVALHO - 10/11/2015 - RETIRADO ELSE ABAIXO POIS JÁ FOI IMPLEMENTADO O ADICIONAL NOTURNO
        //else throw new \Exception('Trabalho Diurno e Noturno no dia '.$this->data->__toString());//tk_warning('Trabalho Diurno e Noturno no mesmo dia.');
        //</editor-fold>

        //<editor-fold desc="Calcula a jornada de trabalho diária">
        $entrada = 0;
        foreach ($this->horario->getIntervalosHorario() as $key => $intervaloHorario) {
            if ($key % 2 != 0) { //Saída
                //$valorJornadaTrabalho += ($intervaloHorario['HORA'] * 60) - $entrada;
                $valorJornadaTrabalho += DateUtil::getHoraFloatDeString($intervaloHorario['HORA']) - $entrada;
            } else { //Entrada
                //$entrada = ($intervaloHorario['HORA'] * 60);
                $entrada = DateUtil::getHoraFloatDeString($intervaloHorario['HORA']);
            }
        }
        //$valorJornadaTrabalho /= 6000;
        //</editor-fold>

        //<editor-fold desc="Define os Cálculos de acordo com o tipo de horário">
        if($idTipoHorario == 'DIURNO') {
            // LEONARDOCARVALHO - 02/12/2015
            /*$vetorCalculoSituacoes[] = $calculosDeAusencias['ATRASO'] = self::ATRASOS_DIURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias['SAIDA']  = self::SAIDAS_DIURNAS;*/
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::ATRASOS_DIURNOS] = self::ATRASOS_DIURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::SAIDAS_DIURNAS]  = self::SAIDAS_DIURNAS;
            $idTrabalho = $this->idTrabDia;
        }
        else if($idTipoHorario == 'NOTURNO') {
            // LEONARDOCARVALHO - 02/12/2015
            /*$vetorCalculoSituacoes[] = $calculosDeAusencias['ATRASO'] = self::ATRASOS_NOTURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias['SAIDA']  = self::SAIDAS_NOTURNAS;*/
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::ATRASOS_NOTURNOS] = self::ATRASOS_NOTURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::SAIDAS_NOTURNAS]  = self::SAIDAS_NOTURNAS;
            $idTrabalho = $this->idTrabNot;
        }
        else {
            // LEONARDOCARVALHO - 02/12/2015 - Adicionado opção para ambas as situações
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::ATRASOS_DIURNOS]  = self::ATRASOS_DIURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::SAIDAS_DIURNAS]   = self::SAIDAS_DIURNAS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::ATRASOS_NOTURNOS] = self::ATRASOS_NOTURNOS;
            $vetorCalculoSituacoes[] = $calculosDeAusencias[self::SAIDAS_NOTURNAS]  = self::SAIDAS_NOTURNAS;
            $idTrabalho = 'AMBOS';
        }
        //</editor-fold>

        // LEONARDOCARVALHO - 02/12/2015 - Condição se opção for ambas, sumarizar o trabalho diurno e noturno
        if ($idTrabalho != 'AMBOS') {
            $valorTrabalhado = $calculosSituacaoFrequencia[$idTrabalho]['HORAS'];
        } else {
            $valorTrabalhado = $calculosSituacaoFrequencia[$this->idTrabDia]['HORAS'] + $calculosSituacaoFrequencia[$this->idTrabNot]['HORAS'];
        }

        //<editor-fold desc="Define os Cálculos de horas extras no dia">
        $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idExtraDia]['CDCALCULOSITUFREQ'];
        $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idExtraNot]['CDCALCULOSITUFREQ'];
        $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idExtraDia2]['CDCALCULOSITUFREQ'];
        $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idExtraNot2]['CDCALCULOSITUFREQ'];

        if ($this->idTipoExtra != $this->idTipoPextra) {
            $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idPextraDia]['CDCALCULOSITUFREQ'];
            $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idPextraNot]['CDCALCULOSITUFREQ'];
            $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idPextraDia2]['CDCALCULOSITUFREQ'];
            $calculosDeExtras [] = $calculosSituacaoFrequencia[$this->idPextraNot2]['CDCALCULOSITUFREQ'];
        }
        //</editor-fold>

        $ambosTrabalho = false;

        // LEONARDOCARVALHO - 02/12/2015
        if ($idTrabalho == 'AMBOS') {
            $idTrabalho = $this->idTrabDia;
            $ambosTrabalho = true;
        }

        $vetorCalculoSituacoes[] = $idTrabalho;

        // Adiciona os Cálculos de extras ao array de verificações
        $vetorCalculoSituacoes = array_merge($vetorCalculoSituacoes, $calculosDeExtras);

        foreach($calculosDeAusencias as $calculoAusencia) {
            $valorAusencias += $calculosSituacaoFrequencia[$calculoAusencia]['HORAS'];
        }

        foreach($calculosDeExtras as $key => $calculoExtra) {
            $valorExtras += $calculosSituacaoFrequencia[$calculoExtra]['HORAS'];

            //As posições ímpares do vetor correspondem às extras noturnas
            if($key % 2 != 0) {
                $extrasNoturnas += $calculosSituacaoFrequencia[$calculoExtra]['HORAS'];
            }
            else {
                $extrasDiurnas += $calculosSituacaoFrequencia[$calculoExtra]['HORAS'];
            }
        }

        if($valorTrabalhado < $valorJornadaTrabalho && $valorExtras > 0) {
            //<editor-fold desc="Caso haja uma falta mas o funcionário tenha trabalhado em algum momento fora da jornada, transforma falta em atraso">
            if($calculosSituacaoFrequencia[$idFalta]['HORAS'] > 0) {
                $vetorCalculoSituacoes[] = $idFalta;
                $valorAusencias += $calculosSituacaoFrequencia[$idFalta]['HORAS'];
                $calculosSituacaoFrequencia[$idFalta]['HORAS'] = 0;
            }
            //</editor-fold>
            $valorCalculado = $valorExtras - $valorAusencias;
            if($valorCalculado >= 0) {
                $valorExtrasRef = $valorExtras;
                $valorExtras = ($valorTrabalhado + $valorExtras) - $valorJornadaTrabalho;

                // LEONARDCARVALHO - 21/12/2015 - Problemas no cálculo de $valorExtras acima por causa de ponto flutuante, soluções abaixo.
                //$valorExtras = ((float)(string)$valorTrabalhado + (float)(string)$valorExtras) - (float)(string)$valorJornadaTrabalho;
                $valorExtras = number_format((float)$valorExtras, 6);

                /* LEONARDOCARVALHO - 02/12/2015 - $valorExtras ficava negativo quando a soma fosse inferior a jornada de trabalho,
                                                   ocorre quando existe hora extra mas o $valorTrabalhado ainda é inferior a jornada,
                                                   atribuido $valorExtrasRef para manter o valor real e verificar valor de $valorExtras */
                if ($valorExtras >= 0) {
                    $valorTrabalhado = $valorJornadaTrabalho;
                    $valorAusencias = 0;
                } else {
                    /* @todo LEONARDOCARVALHO - 30/05/2016 - Adicionado else para validar quando a condição do valorExtras for negativo, 
                                                             sobrava hora extra mas com a nova atribuição acima a hora extra ficava perdida, 
                                                             sem ser complementada ao trabalho e ainda descontava os atrasos e saídas das balizas */
                    //$valorTrabalhado += $valorCalculado;
                    $valorTrabalhado = $valorJornadaTrabalho + $valorExtras;
                    $valorAusencias = $valorJornadaTrabalho - $valorTrabalhado;
                    $valorExtras = 0;
                }
            }
            else {
                $valorTrabalhado += $valorExtras;
                $valorExtras = 0;
                //$valorAusencias = ($valorCalculado * -1);
                $valorAusencias = $valorJornadaTrabalho - $valorTrabalhado;
            }

            // LEONARDOCARVALHO - 02/12/2015 - Subtrai o total de trabalho noturno no trabalho diurno que foi somado acima na condição de AMBOS, para manter a divisão de trabalho no dia
            if ($ambosTrabalho) {
                $calculosSituacaoFrequencia[$idTrabalho]['HORAS'] = $valorTrabalhado - $calculosSituacaoFrequencia[$this->idTrabNot]['HORAS'];
            } else {
                $calculosSituacaoFrequencia[$idTrabalho]['HORAS'] = $valorTrabalhado;
            }

            // LEONARDOCARVALHO - 02/12/2015
            /*$calculosSituacaoFrequencia[$calculosDeAusencias['ATRASO']]['HORAS'] = $valorAusencias;
            $calculosSituacaoFrequencia[$calculosDeAusencias['SAIDA']]['HORAS'] = 0;*/
            $calculosSituacaoFrequencia[self::ATRASOS_DIURNOS]['HORAS']  = $valorAusencias;
            $calculosSituacaoFrequencia[self::SAIDAS_DIURNAS]['HORAS']   = 0;
            $calculosSituacaoFrequencia[self::ATRASOS_NOTURNOS]['HORAS'] = 0;
            $calculosSituacaoFrequencia[self::SAIDAS_NOTURNAS]['HORAS']  = 0;
        }
        else if($valorTrabalhado < $valorJornadaTrabalho) {
            $calculosSituacaoFrequencia[self::ATRASOS_DIURNOS]['HORAS']  = $valorAusencias;
            $calculosSituacaoFrequencia[self::SAIDAS_DIURNAS]['HORAS']   = 0;
            $calculosSituacaoFrequencia[self::ATRASOS_NOTURNOS]['HORAS'] = 0;
            $calculosSituacaoFrequencia[self::SAIDAS_NOTURNAS]['HORAS']  = 0;
        }
        if ($valorTrabalhado > $valorJornadaTrabalho) {
            $valorExtras += $valorTrabalhado - $valorJornadaTrabalho;
            $valorTrabalhado = $valorJornadaTrabalho;

            // LEONARDOCARVALHO - 02/12/2015 - Subtrai o total de trabalho noturno no trabalho diurno que foi somado acima na condição de AMBOS, para manter a divisão de trabalho no dia
            if ($ambosTrabalho) {
                $calculosSituacaoFrequencia[$idTrabalho]['HORAS'] = $valorTrabalhado - $calculosSituacaoFrequencia[$this->idTrabNot]['HORAS'];
            } else {
                $calculosSituacaoFrequencia[$idTrabalho]['HORAS'] = $valorTrabalhado;
            }

            // LEONARDOCARVALHO - 02/12/2015
            /*$calculosSituacaoFrequencia[$calculosDeAusencias['ATRASO']]['HORAS'] = 0;
            $calculosSituacaoFrequencia[$calculosDeAusencias['SAIDA']]['HORAS']  = 0;*/
            $calculosSituacaoFrequencia[self::ATRASOS_DIURNOS]['HORAS']  = 0;
            $calculosSituacaoFrequencia[self::SAIDAS_DIURNAS]['HORAS']   = 0;
            $calculosSituacaoFrequencia[self::ATRASOS_NOTURNOS]['HORAS'] = 0;
            $calculosSituacaoFrequencia[self::SAIDAS_NOTURNAS]['HORAS']  = 0;
        }

        //<editor-fold desc="Recebe o valor de separação de horas extras e divide o valor alterado nos diferentes cálculos">
        $limiteSeparacaoHoraExtra = DateUtil::getHoraFloatDeString($this->qtLimiteSeparacaoHoraExtra/*$this->escalaHistorico->getQthrlimitesephextra()*/);

        $diferenca = ($extrasDiurnas + $extrasNoturnas) - $valorExtras;
        $extrasDiurnas -= $diferenca;
        if($extrasDiurnas < 0) {
            $extrasNoturnas += $extrasDiurnas;
            $extrasDiurnas = 0;
        }

        $indexCalculoExtra = 0; //Horas Diurnas
        if ($extrasDiurnas <= $limiteSeparacaoHoraExtra) {
            $valorReferencia = $extrasDiurnas;
            $valorExcedente = 0;
        } else {
            $valorReferencia = $limiteSeparacaoHoraExtra;
            $valorExcedente = $extrasDiurnas - $limiteSeparacaoHoraExtra;
        }

        $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra]]['HORAS'] = $valorReferencia;
        $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra + 2]]['HORAS'] = $valorExcedente;

        $indexCalculoExtra = 1; //Horas Noturnas
        if ($extrasNoturnas <= $limiteSeparacaoHoraExtra) {
            $valorReferencia = $extrasNoturnas;
            $valorExcedente = 0;
        } else {
            $valorReferencia = $limiteSeparacaoHoraExtra;
            $valorExcedente = $extrasNoturnas - $limiteSeparacaoHoraExtra;
        }        

        // LEONARDOCARVALHO - 02/12/2015 - Descomentado a linha abaixo para setar o novo valor a horas extras EX_NOT_NORMAL_NP_1AS
        // LEONARDOCARVALHO - 12/01/2016 - Comentado novamente por gerar problemas, verificar novamente
        // LEONARDOCARVALHO - 21/01/2016 - Descomentado a linha e adicionada condição para se aplicar somente a plantonistas
        if ($this->horario->getHorarioHistorico()->getIdtipohorario() == self::TURNO) {
            $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra + 2]]['HORAS'] = $extrasNoturnas;
        } else {
            // LEONARDOCARVALHO - 25/05/2016 - Adicionado else, pois mantinha a hora extra noturna quando a mesma era usada para complementar o trabalho
            $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra]]['HORAS'] = round($valorReferencia, 5); // evita problemas com ponto flutuante
            $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra + 2]]['HORAS'] = $valorExcedente;
        }

        /*if ($valorExtras <= $limiteSeparacaoHoraExtra) {
            $valorReferencia = $valorExtras;
            $valorExcedente = 0;
        } else {
            $valorReferencia = $limiteSeparacaoHoraExtra;
            $valorExcedente = $valorExtras - $limiteSeparacaoHoraExtra;
        }

        $indexCalculoExtra = $idTipoHorario == 'DIURNO' ? 0 : 1;
        $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra]]['HORAS'] = $valorReferencia;
        $calculosSituacaoFrequencia[$calculosDeExtras[$indexCalculoExtra + 2]]['HORAS'] = $valorExcedente;*/

        /* Vitor Peixoto 01/07 Gambiarra antes da consideração da divisão de horas noturnas */
        //$calculosSituacaoFrequencia[$this->idExtraNot]['HORAS'] = 0;
        //$calculosSituacaoFrequencia[$this->idExtraNot2]['HORAS'] = 0;
        //</editor-fold>

        foreach ($vetorCalculoSituacoes as $calcSit) {

            //<editor-fold desc="Busca a Associação de Situação de Frequência referente à cada uma das Situações do $vetorCalculoSituacoes">
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                $calculosSituacaoFrequencia[$calcSit]['NRCALCULOSITUFREQ']);

            //Caso não haja associação específica para a organização de trabalho, busca a associação de organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                    $calculosSituacaoFrequencia[$calcSit]['NRCALCULOSITUFREQ']);
            }
            //</editor-fold>

            //<editor-fold desc="Atualiza os Resumos de Situação de Frequência referentes ao $vetorCalculoSituacoes">
            if (is_object($assocSituFreqCalcSit)) {
                $alterou = false;
                /** @var PtoResumositufreq $resumoAtual */
                foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                    if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                        // Se o valor atual da Situação for zero (round para evitar problemas com ponto flutuante)
                        if (round($calculosSituacaoFrequencia[$calcSit]['HORAS'], 5) == 0) {
                            //Remove o Resumo
                            unset($this->resumosSituFreqs[$key]);
                            $alterou = true;
                        } else {
                            $resumoAtual->setQtrefapursitufreq($calculosSituacaoFrequencia[$calcSit]['HORAS']);
                            $alterou = true;
                        }
                        break;
                    }
                }
                if(!$alterou && $calculosSituacaoFrequencia[$calcSit]['HORAS'] != 0) {
                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($programacaoOcorrencia['NRPROGOCOR'],
                                                                         $programacaoOcorrencia['NRMOTIVOOCORFREQ'], null,
                                                                         $assocSituFreqCalcSit->getNrsitufrequencia(),
                                                                         $calculosSituacaoFrequencia[$calcSit]['HORAS']);
                }
            }
            //</editor-fold>

        }

        //Atualiza os cálculos
        $this->calcSituFreq->setCalcSituacoesFreq($calculosSituacaoFrequencia);
    }
    //</editor-fold>

    //<editor-fold desc="Vitor Peixoto 13/08/2015 Cálculo que quita saldos e/ou débitos do banco, tomando as medidas necessárias e zerando-os">
    private function progOcorQuitaDebitoQuitaSaldoQuitaSaldoDebito($programacao, $cdTipoProgOcorrencia) {
        $calculosSituacaoFrequencia = $this->calcSituFreq->getCalcSituacoesFreq(); //Recebe os cálculos referentes ao dia
        $dadosProgramacao = self::retornaDadosProgramacao($programacao); //Retorna os dados da ocorrência

        $situacoesSaldo        = array(); //Array que vai conter as possíveis situações de saldo
        $vetorCalculoSituacoes = array(); //Array que vai conter todas as situações alteradas

        $geraDoSaldoAcrescido = true;   //Booleana que vai definir se a quitação será referente ao saldo acrescido ou não
        $valorSaldosPeriodo   = 0;       //Soma de todos os saldos do banco

        $situacaoPadraoDebito  = self::ATRASOS_DIURNOS;
        // LEONARDOCARVALHO - 22/02/2016 - Altera o resumo de situação de frequência que irá gerar a quitação do crédito acumulado
        //$situacaoPadraoCredito = self::EX_DIA_NORMAL_SEG;
        $situacaoPadraoCredito = self::EX_DIA_CRED_ACUMULADO;

        //<editor-fold desc="Calcula o valor total dos saldos">
            if($geraDoSaldoAcrescido) {
                //Com acrescimo
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SDO_FOLG_ACR_BH_NORM;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SDO_FOLG_ACR_BH_FOLG;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SDO_FOLG_ACR_BH_SAB;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SDO_FOLG_ACR_BH_FER;
            }
            else {
                //Sem acrescimo
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SALDO_FOLGAR_BH_NORM;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SALDO_FOLGAR_BH_FOLG;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SALDO_FOLGAR_BH_SAB;
                $vetorCalculoSituacoes[] = $situacoesSaldo[] = self::SALDO_FOLGAR_BH_FER;
            }

            //Soma os saldos e zera os calculos
            foreach($situacoesSaldo as $situacao) {
                $valorSaldosPeriodo += $calculosSituacaoFrequencia[$situacao]['HORAS'];
                // LEONARDOCARVALHO - 02/12/2015 - Não zerar saldos ao quitar
                //$calculosSituacaoFrequencia[$situacao]['HORAS'] = 0;
            }
        //</editor-fold>

        //Não há necessidade de se quitar saldo inexistente
        if($valorSaldosPeriodo == 0) return;

        //<editor-fold desc="Altera o valor do saldo de acordo com os parâmetros da ocorrência">
            if($valorSaldosPeriodo < $dadosProgramacao['QTREFMIN']) {
                $valorSaldosPeriodo = $dadosProgramacao['QTREFMIN'];
            }
            else if($dadosProgramacao['QTREFMAX'] != 0 && $valorSaldosPeriodo > $dadosProgramacao['QTREFMAX']) {
                $valorSaldosPeriodo = $dadosProgramacao['QTREFMAX'];
            }
            if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                $valorSaldosPeriodo = ($programacao->getVrcoeficienteacrescimo()/100)*($valorSaldosPeriodo);
            }
        //</editor-fold>

        $saldoNegativo = ($valorSaldosPeriodo <= 0);
        if($cdTipoProgOcorrencia == self::QUITA_CRED_ACUMULADO && $valorSaldosPeriodo < 0) {
            return;
        }
        if($cdTipoProgOcorrencia == self::QUITA_DEBITO && $valorSaldosPeriodo > 0) {
            return;
        }

        if($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
            $alterou = false;
            /** @var PtoResumositufreq $currentResum */
            foreach($this->resumosSituFreqs as &$currentResum){
                if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                    if($saldoNegativo) $valorSaldosPeriodo *= -1;
                    $valorSaldosPeriodo += $currentResum->getQtrefapursitufreq();
                    $currentResum->setQtrefapursitufreq($valorSaldosPeriodo);
                    $alterou = true;
                    break;
                }
            }
            if(!$alterou){
                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgramacao['NRPROGOCOR'],
                                                                     $dadosProgramacao['NRMOTIVOOCORFREQ'], null,
                                                                     $programacao->getNrsitufrequencia(),
                                                                     $valorSaldosPeriodo);
            }
            //<editor-fold desc="Busca a Associação de Situação de Frequência referente à Situação de Frequência da programação e altera o cálculo">
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($this->nrorg,
                                                                                        $programacao->getNrsitufrequencia());

            //Caso não haja associação específica para a organização de trabalho, busca a associação de organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrsitufrequencia($nrOrgPadrao,
                                                                                            $programacao->getNrsitufrequencia());
            }
            if(is_object($assocSituFreqCalcSit)) $calcSituFreq[$assocSituFreqCalcSit->getCalculositufreq()->getCdcalculositufreq()]['HORAS'] = $valorSaldosPeriodo;
            //</editor-fold>
        }
        else if($saldoNegativo) {
            $valorSaldosPeriodo *= -1;
            $calculosSituacaoFrequencia[$situacaoPadraoDebito]['HORAS'] += $valorSaldosPeriodo;
            $vetorCalculoSituacoes[] = $situacaoPadraoDebito;
        }
        else {
            $calculosSituacaoFrequencia[$situacaoPadraoCredito]['HORAS'] += $valorSaldosPeriodo;
            $vetorCalculoSituacoes[] = $situacaoPadraoCredito;
        }

        foreach ($vetorCalculoSituacoes as $calcSit) {

            //<editor-fold desc="Busca a Associação de Situação de Frequência referente à cada uma das Situações do $vetorCalculoSituacoes">
            //Primeira busca para a organização trabalho
            /** @var PtoAssocsitufreq $assocSituFreqCalcSit */
            $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                $calculosSituacaoFrequencia[$calcSit]['NRCALCULOSITUFREQ']);

            //Caso não haja associação específica para a organização de trabalho, busca a associação de organização padrão
            if (!is_object($assocSituFreqCalcSit)) {
                $nrOrgPadrao = FPA::getNrorgPadrao();
                $assocSituFreqCalcSit = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                    $calculosSituacaoFrequencia[$calcSit]['NRCALCULOSITUFREQ']);
            }
            //</editor-fold>

            //<editor-fold desc="Atualiza os Resumos de Situação de Frequência referentes ao $vetorCalculoSituacoes">
            if (is_object($assocSituFreqCalcSit)) {
                $alterou = false;
                /** @var PtoResumositufreq $resumoAtual */
                foreach ($this->resumosSituFreqs as $key => &$resumoAtual) {
                    if ($resumoAtual->getNrsitufrequencia() == $assocSituFreqCalcSit->getNrsitufrequencia()) {
                        // Se o valor atual da Situação for zero (round para evitar problemas com ponto flutuante)
                        if (round($calculosSituacaoFrequencia[$calcSit]['HORAS'], 5) == 0) {
                            //Remove o Resumo
                            unset($this->resumosSituFreqs[$key]);
                            $alterou = true;
                        } else {
                            $resumoAtual->setQtrefapursitufreq($calculosSituacaoFrequencia[$calcSit]['HORAS']);
                            $alterou = true;
                        }
                        break;
                    }
                }
                if(!$alterou && $calculosSituacaoFrequencia[$calcSit]['HORAS'] != 0) {
                    $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgramacao['NRPROGOCOR'],
                                                                         $dadosProgramacao['NRMOTIVOOCORFREQ'], null,
                                                                         $assocSituFreqCalcSit->getNrsitufrequencia(),
                                                                         $calculosSituacaoFrequencia[$calcSit]['HORAS']);
                }
            }
            //</editor-fold>

        }

        //Atualiza os cálculos
        $this->calcSituFreq->setCalcSituacoesFreq($calculosSituacaoFrequencia);

    }
    //</editor-fold>

    //<editor-fold desc="Vitor Peixoto 28/10/2015 Comentar antiga implementação quita(Ingrid)">
    /*
        private function progOcorQuita($programacao, $cdTipoProgOcorrencia){
            $calcSituFreq = $this->calcSituFreq->getCalcSituacoesFreq();

            $dadosProgram = self::retornaDadosProgramacao($programacao);

            if($cdTipoProgOcorrencia == self::QUITA_SALDO_OU_DEB){
                if (($this->idHorasFolgarTot > $this->idHorasCompensarTot) && ($this->idHorasCompensarTot != 0)) {
                    /* subtrai horas a compensar proporcionalmente das folgas autorizadas * /
                    /* normal * /
                    $perc = $this->idFolgaAutorizadas[1]* $this->idHorasCompensarTot / $this->idHorasFolgarTot;
                    /* reduz a qtde proporcional calculada * /
                    $this->idFolgaAutorizadas[1] = ($this->idFolgaAutorizadas[1] - $perc);

                    $this->idHorasCompensarTot = 0;
                }
                if (($this->idHorasCompensarTot > $this->idHorasFolgarTot) && ($this->idHorasFolgarTot != 0)) {
                    $this->idHorasCompensarTot = ($this->idHorasCompensarTot-$this->idHorasFolgarTot);
                    $this->idFolgaAutorizadas[1] = 0;
                    $this->idFolgaAutorizadas[2] = 0;
                    $this->idFolgaAutorizadas[3] = 0;
                    $this->idFolgaAutorizadas[4] = 0;
                    $this->idFolgaAutorizadas[5] = 0;
                    $this->idHorasFolgarTot      = 0;
                }
            }

            if($cdTipoProgOcorrencia == self::QUITA_SALDO_OU_DEB ||
                $cdTipoProgOcorrencia == self::QUITA_CRED_ACUMULADO) {

                if($this->idHorasFolgarTot != 0){
                    if($dadosProgram['QTREFMAX'] != 0 && $this->idFolgaAutorizadas[1] > $dadosProgram['QTREFMAX']){
                        $saldoAux = $this->idFolgaAutorizadas[1] - $dadosProgram['QTREFMAX'];
                        $this->idFolgaAutorizadas[1] = $dadosProgram['QTREFMAX'];
                    }
                    elseif($dadosProgram['QTREFMIN'] != 0 && $this->idFolgaAutorizadas[1] < $dadosProgram['QTREFMIN']){
                        $saldoAux = $this->idFolgaAutorizadas[1];
                        $this->idFolgaAutorizadas[1] = 0;
                    }

                    if($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())){
                        /** @var PtoResumositufreq $resumSituFreq * /
                        foreach($this->resumosSituFreqs as $resumSituFreq){
                            if($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()){
                                if($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                                    $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']){
                                    if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                                        $novaQtApurSituFreq = (($programacao->getVrcoeficienteacrescimo()/100)+1)*($resumSituFreq->getQtrefapursitufreq());
                                    }
                                    else{
                                        $novaQtApurSituFreq = $resumSituFreq->getQtrefapursitufreq();
                                    }
                                    //Olhar se caso esteja hora realmente faz nada ou se joga pra cima ou pra baixo
                                    //Olhar se cria um novo resumo com a situação freq ou só coloca a nova nesse msm resumo

                                    $alterou = false;
                                    /** @var PtoResumositufreq $currentResum * /
                                    foreach($this->resumosSituFreqs as &$currentResum){
                                        if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                            $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $novaQtApurSituFreq;
                                            $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                            $alterou = true;
                                            break;
                                        }
                                    }
                                    if(!$alterou){
                                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                             $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                             $programacao->getNrsitufrequencia(),
                                                                                             $novaQtApurSituFreq);
                                    }
                                }
                                break;
                            }
                        }
                    }
                    else{
                        if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                            /* soma a ref na sit_apur cadastrada * /

                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum * /
                            foreach($this->resumosSituFreqs as &$currentResum){
                                if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + min($this->idFolgaAutorizadas[1],
                                            $this->idHorasFolgarTot);
                                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if(!$alterou){
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                     $programacao->getNrsitufrequencia(),
                                                                                     min($this->idFolgaAutorizadas[1],
                                                                                         $this->idHorasFolgarTot));
                            }

                            $soma = false;
                        }
                        else{

                            //Extra Normal
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao * /
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calcSituFreq[self::EX_DIA_NORMAL_1AS]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if(!is_object($assocSituFreqPadrao)){
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calcSituFreq[self::EX_DIA_NORMAL_1AS]['NRCALCULOSITUFREQ']);
                            }

                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum * /
                            foreach($this->resumosSituFreqs as &$currentResum){
                                if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + min($this->idFolgaAutorizadas[1],
                                            $this->idHorasFolgarTot);
                                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if(!$alterou){
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                     $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                     min($this->idFolgaAutorizadas[1],
                                                                                         $this->idHorasFolgarTot));
                            }
                            $soma = true;
                        }

                        //Extra Folga
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao * /
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[self::EX_DIA_FOLGA_1AS]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if(!is_object($assocSituFreqPadrao)){
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[self::EX_DIA_FOLGA_1AS]['NRCALCULOSITUFREQ']);
                        }

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum * /
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                                $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + min($this->idFolgaAutorizadas[2],
                                        $this->idHorasFolgarTot);
                                $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                 $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                 min($this->idFolgaAutorizadas[2],
                                                                                     $this->idHorasFolgarTot));
                        }

                        //Extra Sabado
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao * /
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[self::EX_DIA_SABADO_1AS]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if(!is_object($assocSituFreqPadrao)){
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[self::EX_DIA_SABADO_1AS]['NRCALCULOSITUFREQ']);
                        }

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum * /
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                                $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + min($this->idFolgaAutorizadas[3],
                                        $this->idHorasFolgarTot);
                                $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                 $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                 min($this->idFolgaAutorizadas[3],
                                                                                     $this->idHorasFolgarTot));
                        }

                        //Extra Feriado
                        //Primeira busca para a organização trabalho
                        /** @var PtoAssocsitufreq $assocSituFreqPadrao * /
                        $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                            $calcSituFreq[self::EX_DIA_FERIAD_1AS]['NRCALCULOSITUFREQ']);
                        //Caso não haja associação específica para a organização de trabalho, busca a associação de
                        //organização padrão
                        if(!is_object($assocSituFreqPadrao)){
                            $nrOrgPadrao = FPA::getNrorgPadrao();
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                $calcSituFreq[self::EX_DIA_FERIAD_1AS]['NRCALCULOSITUFREQ']);
                        }

                        $alterou = false;
                        /** @var PtoResumositufreq $currentResum * /
                        foreach($this->resumosSituFreqs as &$currentResum){
                            if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                                $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + min($this->idFolgaAutorizadas[4],
                                        $this->idHorasFolgarTot);
                                $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                $alterou = true;
                                break;
                            }
                        }
                        if(!$alterou){
                            $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                 $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                 $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                 min($this->idFolgaAutorizadas[4],
                                                                                     $this->idHorasFolgarTot));
                        }

                        $this->idFolgaAutorizadas[1] = $saldoAux;
                        $this->idFolgaAutorizadas[2] = 0;
                        $this->idFolgaAutorizadas[3] = 0;
                        $this->idFolgaAutorizadas[4] = 0;
                        $this->idFolgaAutorizadas[5] = 0;
                        $this->idHorasFolgarTot      = $saldoAux;
                    }
                }
            }

            if($cdTipoProgOcorrencia == self::QUITA_SALDO_OU_DEB || $cdTipoProgOcorrencia == self::QUITA_DEBITO) {
                if ($this->idHorasCompensarTot != 0) {
                    $saldoAux = 0;
                    if (($dadosProgram['QTREFMAX'] != 0) && ($this->idHorasCompensarTot > $dadosProgram['QTREFMAX'])) {
                        $saldoAux = $this->idHorasCompensarTot - $dadosProgram['QTREFMAX'];
                        $this->idHorasCompensarTot = $dadosProgram['QTREFMAX'];
                    }
                    if (($dadosProgram['QTREFMIN'] != 0) && ($this->idHorasCompensarTot < $dadosProgram['QTREFMIN'])) {
                        //não tem o mínimo, nao autoriza nada. Saldo é o que tinha
                        $saldoAux = $this->idHorasCompensarTot;
                        $this->idHorasCompensarTot = 0;
                    }

                    /* soma val anterior em atrasos * /
                    /* esta sit deveria ser parametrizada se a escala comp auto atraso * /
                    /* o sistema altera esta sit * /
                    //16/01/04 - Nádia - verifica se informou situacao e trata para atrasos
                    if($programacao->getNrsitufreqgatilho() != "" && !is_null($programacao->getNrsitufreqgatilho())){
                        /** @var PtoResumositufreq $resumSituFreq * /
                        foreach($this->resumosSituFreqs as $resumSituFreq){
                            if($resumSituFreq->getNrsitufrequencia() == $programacao->getNrsitufreqgatilho()){
                                if($resumSituFreq->getQtrefapursitufreq() <= $dadosProgram['QTREFMAXGATILHO'] &&
                                    $resumSituFreq->getQtrefapursitufreq() >= $dadosProgram['QTREFMINGATILHO']){
                                    if($programacao->getVrcoeficienteacrescimo() != '' && !is_null($programacao->getVrcoeficienteacrescimo())){
                                        $novaQtApurSituFreq = (($programacao->getVrcoeficienteacrescimo()/100)+1)*($resumSituFreq->getQtrefapursitufreq());
                                    }
                                    else{
                                        $novaQtApurSituFreq = $resumSituFreq->getQtrefapursitufreq();
                                    }

                                    $alterou = false;
                                    /** @var PtoResumositufreq $currentResum * /
                                    foreach($this->resumosSituFreqs as &$currentResum){
                                        if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                            $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $novaQtApurSituFreq;
                                            $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                            $alterou = true;
                                            break;
                                        }
                                    }
                                    if(!$alterou){
                                        $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                             $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                             $programacao->getNrsitufrequencia(),
                                                                                             $novaQtApurSituFreq);
                                    }
                                }
                                break;
                            }
                        }
                    }
                    else{
                        if ($programacao->getNrsitufrequencia() != "" && !is_null($programacao->getNrsitufrequencia())) {
                            /* soma a ref na sit_apur cadastrada * /
                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum * /
                            foreach($this->resumosSituFreqs as &$currentResum){
                                if($currentResum->getNrsitufrequencia() == $programacao->getNrsitufrequencia()){
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $this->idHorasCompensarTot;
                                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if(!$alterou){
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                     $programacao->getNrsitufrequencia(),
                                                                                     $this->idHorasCompensarTot);
                            }

                            $soma = false;
                        }
                        else{
                            //Primeira busca para a organização trabalho
                            /** @var PtoAssocsitufreq $assocSituFreqPadrao * /
                            $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($this->nrorg,
                                $calcSituFreq[self::ATRASOS_DIURNOS]['NRCALCULOSITUFREQ']);
                            //Caso não haja associação específica para a organização de trabalho, busca a associação de
                            //organização padrão
                            if(!is_object($assocSituFreqPadrao)){
                                $nrOrgPadrao = FPA::getNrorgPadrao();
                                $assocSituFreqPadrao = PtoAssocsitufreq::findOneByNrorgAndNrcalculositufreq($nrOrgPadrao,
                                    $calcSituFreq[self::ATRASOS_DIURNOS]['NRCALCULOSITUFREQ']);
                            }

                            $alterou = false;
                            /** @var PtoResumositufreq $currentResum * /
                            foreach($this->resumosSituFreqs as &$currentResum){
                                if($currentResum->getNrsitufrequencia() == $assocSituFreqPadrao->getNrsitufrequencia()){
                                    $novoQtRefApurSituFreq = $currentResum->getQtrefapursitufreq() + $this->idHorasCompensarTot;
                                    $currentResum->setQtrefapursitufreq($novoQtRefApurSituFreq);
                                    $alterou = true;
                                    break;
                                }
                            }
                            if(!$alterou){
                                $this->resumosSituFreqs[] = self::criaResumoSituFreq($dadosProgram['NRPROGOCOR'],
                                                                                     $dadosProgram['NRMOTIVOOCORFREQ'], null,
                                                                                     $assocSituFreqPadrao->getNrsitufrequencia(),
                                                                                     $this->idHorasCompensarTot);
                            }
                            $soma = true;
                        }
                    }

                    $this->idHorasCompensarTot = $saldoAux;
                }
            }

            $this->calcSituFreq = $calcSituFreq;
        }*/
    //</editor-fold>

    private function criaResumoSituFreq($nrProgOcor     = null, $nrMotivoOcorFreq  = null, $idForcaSituFreq      = null,
                                        $nrSituFreq     = null, $qtRefApurSituFreq = null, $qtRefAbonSituFreq    = null,
                                        $nrSituFreqNova = null, $qtRefApuNovaSituFreq = null,
                                        $dsObserv       = null, $nrLoteLanceevento = null
                                        ){
        $resumoSituFreq = new \Folha\Entities\PtoResumositufreq();
        $resumoSituFreq->setNrorg($this->nrorg);
        $resumoSituFreq->setDsobservacao($dsObserv);
        $resumoSituFreq->setNrprogocorrencia($nrProgOcor);
        $resumoSituFreq->setNrvinculom($this->nrvinculom);
        $resumoSituFreq->setNrsitufrequencia($nrSituFreq);
        $resumoSituFreq->setDtapuracaositufreq($this->data);
        $resumoSituFreq->setNrsitufreqnova($nrSituFreqNova);
        $resumoSituFreq->setIdforcasitufreq($idForcaSituFreq);
        $resumoSituFreq->setNrmotivoocorfreq($nrMotivoOcorFreq);
        $resumoSituFreq->setNrlotelancevento($nrLoteLanceevento);
        $resumoSituFreq->setQtrefabonsitufreq($qtRefAbonSituFreq);
        $resumoSituFreq->setQtrefapursitufreq($qtRefApurSituFreq);
        $resumoSituFreq->setNrperiodoapuracao($this->nrPeriodoApuracao);
        $resumoSituFreq->setQtrefapunovasitufreq($qtRefApuNovaSituFreq);
            
        return $resumoSituFreq;
    }

    private function existeMarcacaoPonto() {

        $where = "NRORG = ?
                  AND NRVINCULOM = ?
                  AND TRUNC(DTHRMARCACAOPONTO) = TO_DATE(?, 'DD/MM/YYYY')";

        $params = array(
            $this->nrorg,
            $this->nrvinculom,
            $this->data->format(DateUtil::FORMATO_BRASILEIRO)
        );

        $marcacoesPonto = GpeMarcacaoponto::getObjectsByWhere($where, $params);

        if (count($marcacoesPonto) != 0)
            return true;
        else
            return false;
    }
}